VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Base64"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
''
' Ce module sert  encoder le contnu d'un fichier en Base64.
'
' (c) Copyright Andrew McMillan <a href="http://www.paradoxes.info/code/">http://www.paradoxes.info/code/</a>
'
' fonctions publiques :
' Base64Encore(FilePath As String) As String

Option Explicit

Private Const Equals As Byte = 61    'Asc("=")

Private Const Mask1 As Byte = 3      '00000011
Private Const Mask2 As Byte = 15     '00001111
Private Const Mask3 As Byte = 63     '00111111
Private Const Mask4 As Byte = 192    '11000000
Private Const Mask5 As Byte = 240    '11110000
Private Const Mask6 As Byte = 252    '11111100

Private Const Shift2 As Byte = 4
Private Const Shift4 As Byte = 16
Private Const Shift6 As Byte = 64

Private Const Base64Lookup As String = _
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"

Private Declare Function GetFileAttributes _
    Lib "kernel32" _
    Alias "GetFileAttributesA" (ByVal lpFileName As String) _
    As Long



'' vrifie que le fichier existe
' @param FilePath chemin et nom du fichier  vrifier
Private Function FileExists(FilePath As String) As Boolean
    Dim r As Long
    r = GetFileAttributes(FilePath)
    If r <> -1 Then
        FileExists = True
    End If
End Function



'' ??
' @param Code la donne binaire
Private Function EnCodeByte(Code As Byte) As Byte
   EnCodeByte = Asc(Mid$(Base64Lookup, Code + 1, 1))
End Function



'' encode le contenu du fichier en BASE64
' @param FilePath chemin et nom du fichier  encoder
Public Function Base64Encode(FilePath As String) As String

    Dim s As String
    Dim EncodedData() As Byte
    Dim l As Long
    Dim m As Long
    Dim Index As Long
    Dim CharCount As Long
    
    If Not FileExists(FilePath) Then
        Exit Function
    End If
   
    Dim Data() As Byte
    Dim FileLength As Long
    Dim fh As Long
    fh = FreeFile
    Open FilePath For Binary As #fh
        FileLength = LOF(fh)
        ReDim Data(FileLength - 1)
        Get #fh, , Data
    Close #fh
   
   MsgBox FileLength
    Dim EncodedLength As Long
    EncodedLength = (FileLength \ 3) * 4
    If FileLength Mod 3 > 0 Then EncodedLength = EncodedLength + 4
    EncodedLength = EncodedLength + ((EncodedLength \ 76) * 2)
    If EncodedLength Mod 78 = 0 Then EncodedLength = EncodedLength - 2
    ReDim EncodedData(EncodedLength - 1)
   
    m = (FileLength) Mod 3
    MsgBox UBound(Data)
    For l = 0 To UBound(Data) - m Step 3
        EncodedData(Index) = EnCodeByte((Data(l) \ Shift2))
        EncodedData(Index + 1) = EnCodeByte(((Data(l) And Mask1) * Shift4) _
            + ((Data(l + 1)) \ Shift4))
        EncodedData(Index + 2) = EnCodeByte(((Data(l + 1) And Mask2) * Shift2) _
            + (Data(l + 2) \ Shift6))
        EncodedData(Index + 3) = EnCodeByte(Data(l + 2) And Mask3)
        Index = Index + 4
        CharCount = CharCount + 4
      
        If CharCount = 76 And Index < EncodedLength Then
            EncodedData(Index) = 13
            EncodedData(Index + 1) = 10
            CharCount = 0
            Index = Index + 2
        End If
    Next
   
    If m = 1 Then
        EncodedData(Index) = EnCodeByte((Data(l) \ Shift2))
        EncodedData(Index + 1) = EnCodeByte((Data(l) And Mask1) * Shift4)
        EncodedData(Index + 2) = Equals
        EncodedData(Index + 3) = Equals
        Index = Index + 4
    ElseIf m = 2 Then
        EncodedData(Index) = EnCodeByte((Data(l) \ Shift2))
        EncodedData(Index + 1) = EnCodeByte(((Data(l) And Mask1) * Shift4) _
            + ((Data(l + 1)) \ Shift4))
        EncodedData(Index + 2) = EnCodeByte((Data(l + 1) And Mask2) * Shift2)
        EncodedData(Index + 3) = Equals
        Index = Index + 4
    End If
   
    Erase Data
   
    Base64Encode = StrConv(EncodedData, vbUnicode)

    Erase EncodedData
   
End Function


Function EncodeBase64(Data() As Byte)

Dim s As String
    Dim EncodedData() As Byte
    Dim l As Long
    Dim m As Long
    Dim Index As Long
    Dim CharCount As Long

Dim EncodedLength As Long
Dim FileLength As Long
    FileLength = UBound(Data) + 1
    
    EncodedLength = (FileLength \ 3) * 4
    If FileLength Mod 3 > 0 Then EncodedLength = EncodedLength + 4
    EncodedLength = EncodedLength + ((EncodedLength \ 76) * 2)
    If EncodedLength Mod 78 = 0 Then EncodedLength = EncodedLength - 2
    ReDim EncodedData(EncodedLength - 1)
   
    m = (FileLength) Mod 3

    For l = 0 To UBound(Data) - m Step 3
        EncodedData(Index) = EnCodeByte((Data(l) \ Shift2))
        EncodedData(Index + 1) = EnCodeByte(((Data(l) And Mask1) * Shift4) _
            + ((Data(l + 1)) \ Shift4))
        EncodedData(Index + 2) = EnCodeByte(((Data(l + 1) And Mask2) * Shift2) _
            + (Data(l + 2) \ Shift6))
        EncodedData(Index + 3) = EnCodeByte(Data(l + 2) And Mask3)
        Index = Index + 4
        CharCount = CharCount + 4
      
        If CharCount = 76 And Index < EncodedLength Then
            EncodedData(Index) = 13
            EncodedData(Index + 1) = 10
            CharCount = 0
            Index = Index + 2
        End If
    Next
   
    If m = 1 Then
        EncodedData(Index) = EnCodeByte((Data(l) \ Shift2))
        EncodedData(Index + 1) = EnCodeByte((Data(l) And Mask1) * Shift4)
        EncodedData(Index + 2) = Equals
        EncodedData(Index + 3) = Equals
        Index = Index + 4
    ElseIf m = 2 Then
        EncodedData(Index) = EnCodeByte((Data(l) \ Shift2))
        EncodedData(Index + 1) = EnCodeByte(((Data(l) And Mask1) * Shift4) _
            + ((Data(l + 1)) \ Shift4))
        EncodedData(Index + 2) = EnCodeByte((Data(l + 1) And Mask2) * Shift2)
        EncodedData(Index + 3) = Equals
        Index = Index + 4
    End If
   
    Erase Data
   
    EncodeBase64 = StrConv(EncodedData, vbUnicode)

    Erase EncodedData
   
End Function


