/*
Copyright (C) 2004 ATEXO Local Trust MPE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For more information on our product, please contact MPE@atexo.com
*/
<?php

require_once 'format.inc.php';


/** traite le formulaire d'inscription de l'entreprise
 * <ul>
 * <li>gestion des erreurs</li>
 * <li>remplissage du ARRAY $form_vars</li>
 * </ul>
 * @ingroup company_fct
 */
function add_co_desc()
{
  $form_vars = array();
  if (!$_POST['nom'] || !$_POST['adresse'] || !$_POST['ayantDroitEngagement'] || !$_POST['enFrance'])
    {
      PrintError("Formulaire incomplet (nom, adresse, ayantDroit, pays d'implantation) " . $_POST['enFrance']);
      return;
    }
  $form_vars['nom'] = $_POST['nom'];
  $form_vars['adresse'] = $_POST['adresse'];
  $form_vars['ayantDroitEngagement'] = $_POST['ayantDroitEngagement'];

  // Si les champs services sont vides, ils prennent comme valeur les champs de la socit
  if ($_POST['nomService'])
    $form_vars['nomService'] = $_POST['nomService'];
  else
    $form_vars['nomService'] = $_POST['nom'];

  if ($_POST['adresseService'])
    $form_vars['adresseService'] = $_POST['adresseService'];
  else
    $form_vars['adresseService'] = $_POST['adresse'];
  

  if ($_POST['enFrance'] == '1')
    {
      if (!$_POST['villeEnregistrement1'] || !$_POST['repMetiers'])
      {
	PrintError("Formulaire incomplet; elements manquants pour candidat tabli en France");
	return;
      }
      $form_vars['paysEnregistrement'] = 'FR';
      $form_vars['villeEnregistrement'] = $_POST['villeEnregistrement1'];
      $form_vars['repMetiers'] = $_POST['repMetiers'];
      
      if ($_POST['siren']) {
    	$form_vars['siren'] = $_POST['siren'];
    }
    }

  if ($_POST['enFrance'] == '2')
    {
      if(!$_POST['villeEnregistrement2'] || !$_POST['paysEnregistrement1'])
	{
	  PrintError("Formulaire incomplet; elements manquants pour candidat non établi en France");
	  return;
	}
      $form_vars['paysEnregistrement'] = $_POST['paysEnregistrement1'];
      $form_vars['villeEnregistrement'] = $_POST['villeEnregistrement2'];

      if ($_POST['sirenEtranger'])
	$form_vars['sirenEtranger'] = $_POST['sirenEtranger'];
    }
  
  if (!$_POST['siren'] && !$_POST['sirenEtranger'])
    {
      if (!$_POST['motifNonIndNum'])
	{
	  PrintError("Formulaire incomplet; pas de numéro identifiant ni de motif de non indication");
	  return;
	}
      $form_vars['motifNonIndNum'] = $_POST['motifNonIndNum'];

      if ($_POST['motifNonIndNum'] == '1')
	{
	  if (!$_POST['ordreProfOuAgrement'])
	    {
	      PrintError("Formulaire incomplet; motif de non indication fourni mais pas de rfrences");
	      return;
	    }
	  $form_vars['ordreProfOuAgrement'] = $_POST['ordreProfOuAgrement'];
	}
      else if ($_POST['motifNonIndNum'] == '3')
	{
	  if (!$_POST['dateConstSociete'] || !$_POST['orgInsription'])
	    {
	      PrintError("Formulaire incomplet; motif de non indication fourni mais pas de références");
	      return;
	    }
	  $form_vars['dateConstSociete'] = $_POST['dateConstSociete'];
	  $form_vars['orgInsription'] = $_POST['orgInsription'];
	}
      else if ($_POST['motifNonIndNum'] == '4')
	{
	  if (!$_POST['dateConstAssoc'])
	    {
	      PrintError("Formulaire incomplet; motif de non indication fourni mais pas de rfrences");
	      return;
	    }
	  $form_vars['dateConstAssoc'] = $_POST['dateConstAssoc'];
	}
      else if($_POST['motifNonIndNum'] == '5')
	{
	  if (!$_POST['dateConstAssocEtrangere'])
	    {
	      PrintError("Formulaire incomplet; motif de non indication fourni mais pas de rfrences");
	      return;
	    }
	  $form_vars['dateConstAssocEtrangere'] = $_POST['dateConstAssocEtrangere'];
	}
    }

  if (!$_POST['formeJuridique'])
    {
      PrintError("Formulaire incomplet; formeJuridique");
      return;
    }
  $form_vars['formeJuridique'] = $_POST['formeJuridique'];
  
  /*
  foreach ($form_vars as $key => $value)
    {
      printf("%s = %s<br>", $key, $value);
    }
    */
  
} // END add_co_desc()


?>
