/*
Copyright (C) 2004 ATEXO Local Trust MPE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For more information on our product, please contact MPE@atexo.com
*/
<?php
require 'config.inc.php';
require_once       'sql.inc.php';
require_once 'sqlRights.inc.php';
require_once     'mysql.inc.php';
require_once    'format.inc.php';
require_once 'crypto.inc.php';
require_once 'mail.inc.php';
require_once 'misc.inc.php';

session_name('administrateur');
session_start();
header('Cache-control: private, no-cache'); # HTTP 1.1
header('Expires: Mon, 25 Feb 2002 01:00:00 GMT'); # HTTP 1.0
header('Pragma: no-cache'); # HTTP 1.0

define ('DEFAULT_CMD', 'show_admin_mainpage');

/** @defgroup administrateur Administrateur */
/** @defgroup admin_auth Authentification de l'administrateur
 * @ingroup  administrateur
 */


/** affiche la page d'accueil des administrateurs techniques
 * @ingroup administrateur
 * @param $_isAuthenticated
 * @return void
 */
function show_admin_mainpage($_isAuthenticated)
{
    if ($_isAuthenticated) {
        echo "<pre>";print_r($_SESSION);echo "</pre>"; return;
        //echo 'Bonjour '.$_SESSION[];
    } else {
        echo "<h1>Marchs publics lectroniques</h1><p>Partie rserve aux
        administrateurs</p><br /><br /><br /><br /><br /><br />";
    } // END if then else
}




/** affiche le formulaire d'authentification par login/mdp
 * @ingroup admin_auth
 * @return void
 */
function show_authentication_form()
{	?>
 <h1>Gestion des marchs publics lectroniques</h1>
    <h2>Accs Administrateur : gestion des consultations et des offres</h2>
	<p>Veuillez vous authentifier</p>
    <table summary="credentials">
    <tr>
    <td>Identifiant</td>
    <td><input type="text" id="login" name="login"/><td>
    </tr>
    <tr>
    <td>Mot de passe</td>
    <td><input type="password" id="mdp" name="mdp"/></td>
    </tr>
    </table>
    <input type="submit" name="Valider" value="Valider" onClick="javascript:ActivateMenu2('administrateur_logon')"/>
    <script type="text/javascript"><!--
        document.main_form.login.focus();
    //--></script>
     <?php
}




/** compare le login/mdp avec la table Administrateur et set les variables de session
 * @ingroup admin_auth
 * 
 * @return true si authentifi, false sinon
 */
function check_administrateur_login_pwd()
{
  // on rinitialise la session administrateur
  $_SESSION['sess_administrateur_logged'] = 0;
  
  // tests d'authentification
  if(!$_POST['login'] || !$_POST['mdp'])
    {
      PrintMessage("Formulaire d'identification incomplet.");
      show_authentication_form();
      return false;
    } // END if

  $admin_array=passwd_match(ADMINISTRATEUR,$_POST['login'], $_POST['mdp']);
  if($admin_array==array())
    {
     if (field_exists(ADMINISTRATEUR,'login', $_POST['login']))
       {
	 $non_auth_admin = get_row_by_field (ADMINISTRATEUR,'login', $_POST['login']);
	 if ($non_auth_admin['tentatives_mdp'] >= MAX_TENTATIVES_MDP)
	   {
	     PrintMessage ("Ce compte est d&eacute;sactiv&eacute;. Veuillez contacter l'administrateur de la plate-forme.");
	     show_authentication_form ();
	     return;
	   }
	 else
	   {
	     increase_tentatives_mdp(ADMINISTRATEUR,'login',$_POST['login']);
	   }
       }
      PrintMessage("Identifiant ou mot de passe incorrect.");
      show_authentication_form();
      return false;
    } // END if
  if ($admin_array['tentatives_mdp'] >= MAX_TENTATIVES_MDP)
   {
     PrintMessage("Ce compte est d&eacute;sactiv&eacute;. Veuillez contacter votre administrateur.");
     show_authentication_form();
     return false;
   }
 else if ($admin_array['tentatives_mdp'] > 0)
   {
     init_tentatives_mdp(ADMINISTRATEUR,'id', $admin_array['id']);
   }
    
  // l'utilisateur est authentifi, on cre sa session
  $_SESSION['sess_administrateur_profile']=$admin_array;
  $_SESSION['sess_administrateur_logged']=1;
  return true;
}

/** authentifie l'administrateur et ractualise la page en appelant la mthode show_admin_auth_mainpage
 * @ingroup admin_auth
 * 
 * @return void
 */
function administrateur_logon()
{
  if (check_administrateur_login_pwd())
    {
    ?>
  <script Language="JavaScript">
     if (document.all)
       {
	 document.all.main_form.cmd.value='show_admin_auth_mainpage';   
	 document.all.main_form.submit();
       }
     else
       {
	 document.main_form.cmd.value='show_admin_auth_mainpage';   
	 document.main_form.submit();
       }
</script>
<?
    }
}


/** affiche la page de garde de l'administrateur authentifi
 * @ingroup admin_auth
 * @return void
 */
function show_admin_auth_mainpage()
{
    if (!$_SESSION['sess_administrateur_logged']) {
        PrintMessage("Vous n'tes pas authentifi");
        show_authentication_form();
        return;
    }

    echo "<h1>Marchs publics lectroniques</h1>";
    echo "<p>Bonjour ".$_SESSION['sess_administrateur_profile']['prenom'].' '
        .$_SESSION['sess_administrateur_profile']['nom'].'</p>';

    ?>
    <p>
        Vous tes authentifi en tant qu'administrateur du portail de gestion
        des marchs publics lectroniques.
    </p>
    
    <?php
}

/** Affiche le formulaire d'inscription d'un interne par l'admin
 * @ingroup admin_auth
 * @return void
 */
function show_interne_insc_form()
{
  if (!$_SESSION['sess_administrateur_logged']) {
    PrintMessage("Vous n'tes pas authentifi");
    show_authentication_form();
    return;
  }
   show_interne_insc_form2(NULL, CREATION_INTERNE); // Dans misc.inc.php
}  //END function show_interne_insc_form()

/** Affiche le formulaire de modif de passwd pour l'admin
 *
 *
 */
    function show_admin_passwd_form()
      {
	if (!$_SESSION['sess_administrateur_logged']) 
	  {
	    PrintMessage("Vous n'tes pas authentifi");
	    show_authentication_form();
	    return;
	  }
	echo "<h1>Modification des donn&eacute;es du compte administrateur</h1>";
	include 'admin_passwd_form_template.php';
?>
<input type="button" name="modifier" value="Modifier" onClick="javascript:ActivateMenu('update_admin_passwd')" />
<input type="button" name="Annuler" value="Annuler" onClick="javascript:ActivateMenu('show_admin_auth_mainpage')" />
<?
      }

    /** Verifie puis change le passwd de l'admin
     *
     *
     */
    function update_admin_passwd()
      {
	if (!$_SESSION['sess_administrateur_logged']) 
	  {
	    PrintMessage("Vous n'tes pas authentifi");
	    show_authentication_form();
	    return;
	  }

	if (!$_SESSION['sess_administrateur_profile']) 
	  {
	    echo "V&ocirc;tre session &agrave; &eacute;t&eacute; ferm&eacute;e";
	    show_authentication_form();
	    return;
	  }

	$update_admin_form_vars = array();
	if (!$_POST["login"])
	{
	  PrintMessage("Formulaire incomplet (champs login manquant)");
	  show_authentication_form();
	  return;
	}
      
	if (($_POST["login"] != $_SESSION['sess_administrateur_profile']["login"]) && field_exists('Administrateur', 'login', $_POST["login"], $_POST["login"]))
	{
	  PrintMessage("Cet identifiant existe d&eacute;j&agrave;. Choisissez-en un autre");
	  show_authentication_form();
	  return;
	}
  
      $update_admin_form_vars["login"] = $_POST["login"];


	if (!$_POST["mdp1"]||!$_POST["mdp2"])
	  {
	    PrintMessage("Formulaire incomplet (champs mot de passe  manquant)");
	    show_admin_passwd_form();
	    return;
	  }
  
	if (strcmp($_POST["mdp1"], $_POST["mdp2"]) != 0)
	  {
	    PrintMessage("Les deux mots de passe sont diff&eacute;rents");
	    show_admin_passwd_form();
	    return;
	  }
  
	$update_admin_form_vars["mdp"] = $_POST["mdp1"];

	$update_admin_query = "UPDATE Administrateur SET login='".$update_admin_form_vars["login"]."', mdp=PASSWORD('".$update_admin_form_vars["mdp"]."') WHERE id = " . $_SESSION['sess_administrateur_profile']["id"];


	$result = sql_query($update_admin_query);

	if(!$result)
	  {
	    PrintMessage("Impossible de modifier le mot de passe");
	    return;
	  }
	/*--On recharge le nouveau profile en session--*/
	$_SESSION['sess_administrateur_profile'] = get_row_by_field('Administrateur', 'id', $_SESSION['sess_administrateur_profile']['id']);
    echo "<h1>Modification des donn&eacute;es du compte administrateur</h1>";
    echo "<p>Votre compte a &eacute;t&eacute; modifi&eacute; avec succ&egrave;s</p>";
?>
<br /><br /><a href="javascript:ActivateMenu('show_admin_auth_mainpage')">Retour &agrave; la page d'accueil</a>
<?
	
      }

/** recupre les consultations non valides
 * @ingroup administrateur
 * @param $order_by champ de la table utilis pour le tri
 * @return SQL_RESPONSE
 */
function sql_get_new_cons($order_by = null)
{
    $query = "SELECT fichierDossier, reference, titre, dateDebut, dateFin, categorie, resume FROM ".CONSULTATION." WHERE etat='0'";
    if ($order_by) {
        $query .= " ORDER BY $order_by";
    }
    return sql_query($query);
} // END function sql_get_new_cons($order_by = null)


/**
 * @ingroup administrateur
 *
 */
function list_new_cons()
{
    if (!$_SESSION['sess_administrateur_logged']) {
        PrintMessage("Vous n'tes pas authentifi");
        show_authentication_form();
        return;
    }
    $new_cons = sql_get_new_cons($_POST['order_by_field']);
   
    echo "<h1>Consultations en attente de validation.</h1>";
    
    $num_rows = mysql_num_rows($new_cons);
    
    if ($num_rows==0) {
        echo "<b>Il n'y a aucune consultation en attente de validation</b><br /><br />";
	return;
    }
    
?>
    <input type="hidden" name="order_by_field" value="">
    <input type="hidden" name="cons_ref" value="">
    <input type="hidden" name="cons_ref_env" value="">
    <table border="1" width="100%" cellspacing="0">
        <thead>
            <tr>
                <th><strong><a href="javascript:ReplayWithOrder('list_new_cons', 'reference')">Ref.</a></strong></th>
                <th><strong><a href="javascript:ReplayWithOrder('list_new_cons', 'categorie')">Categorie</a></strong></th>
                <th><strong><a href="javascript:ReplayWithOrder('list_new_cons', 'dateDebut')">Envoi au J.O.</a></strong></th>
                <th><strong><a href="javascript:ReplayWithOrder('list_new_cons', 'dateFin')">Date et heure<br/> de clture</a></strong></th>
                <th><strong>Emis par</strong></th>
                <th><strong>T&eacute;l&eacute;chargement</strong></th>
                <th colspan="2">Action</th>
            </tr>
        </thead>
        <tbody><?php
            while ($consultation = mysql_fetch_array($new_cons, MYSQL_ASSOC)) {
      echo "\n<tr>"
      ."\t<td>".stripslashes($consultation['reference']).'</td>'
      ."\t<td>".str_replace(BLANK_SEPARATOR, ' ', $consultation['categorie']).'</td>'
      ."\t<td>".iso2frnDate($consultation['dateDebut']).'</td>'
      ."\t<td>".iso2frnDateTime($consultation['dateFin']).'</td>'
      ."\t<td><a href=\"mailto:".get_publisher_email($consultation['reference'])."\">".get_publisher_name($consultation['reference']).'</a></td>'
      ."\t<td><a href=\"javascript:DownloadConsFile('".$consultation['reference']."');\">T&eacute;l&eacute;charger</a></td>"
      // ."\t<td><a href=\"javascript:ValidateCons('".$consultation['reference']."');\">Valider</a></td>"
      ."\t<td><a href=\"javascript:ValidateCons2('1','".$consultation['reference']."');\">Valider</a></td>"
      ."\t<td><a href=\"javascript:DeleteCons('".$consultation['reference']."');\">Refuser</a></td>"
      ."</tr>";
            } // END while
    echo "\n</tbody></table>";
} // END function list_new_cons()

/** Demande a l'admin si il veut reellement supprimer la cons en attente de validation
 *  
 *
 */
Function delete_waiting_cons()
{
  if (!$_SESSION['sess_administrateur_logged'])
    {
      PrintMessage("Vous n'tes pas authentifi");
      show_authentication_form();
      return;
    }

  if(!$_POST['cons_ref'])
    {
      PrintMessage("Impossible de recuperer la reference pour la suppression");
      return;
    }

  $ref = $_POST['cons_ref'];
  echo "<h1>Suppression de consultation</h1>";
  echo "Etes-vous certain de vouloir supprimer la consultation r&eacute;f&eacute;renc&eacute;e <em><b>".stripslashes($ref)."</b></em> ?<br/><br/>";
  /*--Recuperation des infos concernant le createur de la consultation--*/
  $publisher_id = get_publisher_id($ref);
  
  $email_query = "SELECT email FROM Interne WHERE id='".$publisher_id."'";
  $email_resp = sql_query($email_query);
  
  if(!$email_resp)
    {
      PrintMessage("imlpossible de recuperer l'email du createur");
      return;
    }

  $row = mysql_fetch_array($email_resp, MYSQL_ASSOC);
  $publisher_email = $row['email'];

  $mail_body = "Bonjour,\n\nNous vous informons que la consultation \"".stripslashes($ref)."\" que vous avez publie, a t refuse par l'administrateur.".MAIL_SIG;
?>
<input type="checkbox" name="mail_publisher" value="1" CHECKED>Envoi d'un Email au cr&eacute;ateur de la consultation
<br/><br/>
<fieldset>
		<legend><strong>Envoi d'email au cr&eacute;ateur de la consultation <em><?echo stripslashes($ref);?></em></strong></legend>
	<table summary="">
	<tr>
		<td><label>Destinataire</label> :</td>	
		<td>
			<input value="<? echo $publisher_email;?>"
				name="to" size="96" />
		</td>
	</tr>
	
	<tr>
		<td><label>Objet</label> :</td>
		<td>
			<input type="text" name="subject" size="96"
				value="Refus de la consultation <?echo stripslashes($ref);?>" />
		</td>
	</tr>
	<tr>
		<td><label>Message</label> : </td>
		<td><textarea  name="corps" rows="10" cols="72"><?echo $mail_body;?></textarea></td>
	</tr>
	</table>
	<p><input type="button" value="Confirmer" name="confirmer" onClick="javascript:ActivateMenu('do_delete_waiting_cons')">
<input type="button" value="Annuler" name="annuler" onClick="javascript:ActivateMenu('list_new_cons')"></p>
</fieldset>

<?
 echo "<input type=\"hidden\" name=\"cons_ref\" value=\"".$ref."\"/>";
    /*echo "<input type=\"button\" name=\"yes\" value=\"Oui\" onClick=\"javascript:ActivateMenu('do_delete_waiting_cons')\"/>";
  echo "<input type=\"button\" name=\"no\" value=\"Non\" onClick=\"javascript:ActivateMenu('list_new_cons')\"/>";
  echo "<input type=\"hidden\" name=\"cons_ref\" value=\"".$ref."\"/>";*/
}

/** Supprime la cons en attente de validation
 *  
 *
 */
Function do_delete_waiting_cons()
{
  if (!$_SESSION['sess_administrateur_logged'])
    {
      PrintMessage("Vous n'tes pas authentifi");
      show_authentication_form();
      return;
    }


  if(!$_POST['cons_ref'])
    {
      PrintMessage("Impossible de recuperer la reference pour la suppression");
      return;
    }

  $ref = $_POST['cons_ref'];
  $del_query = "DELETE FROM Consultation WHERE reference='".$ref."'";
  $del_resp = sql_query($del_query);

  if(!$del_resp)
    {
      PrintMessage("Probleme lors de la suppression de la consultation ".stripslashes($ref));
      return;
    }
  echo "<h1>Suppression de consultation</h1>";
  echo "<p>La consultation <em><b>".stripslashes($ref)."</b></em> a &eacute;t&eacute; supprim&eacute;e avec succ&egrave;s.</p>" ;

  /*--On verifie si on doit envoyer une email ou non--*/
  if($_POST['mail_publisher']==1)
    {
      
      $mail_address = $_POST['to'];
      $mail_subject = stripslashes($_POST['subject']);
      $message = stripslashes($_POST['corps']);

      $send = send_signed_mail($mail_address, $mail_subject, $message);
      if($send != 0)
       {
	 PrintMessage("Probleme d'envoi de mail. add  ".$mail_address." sub ".$mail_subject." mail ".$message);
	 return;
       }
      echo "<p>Un mail &agrave; &eacute;t&eacute; envoy&eacute; au cr&eacute;ateur de cette consultation.</p>";
    }


  echo "<a href=\"javascript:ActivateMenu('show_admin_auth_mainpage');\">Retour &agrave; la page d'accueil</a>";


}

/** Renvoi l'id de la personne
 *  ayant publie la consultation $_ref
 *
 */
Function get_publisher_id($_ref)
{
  /*----------Recuperation de l'id du createur dans Interne_Consultation---------*/
  $query = "SELECT interne_id FROM Interne_Consultation WHERE consultation_ref='".addslashes($_ref)."' AND droit='3'";
  $resp = sql_query($query);
  if(!$resp)
    {
      PrintMessage("Impossible de recuperer l'id de l'emetteur");
      return;
    }
  else
    {
      $publisher = mysql_fetch_array($resp, MYSQL_ASSOC);
      $id_publisher = $publisher['interne_id'];
    }

  mysql_free_result($resp);

  return $id_publisher;

}


/** Renvoi le nom (nom+prenom) sous forme d'une string, de la personne
 *  ayant publie la consultation $_ref
 *
 */
Function get_publisher_name($_ref)
{
  /*----------Recuperation de l'id du createur dans Interne_Consultation---------*/

  $id_publisher = get_publisher_id($_ref);
  $publisher=array();

  /*----------Recuperation des noms et prenoms du createur dans Interne---------*/

  $query = "SELECT nom, prenom FROM Interne WHERE id='".$id_publisher."'";
  $resp = sql_query($query);
  if(!$resp)
    {
      PrintMessage("Impossible de recuperer le nom de l'emetteur");
      return;
    }
  else
    {
      $publisher = mysql_fetch_array($resp, MYSQL_ASSOC);
      $publisher_name = $publisher['nom']." ".$publisher['prenom'];
    }

  mysql_free_result($resp);

  return $publisher_name;

}

/** Renvoi l'email sous forme d'une string, de la personne
 *  ayant publie la consultation $_ref
 *
 */
Function get_publisher_email($_ref)
{
  /*----------Recuperation de l'id du createur dans Interne_Consultation---------*/

  $id_publisher = get_publisher_id($_ref);
  $publisher=array();

  /*----------Recuperation des noms et prenoms du createur dans Interne---------*/

  $query = "SELECT email FROM Interne WHERE id='".$id_publisher."'";
  $resp = sql_query($query);
  if(!$resp)
    {
      PrintMessage("Impossible de recuperer l'email de l'emetteur");
      return;
    }
  else
    {
      $publisher = mysql_fetch_array($resp, MYSQL_ASSOC);
      $publisher_mail = $publisher['email'];
    }

  mysql_free_result($resp);

  return $publisher_mail;

}

/** Affiche les enveloppes ayant ete refusees et en attente de suppression
 *
 *
 */
Function list_denied_env()
{
  if (!$_SESSION['sess_administrateur_logged']) {
        PrintMessage("Vous n'tes pas authentifi");
        show_authentication_form();
        return;
    }
  
  $denied_query = "SELECT id, consultation_id, entreprise_id FROM Offre WHERE supprime='1'";
  if($_POST['order_by_field']!="")
    $denied_query.=" ORDER BY ".$_POST['order_by_field'];

  $denied_resp = sql_query($denied_query);

  $num_denied = mysql_num_rows($denied_resp);
  
  echo "<h1>Enveloppes en attente de suppression</h1>";

  if($num_denied==0)
    {
      echo "<b>Il n'existe aucune enveloppe en attente de suppression. </b><br/><br />";
      return;
    }

  ?>

   Voici les offres pour lesquelles l'enveloppe num&eacute;ro 2 a &eacute;t&eacute; refus&eacute;e:<br /><br />
<input type="hidden" name="order_by_field" value=""/>
<input type="hidden" name="id_offre" value=""/>

    <table width="100%" border="1" cellspaning="10">
<thead>
            <tr>
                <th><strong><a href="javascript:ReplayWithOrder('list_denied_env', 'id')">Offre n</a></strong></th>
                <th><strong><a href="javascript:ReplayWithOrder('list_denied_env', 'consultation_id')">Consultation</a></strong></th>
                <th><strong><a href="javascript:ReplayWithOrder('list_denied_env', 'entreprise_id')">Entreprise</a></strong></th>
                <th colspan="2"><strong>Enveloppe</strong></th>
            </tr>
        </thead>
        <tbody><?php
 
      while ($offre = mysql_fetch_array($denied_resp, MYSQL_ASSOC)) {

	//Recuperation de l'entreprise
	$corp_query = "SELECT nom FROM Entreprise WHERE id='".$offre['entreprise_id']."'";
	$corp_resp = sql_query($corp_query);
	if(!$corp_resp)
	  {
	    PrintMessage("Impossible de recuperer le nom de l'entreprise");
	    return;
	  }
	$corp = mysql_fetch_array($corp_resp, MYSQL_ASSOC);
	echo "\n<tr>"
	  ."\t<td align=\"center\">".$offre['id'].'</td>'          
	  ."\t<td align=\"center\">".$offre['consultation_id'].'</td>'
	  ."\t<td align=\"center\">".$corp['nom'].'</td>'
	  ."\t<td align=\"center\"><a href=\"javascript:DeleteEnv(".$offre['id'].")\">Supprimer</a></td><td align=\"center\"><a href=\"javascript:RestoreEnv(".$offre['id'].")\">Restaurer</a></td></tr>";
      } // END while
      echo "\n</tbody></table>";
}



/** Supprime l'enveloppe 2 de l'offre id_offre
 *
 *
 */
Function do_delete_enveloppe()
{
  if (!$_SESSION['sess_administrateur_logged'])
    {
      PrintMessage("Vous n'tes pas authentifi");
      show_authentication_form();
      return;
    }

if(!$_POST['id_offre'])
{
  PrintMessage("Impossible de recuperer l'id de l'offre");
  return; 
}
     $resp=sql_query("SELECT consultation_id, mailSignataire FROM Offre WHERE id = '".$_POST['id_offre']."'");
 $del_query = "UPDATE Offre SET enveloppe_2='', supprime='2' WHERE id = '".$_POST['id_offre']."'";
 $del_resp = sql_query($del_query);

 if($del_resp)
   {

     $mail_signataire = mysql_fetch_array($resp, MYSQL_ASSOC);
     $ref = $mail_signataire['consultation_id'];
     $mail_address = $mail_signataire['mailSignataire'];
     $mail_subject = "Suppression enveloppe 2";
     $message = "Content-Type: text/plain; charset=iso-8859-1"
  ."\nContent-Disposition: inline"
  ."\nContent-Transfer-Encoding: 8bit"
  ."\n\Madame, Monsieur,\n\nNous vous informons que la seconde enveloppe de votre offre en rponse  la consultation rference '$ref' a t supprime. \n\nNous vous remercions de votre intrt pour cette consultation.".MAIL_SIG;;

     $send = send_signed_mail($mail_address, $mail_subject, $message);
     if($send != 0)
       {
	 PrintMessage("Probleme d'envoi de mail. add  ".$mail_address." sub ".$mail_subject." mail ".$message);
	 return;
       }
     ?>
<h1>Enveloppes en attente de suppression</h1>
L'enveloppe a &eacute;t&eacute; supprim&eacute;e avec succ&egrave;s.<br /><br />Le sousmissionnaire de cette offre a &eacutet&eacute; inform&eacute; par mail de la suppression de l'enveloppe.
   <br/><br/><a href="javascript:ActivateMenu('list_denied_env');">Retour</a>
<?php
     return;
   }

}

/** Restaure l'enveloppe 2 de l'offre id_offre
 *
 *
 */
Function restore_enveloppe()
{
  if (!$_SESSION['sess_administrateur_logged'])
    {
      PrintMessage("Vous n'tes pas authentifi");
      show_authentication_form();
      return;
    }

if(!$_POST['id_offre'])
{
  PrintMessage("Impossible de recuperer l'id de l'offre");
  return; 
}

 $restore_query = "UPDATE Offre SET supprime='0' WHERE id = '".$_POST['id_offre']."'";
 $restore_resp = sql_query($restore_query);

 if($restore_resp)
   {
     
     ?>
<h2>Enveloppes en attente de suppression</h2>
La deuxi&egrave;me enveloppe de l'offre num&eacute;ro <?echo $_POST['id_offre'];?> a &eacute;t&eacute; restaur&eacute;e avec succ&egrave;s.<br /><br />
	<a href="javascript:ActivateMenu('list_denied_env');">Retour</a>

<?php
     return;
   }

}

/** affiche la page de validation de la consultation slectionne 
 * @ingroup administrateur
 * @return void
 */
function validate_cons()
{
  if (!$_SESSION['sess_administrateur_logged'])
    {
      PrintMessage("Vous n'tes pas authentifi");
      show_authentication_form();
      return;
    }
  
  include 'gen_req.vbs';
  
  if (!$_POST['cons_ref']) {
      PrintError("Erreur interne: Rfrence de la consultation introuvable");
      return;
    }
  ?>
      <input type="hidden" name="cons_ref" value="<? echo $_POST['cons_ref']; ?>">
      <h2>Validation de la consultation</h2>

	 Vous tes sur le point de valider la consultation rfrence <strong><? echo stripslashes($_POST['cons_ref']); ?></strong>.<br /><br />
	 Ceci se traduira par :
	   <ol>
                <li> La gnration d\'un bi-cl pour cette consultation </li>
                <li> La publication de cette consultation </li><br /><br />
           </ol>

<input type="hidden" name="pkcs10_req" value="" />
<input type="hidden" name="reqkeysize" value="" />

<input type="hidden" name="keysize" id="keysize" value="1024" />
<input type="hidden" name="storeflags" id="storeflags" value="" />
CSP : <select name="lbCSP" onChange="handleCSPChange()" language="VBSCRIPT">
<option id="locLoading" selected>Chargement...</option>
</select>
<input type="hidden" name="keyusage" value="both" />


<!--
<input type="checkbox" name="protectkey" value="protectkey" checked>
<em>Adds additional security options to private key storage.</em>


Certificate store type: 
<select name=storetype>
<option value="current-user"> current user
<option value="local-machine"> local machine (for Windows IPSec and L2TP)
</select>
-->
        <br /><br />
         <input type="button" name="valider" value="Gnrer le bi-cl" onClick="CertRequestSub" language="VBSCRIPT" />
	 <?php
}


function show_validation_process($step, $nbr_enveloppes)
{
 
?>
Le processus de validation est le suivant: <br /><br />
<ol>

<li><? if ($step == 1)  echo "<span style='background:#c0c0c0'>"; else echo ""; ?>
  G&eacute;n&eacute;ration du bi-cl&eacute; de l'enveloppe 1.
<? if ($step == 1)  echo "</span>"; else echo ""; ?>
</li>

<li><? if ($step == 2) echo "<span style='background:#c0c0c0;'>"; else echo ""; ?>
Installation du certificat produit correspondant.
<? if ($step == 2)  echo "</span>"; else echo ""; ?>
</li>

<? if ($nbr_enveloppes == 2) 
   { 															  
?><li><? if ($step == 3) echo "<span style='background:#c0c0c0;'>"; else echo ""; ?>
     G&eacute;n&eacute;ration du bi-cl&eacute; de l'enveloppe 2.
<? if ($step == 3)  echo "</span>"; else echo ""; ?>
</li>

<li><? if ($step == 4) echo "<span style='background:#c0c0c0;'>"; else echo ""; ?>
Installation du certificat produit correspondant.
<? if ($step == 4)  echo "</span>"; else echo ""; ?>
</li>
<br /><br /><br />

</ol>
<?
   }
 else
   {
?>
<br /><br /><br />

</ol>
<?
   } // End if $nbr_enveloppes  
}

/** affiche la page de validation de la consultation slectionne 
 * @ingroup administrateur
 * @return void
 */
function validate_cons2()
{
  if (!$_SESSION['sess_administrateur_logged'])
    {
      PrintMessage("Vous n'tes pas authentifi");
      show_authentication_form();
      return;
    }

 if (!$_POST['cons_ref_env']) {
      PrintError("Erreur interne: numero enveloppe introuvable");
      return;
    }

  include 'gen_req2.vbs';
  
  if (!$_POST['cons_ref']) {
      PrintError("Erreur interne: Rfrence de la consultation introuvable");
      return;
    }
  ?>
      <input type="hidden" name="cons_ref" value="<? echo stripslashes($_POST['cons_ref']); ?>">
      <input type="hidden" name="cons_ref_env" value="<?echo $_POST['cons_ref_env'];?>">
      <h2>Validation de la consultation</h2>
<?php
  //determiner $nbr_enveloppes
  $nb_env_query = "SELECT nbr_enveloppes FROM Consultation WHERE reference='".addslashes($_POST['cons_ref'])."'";
  $nb_env_resp = sql_query($nb_env_query);
  $nb_env_line = mysql_fetch_array($nb_env_resp, MYSQL_ASSOC);

  $nbr_enveloppes=$nb_env_line['nbr_enveloppes'];
  //fin determiner nbre enveloppes

  if($_POST['cons_ref_env']==1)
    {
      show_validation_process(1, $nbr_enveloppes);
?>
	 Vous tes sur le point de g&eacute;n&eacute;rer le bi-cl&eacute; 1 de la consultation r&eacute;f&eacute;renc&eacute;e <strong><? echo stripslashes($_POST['cons_ref']); ?></strong>.<br /><br />
<?php
     }
  elseif($_POST['cons_ref_env']==2)
    {
      show_validation_process(3, $nbr_enveloppes);
?>
Vous tes sur le point de g&eacute;n&eacute;rer le bi-cl&eacute; 2 de la consultation rfrence <strong><? echo stripslashes($_POST['cons_ref']); ?></strong>.<br /><br />
<?php
    }
  else
    {
      PrintError("Probleme pour determiner pour quelle enveloppe on doit generer le bicle");
      return;
    }
?>	 
<input type="hidden" name="nbr_enveloppes" value="<?echo $nbr_enveloppes;?>" />
<input type="hidden" name="pkcs10_req" value="" />
<input type="hidden" name="reqkeysize" value="" />

<input type="hidden" name="keysize" id="keysize" value="1024" />
<input type="hidden" name="storeflags" id="storeflags" value="" />
CSP : <select name="lbCSP" onChange="handleCSPChange()" language="VBSCRIPT">
<option id="locLoading" selected>Chargement...</option>
</select>
<input type="hidden" name="keyusage" value="both" />
        <br /><br />
         <input type="button" name="valider" value="Gnrer le bi-cl" onClick="CertRequestSub" language="VBSCRIPT" />
	 <?php
}


/** fermeture de la session administrateur
 * @ingroup admin_auth
 * @return VOID
 */
function disconnect_admin()
{
    $_SESSION = array();
    ?>
	<script Language="JavaScript" type="text/javascript">
	if (document.all) { // IE
		document.all.main_form.cmd.value='';   
		document.all.main_form.submit();
	} else { // non-IE
		document.main_form.cmd.value='';   
		document.main_form.submit();
	}
	</script>
<?php
} // end function disconnect_admin()

/** valide la consultation slectionne
 * @ingroup administrateur
 * @return VOID 
 */
function do_validate_cons()
{
    if (!$_SESSION['sess_administrateur_logged']) {
        PrintMessage ("Vous n'tes pas authentifi");
        show_authentication_form();
        return;
    }
    if (!$_POST['cons_ref']) {
        PrintError("Erreur interne: Rfrence de la consultation introuvable");
        return;
    }  

    // la consultation passe  l'tat 1
    $update_state_in_cons = "UPDATE ".CONSULTATION." SET etat='1' WHERE reference='".addslashes($_POST['cons_ref'])."'";

    $update_state_res = sql_query ($update_state_in_cons);
    if (!$update_state_res) {
        PrintError("Erreur lors de la publication de la consultation.");
        return;
    }
    echo "La consultation ".stripslashes($_POST['cons_ref'])." est maintenant publie.";
} // END function do_validate_cons()

/** valide la consultation slectionne
 * @ingroup administrateur
 * @return VOID 
 */
function do_validate_cons2()
{

    if (!$_SESSION['sess_administrateur_logged']) {
        PrintMessage("Vous n'tes pas authentifi");
        show_authentication_form();
        return;
    }
    if (!$_POST['cons_ref']) {
        PrintError("Erreur interne: Rfrence de la consultation introuvable");
        return;
    }  
    
    if($_POST['cons_ref_env']==2)
      {
	// la consultation passe  l'tat 1
	$update_state_in_cons = "UPDATE ".CONSULTATION." SET dateValidation='".date('Y-m-d')."', etat='1' WHERE reference='".addslashes($_POST['cons_ref'])."'";
	$update_state_res = sql_query ($update_state_in_cons);
	if (!$update_state_res)
	  {
	    PrintError("Erreur lors de la publication de la consultation.");
	    return;
	  }
       ?>
	<h1>Validation de la consultation</h1>
	   La consultation <b><?php echo stripslashes($_POST['cons_ref']);?></b> est maintenant publie<br /><br /><br />
	<a href="javascript:ActivateMenu('show_admin_auth_mainpage');">Page d'accueil</a>
<?php
      }
      elseif($_POST['nbr_enveloppes']==1)
      {
	$update_state_in_cons = "UPDATE ".CONSULTATION." SET dateValidation='".date('Y-m-d')."', etat='1' WHERE reference='".addslashes($_POST['cons_ref'])."'";
	$update_state_res = sql_query ($update_state_in_cons);
	if (!$update_state_res)
	  {
	    PrintError("Erreur lors de la publication de la consultation.");
	    return;
	  }
?>
      <h2>Validation de la consultation 1 enveloppe</h2>
	   La consultation <b><?php echo stripslashes($_POST['cons_ref']);?></b> est maintenant publie<br /><br /><br />
	<a href="javascript:ActivateMenu('show_admin_auth_mainpage');">Page d'accueil</a>
<?
      }
    else
      {
?>
<input type="hidden" name="cons_ref" value="">
 <input type="hidden" name="cons_ref_env" value="">
 <script Language="JavaScript">
    ValidateCons2(2, "<?echo $_POST['cons_ref'];?>");
 </script>

   <?php
      }
} // END function do_validate_cons()

/** gnre le bi-cl et insre le certificat dans la base
 * @ingroup administrateur
 * @return void
 */
function generate_cert2()
{
  if (!$_SESSION['sess_administrateur_logged']) {
      PrintMessage("Vous n'tes pas authentifi");
      show_authentication_form();
      return;
    }
  
  if (!$_POST['cons_ref']) {
      PrintError("Erreur interne: Rfrence de la consultation introuvable");
      return;
    }
  if (!$_POST['pkcs10_req']) {
      PrintError("Le serveur ne trouve pas la requte PKCS10");
      return;
    }

  $sess_id = session_id();
    // creation de la requete OPENSSL //////////////////////////////////////////
  $req = "-----BEGIN CERTIFICATE REQUEST-----\n".$_POST['pkcs10_req']."-----END CERTIFICATE REQUEST-----";
  $tmp_req_filename = TMP_DIR.$sess_id."_pkcs10.pem";
  $req_fp = fopen($tmp_req_filename, 'w');
  if (!fwrite($req_fp, $req)) {
      PrintError("Erreur interne: Impossible d'crire la requte");
      return;
    }
  fclose($req_fp);

    // generation du certificat ////////////////////////////////////////////////
  $tmp_cert_filename = TMP_DIR.$sess_id."_cert.pem";
  $create_cert = OPENSSL ." x509 -req -in $tmp_req_filename -out $tmp_cert_filename -days 365 -CA ".CA_CERT." -CAkey ".CA_PRIV_KEY." -CAserial ".CA_SERIAL." -extfile /usr/local/ssl/openssl.cnf -extensions s_mime_cert";
  system($create_cert . " &> /tmp/create_cert", $res);

  if ($res != 0) {
     PrintError("Erreur lors de la cration du certificat");
     return;
   }

   $cert_fp = fopen($tmp_cert_filename, 'r');
   $pem_cert = fread($cert_fp, filesize($tmp_cert_filename));
   fclose($cert_fp);

   unlink($tmp_req_filename);
   unlink($tmp_cert_filename);

   ereg("-----BEGIN CERTIFICATE-----\n(.*)-----END CERTIFICATE-----", $pem_cert, $cert_text);

   if (!$cert_text) {
       PrintError("Le certificat gnr n'est pas valide");
       return;
     }
   
   if($_POST['cons_ref_env']==1)
     {
   // Insertion du certificat dans la consultation (enveloppe1)
   $insert_cert_in_cons = 'UPDATE '.CONSULTATION." SET certificat_env_1='$pem_cert' WHERE reference='".addslashes($_POST['cons_ref'])."'";
     }
   elseif($_POST['cons_ref_env']==2)
     {
// Insertion du certificat dans la consultation (enveloppe2)
   $insert_cert_in_cons = 'UPDATE '.CONSULTATION." SET certificat_env_2='$pem_cert' WHERE reference='".addslashes($_POST['cons_ref'])."'";
     }
   else
     {
       PrintError("Impossible de determiner le numero de l'enveloppe(update db)");
       return;
     }

   $insert_cert_res = sql_query ($insert_cert_in_cons);
   if (!$insert_cert_res) {
       PrintError("Erreur lors de l'insertion du certificat");
       return;
     }
//   mysql_free_result($insert_cert_res);

    // cration de la clef prive ??? XXX //////////////////////////////////////
?>
<input type="hidden" name="certificate" value="<?php echo $cert_text[1];?>" />
<input type="hidden" name="cons_ref" value="<?php echo stripslashes($_POST['cons_ref']);?>" />
<input type="hidden" name="cons_ref_env" value="<?php echo $_POST['cons_ref_env'];?>" />
<input type="hidden" name="nbr_enveloppes" value="<?php echo $_POST['nbr_enveloppes'];?>" />


<?php  include "install_cert2.vbs";?>
<br />

<?php
// TODO determiner $nbr_enveloppes
$nbr_enveloppes = $_POST['nbr_enveloppes'];
    // installation du certificat sur le poste client //////////////////////////
if($_POST['cons_ref_env']==1)
{
 ?>
<h2>Validation de la consultation</h2>
   <? show_validation_process(2, $nbr_enveloppes);?>
Le premier bi-cl a t gnr avec succs.<br /><br />
  <?php
}
elseif($_POST['cons_ref_env']==2)
{
?>
<h2>Validation de la consultation</h2>
   <?show_validation_process(4, $nbr_enveloppes);?>
Le second bi-cl a t gnr avec succs.<br /><br />
<?php
}
?>
Vous devez maintenant installer le certificat produit puis le fournir au responsable du march.<br /><br /> 
<input type="button" name="accept" value="Installer le certificat" onClick="CertAcceptSub" language="VBSCRIPT" />

<?php
} // END function generate_cert()


/** gnre le bi-cl et insre le certificat dans la base
 * @ingroup administrateur
 * @return void
 */
function generate_cert()
{
  if (!$_SESSION['sess_administrateur_logged']) {
      PrintMessage("Vous n'tes pas authentifi");
      show_authentication_form();
      return;
    }
  
  if (!$_POST['cons_ref']) {
      PrintError("Erreur interne: Rfrence de la consultation introuvable");
      return;
    }
  if (!$_POST['pkcs10_req']) {
      PrintError("Le serveur ne trouve pas la requte PKCS10");
      return;
    }

  $sess_id = session_id();
    // creation de la requete OPENSSL //////////////////////////////////////////
  $req = "-----BEGIN CERTIFICATE REQUEST-----\n".$_POST['pkcs10_req']."-----END CERTIFICATE REQUEST-----";
  $tmp_req_filename = TMP_DIR.$sess_id."_pkcs10.pem";
  $req_fp = fopen($tmp_req_filename, 'w');
  if (!fwrite($req_fp, $req)) {
      PrintError("Erreur interne: Impossible d'crire la requte");
      return;
    }
  fclose($req_fp);

    // generation du certificat ////////////////////////////////////////////////
  $tmp_cert_filename = TMP_DIR.$sess_id."_cert.pem";
  $create_cert = OPENSSL ." x509 -req -in $tmp_req_filename -out $tmp_cert_filename -days 365 -CA ".CA_CERT." -CAkey ".CA_PRIV_KEY." -CAserial ".CA_SERIAL." -extfile /usr/local/ssl/openssl.cnf -extensions s_mime_cert";
  system($create_cert . " &> /tmp/create_cert", $res);

  if ($res != 0) {
     PrintError("Erreur lors de la cration du certificat");
     return;
   }

   $cert_fp = fopen($tmp_cert_filename, 'r');
   $pem_cert = fread($cert_fp, filesize($tmp_cert_filename));
   fclose($cert_fp);

   unlink($tmp_req_filename);
   unlink($tmp_cert_filename);

   ereg("-----BEGIN CERTIFICATE-----\n(.*)-----END CERTIFICATE-----", $pem_cert, $cert_text);

   if (!$cert_text) {
       PrintError("Le certificat gnr n'est pas valide");
       return;
     }

   // Insertion du certificat dans la consultation /////////////////////////////
   $insert_cert_in_cons = 'UPDATE '.CONSULTATION." SET certificat='$pem_cert' WHERE reference='".addslashes($_POST['cons_ref'])."'";


   $insert_cert_res = sql_query ($insert_cert_in_cons);
   if (!$insert_cert_res) {
       PrintError("Erreur lors de l'insertion du certificat");
       return;
     }
//   mysql_free_result($insert_cert_res);

    // cration de la clef prive ??? XXX //////////////////////////////////////
?>
<input type="hidden" name="certificate" value="<?php echo $cert_text[1];?>" />
<input type="hidden" name="cons_ref" value="<?php echo $_POST['cons_ref'];?>" />

<?php  include "install_cert.vbs";?>
<br />

<?php
    // installation du certificat sur le poste client //////////////////////////
?>
Le bi-cl a t gnr avec succs.<br /><br />
Vous devez maintenant installer le certificat produit puis le fournir au responsable du march.<br /><br /> 
<input type="button" name="accept" value="Installer le certificat et publier la consultation" onClick="CertAcceptSub" language="VBSCRIPT" />

<?php
} // END function generate_cert()





?>












<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<title><?echo OWNER_NAME;?> - Marchs publics lectroniques</title>
	<link rel="stylesheet" type="text/css" href="../include/joli.css">
	<script type="text/javascript" src="../include/form.inc.js"><!-- //--></script>
	<script type="text/javascript" src="../include/popup.inc.js"><!-- //--></script>
    <?php include "init_xenroll.vbs"; ?>
</head>

<body 

<?
// Initialisation de XEnroll si ncessaire
if ($_POST['cmd'] == 'validate_cons' || $_POST['cmd'] == 'generate_cert')
     echo 'language="VBSCRIPT" onload="postload()"';
     ?>
> <!-- FERMETURE de body -->


    <div id="tout">
        <?php require 'template.administrateur-bandeau-h.inc.php';?>
        <div id="contenu">
            <table id="ttt" summary="les trois colonnes">
                <tr>
                    <?php require 'template.administrateur-g.inc.php';?>
                    <td id="centre">
                        <form name="main_form" id="main_form" method="POST"
                        action="<?php echo $_SERVER['PHP_SELF']; ?>"
                        enctype="multipart/form-data">
                            <input type="hidden" name="cmd" id="cmd" value="">
<?php
$cmd = $_POST['cmd'];
if (!$cmd)
    { $cmd = DEFAULT_CMD; }

switch ($cmd) {
    case 'show_admin_mainpage': // affiche page d'accueil
          show_admin_mainpage(false);
          break;
    case "administrateur_logon":
          administrateur_logon();
          break;
    case "disconnect_admin":
          disconnect_admin();
          break;
 case "show_interne_insc_form":
          show_interne_insc_form();
          break;
 case "add_interne_insc":
   require_once 'add_interne_insc.php';

   add_interne_insc();
   break;

 case "show_interne_list":
   require_once "supp_interne.php";
   show_interne_list();
   break;

 case "delete_interne":
   require_once "supp_interne.php";
   delete_interne();
   break;

 case "show_deactivated_internes":
   require_once "activer_interne.php";
   show_deactivated_internes();
   break;

 case "activer_interne":
   require_once "activer_interne.php";
   activer_interne();
   break;

 case "do_activate_interne":
   require_once "activer_interne.php";
   do_activate_interne();
   break;

case "show_subs_list":
   require_once "supp_subs.php";
   show_subs_list();
   break;

 case "delete_externe":
   require_once "supp_subs.php";
   delete_externe();
   break;

 case "delete_waiting_cons":
   delete_waiting_cons();
   break;

 case "do_delete_waiting_cons":
   do_delete_waiting_cons();
   break;

    case "show_authentication_form":
          show_authentication_form();
          break;
    case "show_admin_auth_mainpage":
          show_admin_auth_mainpage();
          break;
    case "show_admin_passwd_form":
          show_admin_passwd_form();
	  break;
    case "update_admin_passwd":
          update_admin_passwd();
          break;
    case "list_new_cons":
          list_new_cons();
          break;
    case "list_denied_env":
          list_denied_env();
          break;

 case "do_delete_enveloppe":
      do_delete_enveloppe();
      break;

 case "restore_enveloppe":
      restore_enveloppe();
      break;
    case "validate_cons":
      //validate_cons();
         validate_cons2();
          break;
    case "do_validate_cons":
      // do_validate_cons();
	 do_validate_cons2();
          break;
    case "generate_cert":
      //generate_cert();
	generate_cert2();
          break;
   default:
          echo "Commande inconnue: $cmd";
          break;
} // END switch
?>
                        </form>
                    </td>
                </tr>
            </table>
            <?php require_once 'template.footer.inc.php' ?>
        </div><!-- FIN DIV CONTENU //-->
    </div><!-- FIN DIV TOUT //-->
</body>



</html>
