/*
Copyright (C) 2004 ATEXO Local Trust MPE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For more information on our product, please contact MPE@atexo.com
*/
<?php 
define('CONS_APPROVED_STATE', '1');



/** cre la requte SQL pour la recherche publique de consultations
 * @return STRING la requte SQL
 */
function create_searchQuery()
{
    //recuperation des valeurs du formulaire
  $vars = array('reference', 'categorie','parution1','parution2','deadline1',
        'deadline2','motsTitre','motsResume','limit','referenceQuery');
    foreach($vars as $var) {
        $$var = isset($_POST[$var]) ? $_POST[$var] : '';
    } // END foreach

    ////////////////////////////////////////// changement de format pour la date
    $dateVars = array('parution1', 'parution2', 'deadline1', 'deadline2');
    foreach($dateVars as $var) {
        if(strlen($$var)!=0)
            { $$var = frnDate2iso($$var); } // END if
    } // END foreach


    //Vrification des valeurs du formulaire
    //TODO XXX tester la validit de parution1,2 deadline1,2


    //construction de la requte SQL  partir ds valeurs du formulaire
    $query = "SELECT DISTINCT ".REFERENCE
        .", categorie, titre, resume, dateDebut, dateFin, fichierDossier";

    $query .= "\nFROM `".CONSULTATION."`";
    
    //$query .= "\nWHERE etat='".CONS_APPROVED_STATE."'";
    $query .= "\n WHERE etat='".CONS_APPROVED_STATE."' AND type_procedure='".TYPE_PROCEDURE_PUBLICITE."'";
    $query .= "\n AND UNIX_TIMESTAMP(dateFin) > UNIX_TIMESTAMP(NOW()) ";
    //$query .= "\n AND (DATE_SUB(dateFin, INTERVAL TO_DAYS(NOW()) DAY) > 0)";
   if (strlen($reference)!=0)
        {
	  $query .= "\n AND (`".REFERENCE."` = '".addslashes($reference)."' OR `".REFERENCE."` LIKE '%".$reference."%') ";
	}
    if (strlen($parution1)!=0)
        { $query .= "\n      AND TO_DAYS(dateDebut) >= TO_DAYS('$parution1')"; }
    if (strlen($parution2)!=0)
        { $query .= "\n      AND TO_DAYS(dateDebut) <= TO_DAYS('$parution2')"; }
    if (strlen($deadline1)!=0)
        { $query .= "\n      AND TO_DAYS(dateFin) >= TO_DAYS('$deadline1')"; }
    if (strlen($deadline2)!=0)
        { $query .= "\n      AND TO_DAYS(dateFin) <= TO_DAYS('$deadline2')"; }
    if (strlen($categorie)!=0)
        { $query .= "\n      AND categorie='$categorie'"; }
    //TODO XXX Grer plusieurs categories

    if (strlen($motsTitre)!=0) {
        $mots = explode(';', $motsTitre);
        foreach ($mots as $mot) {
            if (strlen($mot)!=0)
                { $query .= "\n      AND titre LIKE '%$mot%' or titre = '".addslashes($mot)."'"; }
        } // END foreach
    } //END motsTitre

    if (strlen($motsResume)!=0) {
        $mots = explode(' ', $motsResume);
        foreach ($mots as $mot) {
            if (strlen($mot))
                { $query .= "\n      AND resume LIKE '%$mot%'"; }
        } // END foerach
    } // end motsResume

    if (strlen($referenceQuery)!=0)
        { $query.= $referenceQuery; }

    $query .="\nORDER BY `dateDebut` DESC";

    if ($limit!=0)
      { $query .= "\nLIMIT $limit"; } // end $limit

    // $query .= "\n;";
    return $query;
} // END function create_searchQuery()



/** effectue la requte
 * @param $_query la requte  effectuer
 * @param $_displayNumResult BOOL est-ce quon affiche le nombre de rsultats
 * @param $page nom de la fonction qui appelle show_found_cons pour la gestion de l'affichage
 * @return VOID
 */
function show_found_cons($_query, $_displayNumResult=true, $page=-1)
{
  /*--Calcul du nombre total de resultats a la requete $query--*/
  $resp_nb_result = sql_query($_query);
  $nb_result = mysql_num_rows($resp_nb_result);
  mysql_free_result($resp_nb_result);
  
  if($page==-1)
    {
      $response = sql_query($_query);// ANCIENNE VERSION (avant prec/suiv)
    }
  else
    {
      /*--Nouvelle version--*/
      
      /*--Calcul du premier enregistrement a afficher ($min)--*/
      $displayed=(!$_POST['displayed'])?1:$_POST['displayed'];
      $min = ($displayed-1)*RESULTS_TO_SHOW;
      
      /*--effectue la requete $query + LIMIT $min,RESULTS_TO_SHOW --*/
      $response = sql_select_limit2($_query, $min, RESULTS_TO_SHOW);
    } // End else ($page)

    if (!$response||$nb_result==0) {
        echo "<b>Aucune rponse trouve</b>";
        return;
    } // END if (!$response)
    ?>
    <script type="text/javascript" src="./include/popup.inc.js"><!-- //-->
    </script>
    <?php
       //$nb_result = mysql_num_rows($response); ANCIENNE VERSION (avant prec/suiv)
    if ($_displayNumResult) {
      if($page==-1)
      {      
	echo "<em>(".$nb_result." consultations trouves)</em>";
      }
      else
      { 
	/*--Calcul du dernier element affiche (Pour message d'info dedie a l'utilisateur) --*/
	$last_displayed = ((RESULTS_TO_SHOW*$displayed)>$nb_result)?$nb_result:RESULTS_TO_SHOW*$displayed;
	echo "<p><em>(R&eacute;ponses ".($min+1)." &agrave; ".$last_displayed." sur ".$nb_result." r&eacute;ponses trouv&eacute;es)</em></p>";
      }

    } // End if($_displayNumResult)
    ?>
    <input type="hidden" name="prop_form" value="">
    <input type="hidden" name="refMarche"  value="">
    <table id="consultationList" summary="Liste des consultations">
        <tbody>
            <?php
            while ($line=mysql_fetch_array($response, MYSQL_ASSOC)) {
                // calcul de la taille du fichier de consultation
                if ($line['fichierDossier']) {
                    $taille=strlen($line['fichierDossier']);
                    if ($taille>1000) {
                        $taille /= 1000;
                        $taille = preg_replace('/\..*/','',$taille);
                        $taille +=1;
                        $taille .= " Ko";
                    }    else {
                        $taille .= " octets";
                    } // END if then else
                    $taille="($taille)";
                } else {
                    $taille="";
                } // END if then else
		$ref_res = $line['reference'];
                ?>
                <tr><td>
                    <strong><?php echo stripslashes($line['titre']);?></strong>
                    <div class="droite">
                        <u>Date d'envoi au JO</u> : <?php echo iso2frnDate($line['dateDebut']);?>
                    </div>
                    <br /><u>Catgorie</u> : <?php echo stripslashes(str_replace('....',' ',$line['categorie']));?>
                    <div class="droite">
                        <u>Date et heure de Clture</u> : <?php echo iso2frnDateTime($line['dateFin']);?>
                    </div>
                    <br /><u>Rfrence</u> : <?php echo stripslashes($line['reference']);?>
                    <p><?php echo stripslashes($line['resume']); ?></p>
                    <div class="droite">
                        <a href="javascript:ValidateRef('<? echo $line['reference']; ?>');">Faire une offre</a>
                    </div>
                    <a href="javascript:x();" onClick="javascript:new_window('<? echo "telecharger.php?reference=".$line['reference'];?>', 402, 405, 0, 0)">Tlcharger le dossier <?php echo$taille;?></a>
                </td></tr>
                <?php
            } // END WHILE EACH SQL ANSWER
            mysql_free_result($response);
            ?>
        </tbody>
    </table>
    <?php
if($page!=-1)
    show_page_result($page, RESULTS_TO_SHOW, $nb_result);

return  $ref_res;
} // END function show_found_cons($_query)

?>
