/*
Copyright (C) 2004 ATEXO Local Trust MPE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For more information on our product, please contact MPE@atexo.com
*/
<?php
// 193.149.120.214
session_name('interne');
session_start();

require_once 'config.inc.php';
require_once      'misc.inc.php';
require_once 'sqlRights.inc.php';
require_once     'mysql.inc.php';
require_once    'format.inc.php';



/** vrifie que le document XML est valide
 * @ingroup offer_fct
 * @param $file chemin du fichier contenant ledocument XML
 * @return ARRAY (objet DOM, l'erreur ventuelle)
 */
function validate_xml_dom($file)
{
  $error = array();
  //$dom = xmldocfile($file, DOMXML_LOAD_VALIDATING, $error);
  $dom = domxml_open_file($file);
  if (!is_object($dom)) {
      return array(NULL, $error);
    }
  return array($dom, NULL);
} // END function validate_xml_dom($file)



/** vrifie que l'objet DOM est conforme  la DTD
 * @ingroup offer_fct
 * @param $dom l'objet DOM
 * @return ARRAY (l'objet DOM, l'erreur ventuelle)
 */
function validate_xml_dtd($dom)
{
  $error = array();
  if (!domxml_doc_validate($dom, $error))
    {
      return array(NULL, $error);
    }
  return array($dom, NULL);
} //END function validate_xml_dtd($dom)


/** vrifie que le document XML est valide et conforme
 * @ingroup offer_fct
 * @param $file chemin dufichier contenant le document XML
 * @return XXX
 */
function parse_xml_file($file)
{
  $dom = validate_xml_dom($file);
  if (!$dom[0]) {
      PrintError ("Objet DOM invalide.");
      print_r($dom[1]);
      return NULL;
    }
  
  $dtd= validate_xml_dtd($dom[0]);
  if (!$dtd[0]) {
      PrintError ("L'objet DOM ne respecte pas la DTD.");
      print_r($dtd[1]);
      return NULL;
    }
  return $dtd[0];
} // END function parse_xml_file($file)



/** vrifie que le timestamp correspond bien  la donne horodate, et
 * renvoie son contenu
 * @ingroup offer_fct
 * @param $infile chemin du fichier de donne (XML)
 * @param $ts_reply_file chemin du fichier de timestamp
 * @return ARRAY (BOOL, contenu du timestamp)
 */
function verify_timestamp($infile, $ts_reply_file)
{
  $verify = OPENSSL . " ts -verify -data $infile -in $ts_reply_file -CAfile " . TS_CAFILE;
  system("$verify  &> /tmp/tsv_error", $ts_verify);
  $text = '';
  if ($ts_verify == 0) {
    //recupration de la date
    $text_res = OPENSSL . " ts -reply -in $ts_reply_file -text";
    system("$text_res  &> $infile.tst", $ts_text);
    $fp = fopen("$infile.tst", 'r');
    $text = fread($fp, filesize("$infile.tst"));
    fclose($fp);
    unlink ("$infile.tst");
  }
  return array($ts_verify, $text);
} // END function verify_timestamp



/** renvoie le contenu du jeton d'horodatage
 * @ingroup interne_fct
 * @param $_tsFilename chemin du fichier contenant le jeton
 * @return ARRAY (reponse systme , contenu du jeton)
 */
function read_timestamp($_tsFilename) {
	error_reporting('E_all');
	$tempFile=TMP_DIR.'jeton-'.session_id().'.tst';
	system(OPENSSL." ts -reply -in $_tsFilename -text &> $tempFile"   , $sys);
	$fp=fopen($tempFile, 'r');
	$tsText=fread($fp, filesize($tempFile));
	fclose($fp);
	unlink($tempFile);
	return array($sys, $tsText);
} // END function read_timestamp($_tsFilename)



/** vrifie la signature face  la donne
 * @ingroup offer_fct
 * @param $data_file	chemin du fichier de donnes
 * @param $pkcs7_file_name	chemin du fichier de signature
 * @param $signer_cert	chemin du fichier contenant le certificat
 * @return SYSTEM REPLY
 */
function verify_signatures($data_file, $pkcs7_file_name, $signer_cert)
{
  $CAdir = '/home/tantaoui/cvs/marchespublics/activex/eParapheur/upload/CA/';

  // $verify = OPENSSL." smime -verify -inform PEM -in $pkcs7_file_name -signer $signer_cert -content ".str_replace(' ', '\ ', $data_file)." -CAfile $CAdir"."activex.crt -out /dev/null"; // faire plutt un escapeshellargs()

  $verify_nocerts = OPENSSL." smime -verify -noverify -inform PEM -signer $signer_cert -in  $pkcs7_file_name -content ".str_replace(' ', '\ ', $data_file)." -out /dev/null"; // faire plutt un shellescapeargs()

  $command = $verify_nocerts;
 
  
  system("$command &> /tmp/verify_error", $verif);
  return $verif;
} // END function verify_signatures($data_file, $pkcs7_file_name, $signer_cert)

/**
 * @param $pkcs7_signature
 */
function verify_certificate($pkcs7_signature, $sess_id)
{
  $signature_file_name = TMP_DIR.$sess_id."_signature.pem";
  $signer_file_name = TMP_DIR.$sess_id."_signer.pem";
  $fp = fopen($signature_file_name, 'w');
  if (!fwrite($fp, $pkcs7_signature))
    {
      echo "Impossible d'crire la signature dans $signature_file_name";
    } // END if
  fclose($fp);

  // Recuperation du certificat
  $get_cert = OPENSSL." smime -verify -in $signature_file_name -noverify -nosigs -signer $signer_file_name -inform PEM -content /dev/null";

  system($get_cert . " &> ".ERROR_FILE, $get_cert_error);
  if ($get_cert_error != 0)
    {
      return 1;
    } 
  $verif_crl_file = CRL_VERIF_FILE.$sess_id;
  $verif_cmd = OPENSSL." verify -CApath ".TRUST_DIR." -crl_check $signer_file_name";
  system($verif_cmd . " &> ".$verif_crl_file, $verif_error);
  if ($verif_error != 0)
    {
      return 2;
    }
   
   //recuperation du message d'erreur OpenSSL
   $fp = fopen($verif_crl_file, 'r');
   $crl_error = fread($fp, filesize($verif_crl_file));
   fclose($fp);

   @unlink($signer_file_name);
   @unlink($signature_file_name);
   
   // On recheche "error NN at M depth lookup:"
   // exemple error 20 at 0 depth lookup:unable to get local issuer certificate
   // teste avec OpenSSL version 0.9.7c
   preg_match("/^error ([0-9]*) at ([0-9]*) depth lookup:/m", $crl_error, $error);
   unlink($verif_crl_file);
   if($error[0])
     return 3;

  return 0;
}

/** recupre le champ SIGNER du certificat
 * @ingroup offer_fct
 * @param $x509File
 * @param $field
 * @return STRING identit du signataire
 */
function get_signer_field($x509File, $field)
{
  $fp = fopen($x509File, 'r');
      $certificate = fread($fp, filesize($x509File));
  fclose($fp);
  $cert = openssl_x509_read($certificate);
  $x509 = openssl_x509_parse($cert, true);
  openssl_x509_free($cert);
  return str_replace('/', ' ', $x509[$field]);
} // END function get_signer_field($x509File, $field)



/** XXX TODO
 * <ul>
 * <li>vrification du rpertoire</li>
 * <li>vrification de la signature du document principal</li>
 * <li>vrification de la signature du document complmentaire</li>
 * <li>vrification de la signature des annexes</li>
 * <li>recuperation du signataire</li>
 * <li>verification du jeton d'horodatage</li>
 * </ul>
 * @ingroup offer_fct
 */
function verif_dir()
{
  if (!$_POST['verifDir']) {
    PrintError('Pas de rpertoire  vrifier');
    return;
  } // END if
  $time_stamp = '';
  $work_dir = WORK_DIR.$_POST['verifDir'].'/';
  $signer_cert = $work_dir.'signer.crt';
  $verif = -1;
  $dom = parse_xml_file($work_dir.'eParapheur.xml');

  // Document principal ////////////////////////////////////////////////////////
  $docPrincipal = $dom->get_elements_by_tagname('DocPrincipal');
  $signDocPrincipal = $dom->get_elements_by_tagname('SignatureDocPrincipal');

  if ($docPrincipal[0]->get_content() == "" || $signDocPrincipal[0]->get_content() == "") {
    PrintError("Document Principal absent");
    show_dirs();
    return;
  }

  $pkcs7_file_name = $work_dir."pkcs7_docPrin.tmp";
  
  $pkcs7_content = $signDocPrincipal[0]->get_content();
  $fp = fopen($pkcs7_file_name, 'w');
    if (!fwrite($fp, $pkcs7_content)) {
      echo "Impossible d'crire $pkcs7_file_name";
    } // END if
  fclose($fp);
  
  $verif =  verify_signatures(utf8_decode($work_dir.$docPrincipal[0]->get_content()), $pkcs7_file_name, $signer_cert);
  if ($verif == 0) {
    echo "<br><strong> Vrification Document Principal OK</strong> ".basename($work_dir.$docPrincipal[0]->get_content())."<br>";
  } else {
    echo "<br><strong> Vrification Document Principal</strong>: ".basename($work_dir.$docPrincipal[0]->get_content())." ERREUR ($verif)<br>";
  } // END if then else
  unlink($pkcs7_file_name);

  // Document complment ///////////////////////////////////////////////////////
  $docComplement = $dom->get_elements_by_tagname("DocComplement");
  $signDocComplement = $dom->get_elements_by_tagname("SignatureDocComplement");

  if ($docComplement[0]->get_content() != '' && $signDocComplement[0]->get_content() != '') {
      $pkcs7_file_name = $work_dir."pkcs7_docComp.tmp";
      $pkcs7_content = $signDocComplement[0]->get_content();
      $fp = fopen($pkcs7_file_name, 'w');
          if (!fwrite($fp, $pkcs7_content)) {
	          PrintError("Impossible d'crire " . $pkcs7_file_name);
	      }
      fclose($fp);
      
      $verif =  verify_signatures(utf8_decode($work_dir.$docComplement[0]->get_content()), $pkcs7_file_name, $signer_cert);
      if ($verif == 0) {
	echo "<br> <strong>Vrification Document Complement OK</strong>: ".basename($work_dir.$docComplement[0]->get_content())."<br>";
      } else {
	echo "<br> <strong>Vrification Document Complement ($verif)</strong> ".basename($work_dir.$docComplement[0]->get_content()).": ERREUR<br>";
    } // END if then else
      unlink($pkcs7_file_name);
    } // END if

  // Annexes ///////////////////////////////////////////////////////////////////
  $Annexes = $dom->get_elements_by_tagname('Annexe');
  $i = 0;
  while ($domAnnexe = $Annexes[$i]) {
      $docAnnexe     = $domAnnexe->get_elements_by_tagname('FichierAnnexe');
      $signDocAnnexe = $domAnnexe->get_elements_by_tagname('SignatureAnnexe');
      
      if ($docAnnexe[0]->get_content() != '' && $signDocAnnexe[0]->get_content() != '') {
	  $pkcs7_file_name = $work_dir."pkcs7_Annexe$i.tmp";
	  
	  $fp = fopen($pkcs7_file_name, 'w');
	  $pkcs7_content = $signDocAnnexe[0]->get_content();
	  if (!fwrite($fp, $pkcs7_content)) {
	      echo "Impossible d'crire $pkcs7_file_name.";
	    } // END if
	  fclose($fp);
	  
	  $verif =  verify_signatures(utf8_decode($work_dir.$docAnnexe[0]->get_content()), $pkcs7_file_name, $signer_cert);
	  if ($verif == 0) {
	    echo "<br> <strong>Vrification Document Annexe $i OK</strong>: ".basename($work_dir.$docAnnexe[0]->get_content())."<br>";
	  } else {
	    echo "<br> <strong>Vrification Document Annexe $i ($verif)</strong> ".basename($work_dir.$docAnnexe[0]->get_content()).": ERREUR<br>";
      } // END if then else
	  unlink($pkcs7_file_name);
	  
	} // END if
      $i++;
    } // END while ($domAnnexe = $Annexes[$i])

  // recuperation de l'identit du signataire //////////////////////////////////
  if ($verif == 0) {
      echo "<br>Ce dossier a t envoy et sign par :" . get_signer_field($signer_cert, 'name'); 
    } // END if
  if (is_file($signer_cert)) {
    unlink ($signer_cert);
    } // END if

  // verification du timestamp /////////////////////////////////////////////////
  $ts = verify_timestamp($work_dir."eParapheur.xml", $work_dir."eParapheur.xml.tst");

  if ($ts[0] != 0) {
      PrintMessage("Erreur lors de la vrification du jeton d'horodatage");
      return;
    } else {
      echo "<br /><br /><strong>L'horodatage a t vrifi avec succs</strong>";
      $msgs = explode("\n", $ts[1]);
      foreach ($msgs As $msg) {
	  $msgTitle = explode("Time stamp:", $msg);
	  if ($msgTitle[1]) {
	      $time_stamp = $msgTitle[1];
	      echo "<br />L'horodatage a t effectu le $msgTitle[1].";
	    } // END if
	} // END foreach
    } // END if then else
} // END verif_dir()



/** envoi de l'accus de rception de l'offre
 * <ul>
 * <li>Cration du mail</li>
 * <li>Signature du mail</li>
 * <li>Envoi du mail</li>
 * </ul>
 * @ingroup offer_fct
 * @param $to_addr adresse mail de l'offreur
 * @param $ref rfrence de la consultation
 * @param $time date du jeton d'horodatage
 * @param $serial numro de srie du jeton d'horodatage
 * @return SYSTEM answer
 */
function return_receipt($to_addr, $ref, $time, $serial)
{
  $sess_id = session_id();
  $send_signed = -1;
  
    // creation du mail ////////////////////////////////////////////////////////
  $msg = "Content-Type: text/plain; charset=iso-8859-1"
  ."\nContent-Disposition: inline"
  ."\nContent-Transfer-Encoding: 8bit"
  ."\n\nAccus de rception numro : $serial\n\nMadame, Monsieur,\n\nNous accusons rception de votre offre/candidature en rponse  la consultation rference '$ref' remise le$time.\n\nNous vous remercions pour votre intrt pour cette consultation.".MAIL_SIG;

  // ATTENTION: CHANGER LE REPERTOIRE OU EST CR MSG.TXT
  // et effacer les fichiers
  $mail_file_name = TMP_DIR.$sess_id."_mail.txt";
  $fp = fopen($mail_file_name, 'w');
  if (!fwrite($fp, $msg)) {
    PrintError("Erreur lors de l'criture du mail");
    fclose($fp);
    return -1;
  } // END if
  fclose($fp);

  $subject = "\"".MAIL_SUBJECT_PREFIX." Accus de rception\"";
  $signed_mail_file_name = TMP_DIR.$sess_id."_signed_mail.txt";

    // signature du mail ///////////////////////////////////////////////////////
  $cmd = OPENSSL." smime -sign -in $mail_file_name -inkey ".SMIME_PRIV_KEY." -signer ".SMIME_CERT
    ." -certfile ".SMIME_CA_FILE." -out $signed_mail_file_name -to $to_addr -from \""
    .MAIL_FROM_ADDR."\" -subject $subject";

  system($cmd . " &> ".TMP_DIR."sign_mail_error", $sign_mail);
  if ($sign_mail != 0) {
    PrintError("Erreur lors de la signature du mail: $sign_mail");
  } // END if

    // envoi du mail ///////////////////////////////////////////////////////////
  system(ini_get('sendmail_path') ." < $signed_mail_file_name &> ".TMP_DIR."send_signed_mail_error", $send_signed);
  unlink($mail_file_name);
  unlink($signed_mail_file_name);

  return $send_signed;
} // END function return_receipt($to_addr, $ref, $time, $serial)



/** affiche le formulaire du dossier d'offre
 * @ingroup offer_fct
 */
function show_prop_form()
{
  ?>
 <input type="hidden" name="show_all_prop_form" value="0" />
    <?php
    include 'prop_form.php';
} // END function show_prop_form()

/** affiche le formulaire du dossier d'offre
 * @ingroup offer_fct
 */
function show_prop_form2()
{
  ?>
 <input type="hidden" name="show_all_prop_form" value="0" />
    <?php
    include 'prop_form2.php';
} // END function show_prop_form()


/** affiche le contenu durpertoire WORK_DIR
 * @ingroup offer_fct
 */
function show_dirs()
{
    ?>
        <SCRIPT type="text/javascript">
            /**
              * @ingroup offer_fct
              * @param DirName
              */
            function VerifySignature(DirName)
            {
                document.all.main_form.cmd.value = 'verif_dir';
                if(document.all) { //IE
                    document.all.main_form.verifDir.value = DirName;
                    document.all.main_form.submit();
                } else {
                    document.main_form.verifDir.value = DirName;
                    document.main_form.submit();
                } // END if then else
            } // END function VerifySignature(DirName)
        </SCRIPT>
    <?php
    $handle = opendir(WORK_DIR);
    if ($handle) {
        while ($file = readdir($handle)) {
            if ($file != '.' && $file != '..' && is_dir(WORK_DIR.$file)) {
                echo "<a href=\"javascript:VerifySignature('$file')\">$file</a><br>";
            } // END if
            $i++;
        } // END while
   } // END if ($handle)
} // END function show_dirs()


/** recupere le rsum d'une consultation
 * @ingroup offer_fct
 * @param $ref la rfrence de la consultation
 * @return STRING le rsum de la consultation
 */
function get_market_sum($ref)
{
  $market_query = "SELECT resume FROM Consultation WHERE reference='".$ref."' AND etat='1' AND type_procedure=".TYPE_PROCEDURE_PUBLICITE;
  $market_resp = sql_query($market_query);

  $market = mysql_fetch_array($market_resp, MYSQL_ASSOC);
  return stripslashes($market['resume']);
} // END function get_market_sum($ref)

/** recupere le rsum d'une consultation
 * @ingroup offer_fct
 * @param $code le code de la consultation restreinte
 * @return STRING la reference de la consultation
 */
function get_restreinte_ref($code)
{
echo  $ref_query = "SELECT reference FROM `Consultation` WHERE code_procedure='".addslashes($code)."' AND etat=1 AND type_procedure=".TYPE_PROCEDURE_RESTREINTE." AND TO_DAYS(dateFin) > TO_DAYS(NOW()) ";
 return;
  $ref_resp = sql_query($ref_query);
  $ref = mysql_fetch_array($ref_resp, MYSQL_ASSOC);
  //$ref=get_row_by_field('Consultation', 'code_procedure', $code);
 
  return stripslashes($ref['reference']);
} // END function get_restreinte_ref($code)

/** recupere le titre d'une consultation
 * @ingroup offer_fct
 * @param $ref la rfrence de la consultation
 * @return STRING le titre de la consultation
 */
function get_market_title($ref)
{
  $market = get_row_by_field(CONSULTATION, REFERENCE, $ref);
  return stripslashes($market['titre']);
} // END function get_market_title($ref)



/** TODO XXX
 * <ul>
 * <li>gestion des erreurs</li>
 * <li>TODO XXX</li>
 * </ul>
 * @ingroup offer_fct
 */
function reload_with_summary()
{
  require_once 'do_search_cons.php';

  if (!$_POST['refMarche2']) {
    PrintError ("Veuillez saisir la rfrence de la consultation");
    include 'prop_ref.php';
    return;
  } // END if  
  include 'prop_ref.php';

  $market_query = "SELECT fichierDossier, reference, titre, dateDebut, dateFin, categorie, resume FROM Consultation WHERE reference='".addslashes($_POST['refMarche2'])."' AND etat='1' AND type_procedure=".TYPE_PROCEDURE_PUBLICITE;
  $market_ref=show_found_cons($market_query, false);


  //$marketSummary = get_market_sum($_POST['refMarche']);
  
  if (!$market_ref) {
    echo "<b>La rfrence <em>".$_POST['refMarche2']."</em> ne correspond  aucune consultation</b>";
    $_SESSION['sess_cons']=array();
  } // END if
  /* else
    {
?>
<input type="hidden" id="refMarche" name="refMarche" value="<?php echo $market_ref;?>">
<?php
    }*/
} // END function reload_with_summary()

/** Affiche les consultations a procedure 
 * restreinte correspondant au code $_POST[code_procedure]
 * <ul>
 * <li>gestion des erreurs</li>
 * <li>TODO XXX</li>
 * </ul>
 * @ingroup offer_fct
 */
function reload_from_code_with_summary()
{
  require_once 'do_search_cons.php';
  if (!$_POST['code_procedure']) {
    PrintError ("Veuillez saisir le code de la consultation  procdure restreinte");
    include 'prop_ref.php';
    return;
  } // END if  
  include 'prop_ref.php';
  $ref_query = "SELECT fichierDossier, reference, titre, dateDebut, dateFin, categorie, resume FROM `Consultation` WHERE code_procedure='".addslashes(trim($_POST['code_procedure']))."' AND etat=1 AND type_procedure=".TYPE_PROCEDURE_RESTREINTE." AND TO_DAYS(dateFin) > TO_DAYS(NOW()) ";
  $result_ref=show_found_cons($ref_query, false);
  
  if(!$result_ref){
    echo "<br /><b>Le code d'acc&egrave;s <em>".$_POST['code_procedure']."</em> ne correspond  aucune consultation</b>";
    //$_SESSION['sess_cons']=array();
  } // END if*/
  /* else
    {
?>
<input type="hidden" id="refMarche" name="refMarche" value="<?php echo $result_ref;?>">
<?php
    }*/

  /* $ref_restreinte = get_restreinte_ref($_POST['code_procedure']);

  if (!$ref_restreinte) {
    echo "<b>Le code d'acc&egrave;s <em>".$_POST['code_procedure']."</em> ne correspond  aucune consultation</b>";
    $_SESSION['sess_cons']=array();
  } // END if*/
  //include 'prop_ref.php';

} // END function reload_with_summary()

/** vrifie si toutes les annexes se suivent
 * @ingroup offer_fct
 * @return BOOL true/false
 */
function checkAppendices($max)
{
  if ($max == 1) {
    return true;
  }
  $maxMoins1 = $max - 1;

  $nom = "fichierAnn$max";
  $nomMoins1 = "fichierAnn$maxMoins1";
  if ($_FILES[$nom]['tmp_name'] && !$_FILES[$nomMoins1]['tmp_name']) {
    return false;
  } else {
    return checkAppendices($maxMoins1);
  } // END if then else
} // END function checkAppendices($max)



/** soumission effective de DC4/DC5/dossier
 * <ul>
 * <li>gestion des erreurs de formulaire</li>
 * <li>Rcupration du certificat de la consultation</li>
 * <li>Gnration d'un passwd</li>
 * <li>Chiffrement asymtrique du passwd</li>
 * <li>stockage du passwd chiffr en BD</li>
 * <li>Chiffrement symtrique du fichier de l'offre</li>
 * <li>stockage de la date et du #serie du jeton d'horodatage</li>
 * <li>insersion du reste : DC4, DC5, offre : en BD</li>
 * </ul>
 * @ingroup offer_fct
 */
function submit_prop()
{
  $sess_id = session_id();
  if (!$_SESSION['sess_logged']) {
      PrintError ("Vous n'tes pas authentifi");
      authenticate();
      return;
    }
  // cas en principe impossible maintenant
  if ($_SESSION['sess_auth_method'] != CERT_AUTH) {
      PrintError ("Vous ne pouvez pas accder  cette fonctionnalit car vous n'tes pas authentifi par certificat");
      authenticate();
      return;
    }
  
  if (!$_SESSION['sess_cons']) {
      PrintError("Erreur lors de la rcupration de la consultation");
      include 'prop_ref.php';
      return;
    }
  
  $max_appendix = 5;
  
  if (! checkAppendices($max_appendix)) {
      PrintError("Vous devez remplir les annexes les unes  la suite des autres");
      include 'prop_form.php';
      return;
    }
  
  $prop_form_vars = array ();
  $prop_form_vars = $_SESSION['sess_prop'];
  $prop_form_vars['consultation_id'] = $_SESSION['sess_cons']['reference'];
  $prop_form_vars['entreprise_id'] = $_POST['co_id'];
  $prop_form_vars['inscrit_id'] = $_POST['subs_id'];
  $prop_form_vars['prixTotal'] = $_POST['prixTotal'];
  $prop_form_vars['mailSignataire'] = $_POST['mailSignataire'];
  if ($_POST['comment']) {
    $prop_form_vars['commentaire'] = $_POST['comment'];
  } // END if
  
//   $cfg_file = WORK_DIR . $prop_form_vars['consultation_id'];
//   if (!is_dir($cfg_file))
//     mkdir($cfg_file, 0755);
//   $cfg_file .= "/".$_POST['co_id'];
//   if (!is_dir($cfg_file))
//     mkdir($cfg_file, 0755);
  
  
  $xmlFileName = WORK_DIR . $sess_id."_eParapheur.xml";

  // write to file
  if ($_POST['xmlFile']) 
    {
      $fp = fopen ($xmlFileName, "w");  
      if (!fwrite($fp, stripslashes($_POST['xmlFile']))) 
	{
      	  PrintError("Erreur lors de l'criture du fichier XML");
      	  include 'prop_ref.php';
      	  return;
      	}
      fclose($fp);
      $dom = validate_xml_dom($xmlFileName);
      if (!$dom)
	{
	  PrintError ("Le fichier XML n'est pas conforme");
	  return;
	} // END if
      $dtd = validate_xml_dtd ($dom[0]);
      if (!$dtd)
	{
	  PrintError ("Le fichier XML n'est pas valide");
	  return;
	} // END if
    }
  else
    {
      PrintError("Le serveur ne trouve pas la signature");
      include 'prop_form.php';
      return;
    } // END if then else
  
  $prop_form_vars['signatureXML'] = $_POST['xmlFile'];
  
  if (!$_FILES['fichierPrin']['tmp_name']) {
      PrintError("Document principal manquant  votre envoi");
      include 'prop_form.php';
      return;
    }

  

  // A REACTIVER EN CAS D'ABANDON DU CHIFFREMENT  
//   $fp = fopen ($_FILES['fichierPrin']['tmp_name'], 'r');
//   $principal = fread($fp, filesize($_FILES['fichierPrin']['tmp_name']));
//   fclose($fp);
  

  // Rcupration du certificat de la consultation /////////////////////////////
    $sealing_cert = $_SESSION['sess_cons']['certificat'];
    if (!$sealing_cert) {
        PrintError("Aucun certificat de chiffrement n'a t trouv pour cette consultation");
    }
    $sealing_cert_file = "";
    if ($sealing_cert) {
        $sealing_cert_file = TMP_DIR.$sess_id."_sealing_cert.pem";
        $fp = fopen($sealing_cert_file, 'w');
            if (!fwrite($fp, $sealing_cert)) {
                echo "Impossible d'crire le certificat";
                return;
            } // END if
        fclose($fp);
    } // END if

    if ($sealing_cert_file) { // Si le certificat existe
        //gnration du mot de passe ///////////////////////////////////////////
        $pass = generate_random_password(16);
        if (!$pass) {
            PrintError("Erreur lors de la gnration du password random");
            return;
        } // END if
        // chiffrer le mot de passe en ASYMETRIQUE /////////////////////////////
        $crypted_pass = asym_cipher_data($pass, $sealing_cert_file);
        //stocker le passwd chiffr dans la base ///////////////////////////////
        $prop_form_vars['pass_crypte'] = $crypted_pass;
        // chiffrement symtrique du fichier de l'offre avec le passwd /////////
        $encrypted_data = sym_cipher_file($_FILES['fichierPrin']['tmp_name'], 'des3', $pass);
        //$encrypted_data = crypt_data($sealing_cert_file, $_FILES['fichierPrin']['tmp_name']);
        if (!$encrypted_data) {
            PrintError("Erreur lors du chiffrement du fichier principal");
            return;
        }
        $prop_form_vars['docPrincipal'] = addslashes($encrypted_data);
    } // END if ($sealing_cert_file)
  // A REACTIVER EN CAS D'ABANDON DU CHIFFREMENT  
  //   else
  //     $prop_form_vars['docPrincipal'] = addslashes($principal);
  
    if ($_FILES['fichierComp']['tmp_name']) {
        // A REACTIVER EN CAS D'ABANDON DU CHIFFREMENT  
        //       $fp = fopen ($_FILES['fichierComp']['tmp_name'], 'r');
        //       $complement = fread($fp, filesize($_FILES['fichierComp']['tmp_name']));
        //       fclose($fp);
        if ($sealing_cert_file) { // Si un certificat existe
            $encrypted_data = sym_cipher_file($_FILES['fichierComp']['tmp_name'], 'des3', $pass);
            if (!$encrypted_data) {
                PrintError("Erreur lors du chiffrement du fichier principal");
                return;
            } // END if
            $prop_form_vars['docComplement'] = addslashes($encrypted_data);
        } // END if
        // A REACTIVER EN CAS D'ABANDON DU CHIFFREMENT
        //   else
        //   $prop_form_vars['docComplement'] = addslashes($complement);
    } // END if
    $i = 1;
    while($i <= $max_appendix) {
        $appendix = "fichierAnn" . $i;
        if ($_FILES[$appendix]['tmp_name'])	{
            // $fp = fopen ($_FILES[$appendix]['tmp_name'], 'r');
            // $annexe = fread($fp, filesize($_FILES[$appendix]['tmp_name']));
            // fclose($fp);
            if ($sealing_cert_file) {// Si un certificat existe
                $encrypted_data = sym_cipher_file($_FILES[$appendix]['tmp_name'], 'des3', $pass);
                if (!$encrypted_data) {
                    PrintError("Erreur lors du chiffrement du fichier principal");
                    return;
                } // END if
                $prop_form_vars[$appendix] = addslashes($encrypted_data);
            } // END if
            // A REACTIVER EN CAS D'ABANDON DU CHIFFREMENT
            // else
            //$prop_form_vars[$appendix] = addslashes($annexe);
        } // END if
        $i ++;
    } // END while 
  
    $confirm = -1;
    $ts = timeStamp($xmlFileName); //(0, date) si tout va bien (-1, null) sinon
    if ($ts[0] == 0) {
        // recupration de la date dans le jeton
        $tsDate = $ts[1];
        // recupration du jeton d'horodatage
        $fp = fopen ($xmlFileName.".tsr", 'r');
            $timestamp = fread($fp, filesize($xmlFileName.".tsr"));
        fclose($fp);
        $prop_form_vars['horodatage'] = addslashes($timestamp);
        // recupration du numro de srie du jeton
        $serial='N/A';
        $ts_sn = read_timestamp("$xmlFileName.tsr");
        if($ts_sn[0]!=0) {
            PrintError("Erreur : impossible de lire le jeton d'horodatage");
        } else {
            preg_match('/^Serial number: (.*)/m',$ts_sn[1],$match);
            $serial=substr($match[1],2); // format 564616F8 et pas 0x564616F8
        } # END if then else
        if(isset($_POST['mailSignataire']))	{
            $confirm = return_receipt($_POST['mailSignataire'], stripslashes($_POST['consultation_id']), $tsDate, $serial);
        } // END if
        // Stockage de la date et du no de srie du jeton en BD ////////////////
        // pour redondance
        $prop_form_vars['untrustedDate']= ltrim($tsDate);
        $prop_form_vars['untrustedSerial']=$serial;
    } # END $ts[0]==0
    
    // insertion SQL en BD /////////////////////////////////////////////////////
    $insert_query = 'INSERT INTO Offre ';
    $keys = '(';
    $values = '(';
    // dc4
    foreach ($_SESSION['sess_dc4'] as $key => $value) {
        $keys .= "$key, ";
        $values .= "'$value', ";
    }
    // dc5
    foreach ($_SESSION['sess_dc5'] as $key => $value) {
        $keys .= "$key, ";
        $values .= "'$value', ";
    }
    // Dossier de l'offre
    $i = 1;
    foreach ($prop_form_vars as $key => $value) {
        $keys .= $key;
        $values .= "'$value'";
        if ($i < count ($prop_form_vars)) {
            $keys .= ', ';
            $values .= ', ';
        }
        $i++;
    } // END foreach

    $keys .= ')';
    $values .= ')';
    $insert_query .= "$keys \nVALUES $values\n;";
    $res = sql_query($insert_query);
    if ($res) {
        echo "Votre offre a bien t enregistre<br><br>";
    }
    if ($confirm == 0) {
        echo "Vous allez bientt recevoir un mail de confirmation  l'adresse <strong>".$_POST['mailSignataire']."</strong><br/><br/>";
    }
    echo "Nous vous remercions pour votre intrt pour cette consultation<br><br>";
    echo "<a href=\"javascript:ActivateMenu('get_main_page')\">Retour  la page d'accueil</a>";

    @unlink ($xmlFileName);
    @unlink ($xmlFileName.".tsr");
} // END function submit_prop()


/** soumission effective des 2 enveloppes
 * <ul>
 * <li>gestion des erreurs de formulaire</li>
 * <li>Rcupration du certificat de la consultation</li>
 * <li>Gnration d'un passwd</li>
 * <li>Chiffrement asymtrique du passwd</li>
 * <li>stockage du passwd chiffr en BD</li>
 * <li>Chiffrement symtrique du fichier de l'offre</li>
 * <li>stockage de la date et du numero de serie du jeton d'horodatage</li>
 * <li>insersion du reste : DC4, DC5, offre : en BD</li>
 * </ul>
 * @ingroup offer_fct
 */
function submit_prop2()
{

  $sess_id = session_id();
  if (!$_SESSION['sess_logged']) {
      PrintError ("Vous n'tes pas authentifi");
      authenticate();
      return;
    }
  // cas en principe impossible maintenant
  if ($_SESSION['sess_auth_method'] != CERT_AUTH) {
      PrintError ("Vous ne pouvez pas accder  cette fonctionnalit car vous n'tes pas authentifi par certificat");
      authenticate();
      return;
    }
  
  if (!$_SESSION['sess_cons']) {
      PrintError("Erreur lors de la rcupration de la consultation");
      include 'prop_ref.php';
      return;
    }
   
  $prop_form_vars = array ();
  $prop_form_vars = $_SESSION['sess_prop'];
  $prop_form_vars['consultation_id'] = $_SESSION['sess_cons']['reference'];
  $prop_form_vars['entreprise_id'] = $_POST['co_id'];
  $prop_form_vars['inscrit_id'] = $_POST['subs_id'];


  $prop_form_vars['mailSignataire'] = $_POST['mailSignataire'];
  if ($_POST['comment']) {
    $prop_form_vars['commentaire'] = $_POST['comment'];
  } // END if
  
  

  $xmlFileName = WORK_DIR.$sess_id."_signature.xml";

  // write to file
  if ($_POST['signEnvXml']) 
    {
      $fp = fopen ($xmlFileName, "w");  
      if (!fwrite($fp, stripslashes($_POST['signEnvXml']))) 
	{
      	  PrintError("Erreur lors de l'criture du fichier XML");
      	  include 'prop_form2.php';
      	  return;
      	}
      fclose($fp);
      $dom = validate_xml_dom($xmlFileName);
      if (!$dom)
	{
	  PrintError ("Le fichier XML n'est pas conforme");
	  return;
	} // END if
      $dtd = validate_xml_dtd ($dom[0]);
      if (!$dtd)
	{
	  PrintError ("Le fichier XML n'est pas valide");
	  return;
	} // END if
      
      // Verification des signatures
      $signatures = $dom[0]->get_elements_by_tagname('Signature');
      for ($sign_index = 0; $sign_index < $_SESSION['sess_cons']['nbr_enveloppes']; $sign_index ++)
	{
	  $signature_env = $signatures[$sign_index]->get_content();
	  if (verify_certificate($signature_env, $sess_id) != 0)
	    {
	      PrintMessage("Votre offre n'a pas &eacute;t&eacute; enregistr&eacute;e car votre certificat de
signature n'a pas pu &eacute;tre v&eacute;rifi&eacute;.");
	      include 'prop_form2.php';
	      return ;
	    }
	}
    }
  else
    {
      PrintError("Le serveur ne trouve pas la signature");
      include 'prop_form2.php';
      return;
    } // END if then else
  
  $prop_form_vars['signatureEnvXML'] = $_POST['signEnvXml'];
  
  if($_SESSION['sess_cons']['nbr_enveloppes']==2)
    {
      if (!$_FILES['fichierPrin1']['tmp_name']||!$_FILES['fichierPrin2']['tmp_name']) {
	PrintError("Une des deux enveloppes manque  votre envoi");
	include 'prop_form2.php';
	return;
      }
    }
  
  elseif($_SESSION['sess_cons']['nbr_enveloppes']==1)
    {
      if (!$_FILES['fichierPrin1']['tmp_name']) {
	PrintError("L'enveloppe manque  votre envoi");
	include 'prop_form2.php';
	return;
      }
    }
  
  $prop_form_vars['nom_fichier_1'] = $_FILES['fichierPrin1']['name'];
  $prop_form_vars['nom_fichier_2'] = $_FILES['fichierPrin2']['name'];

 

   /*---------------ON NE CHIFFRE PAS LES FICHIERS--------------------*/
   $fp = fopen ($_FILES['fichierPrin1']['tmp_name'], 'r');
   $enveloppe_1 = fread($fp, filesize($_FILES['fichierPrin1']['tmp_name']));
   fclose($fp);

   if($_SESSION['sess_cons']['nbr_enveloppes']==2)
     {
       $fp2 = fopen ($_FILES['fichierPrin2']['tmp_name'], 'r');
       $enveloppe_2 = fread($fp2, filesize($_FILES['fichierPrin2']['tmp_name']));
       fclose($fp2);
     }
  
   //Recuperation des donnees cryptees
   if(!$_POST['encryptFile1'])
     {
       PrintError("Le fichier 1 n'a pas ete crypte");
       return;
     }
   else
     {
       $encrypted_data1 = $_POST['encryptFile1'];
       $prop_form_vars['enveloppe_1'] = $encrypted_data1;
     }
   if($_SESSION['sess_cons']['nbr_enveloppes']==2)
     {
       if(!$_POST['encryptFile2'])
	 {
	   PrintError("Le fichier 2 n'a pas ete crypte");
	   return;
	 }
       else
	 {
	   $encrypted_data2 = $_POST['encryptFile2'];
	   $prop_form_vars['enveloppe_2'] = $encrypted_data2;
	 }
     }
   //Recuperation du fichier xml crypte
   if(!$_POST['xmlFile'])
     {
       PrintError("Le fichier xml n'a pas ete crypte");
       return;
     }
   else
     {
       $encrypted_xml = $_POST['xmlFile'];
       $prop_form_vars['signatureXML'] = $encrypted_xml;
     }
   



	/*------------------------FIN CAS AVEC 2 ENVELOPPES----------------------------*/

   //SI CHIFFREMENT   } // END if ($sealing_cert_file)
  // A REACTIVER EN CAS D'ABANDON DU CHIFFREMENT  
  //   else
  //     $prop_form_vars['docPrincipal'] = addslashes($principal);
  
    
  
    $confirm = -1;
    $ts = timeStamp($xmlFileName); //(0, date) si tout va bien (-1, null) sinon
    if ($ts[0] == 0)
      {
        // recupration de la date dans le jeton
        $tsDate = $ts[1];
        // recupration du jeton d'horodatage
        $fp = fopen ($xmlFileName.".tsr", 'r');
	$timestamp = fread($fp, filesize($xmlFileName.".tsr"));
        fclose($fp);
        $prop_form_vars['horodatage'] = $timestamp;
        // recupration du numro de srie du jeton
        $serial='N/A';
        $ts_sn = read_timestamp("$xmlFileName.tsr");
        if($ts_sn[0]!=0)
	  {
            PrintError("Erreur : impossible de lire le jeton d'horodatage");
	    return;
	  }
	else
	  {
            preg_match('/^Serial number: (.*)/m',$ts_sn[1],$match);
            $serial=substr($match[1],2); // format 564616F8 et pas 0x564616F8
	  } // END if then else
	if(isset($_POST['mailSignataire']))
	  {
            $confirm = return_receipt($_POST['mailSignataire'], stripslashes($_SESSION['sess_cons']['reference']), $tsDate, $serial);
	  } // END if
        // Stockage de la date et du no de srie du jeton en BD ////////////////
        // pour redondance
	//        $prop_form_vars['untrustedDate']= ltrim($tsDate);
        $prop_form_vars['untrustedSerial']=$serial;
      } // END $ts[0]==0

    // Si l'horodatage echoue, on accepte l'offre quand meme
    $prop_form_vars['untrustedDate']= date('d/m/Y H:i');
    //$prop_form_vars['untrustedSerial']=;


    // insertion SQL en BD /////////////////////////////////////////////////////
    $insert_query = 'INSERT INTO Offre ';
    $keys = '(';
    $values = '(';
    
    // Dossier de l'offre
    $i = 1;
    foreach ($prop_form_vars as $key => $value)
      {
        $keys .= $key;
        $values .= "'".addslashes($value)."'";
        if ($i < count ($prop_form_vars))
	  {
	    $keys .= ', ';
            $values .= ', ';
	  }
        $i++;
      } // END foreach

    $keys .= ')';
    $values .= ')';
    $insert_query .= "$keys \nVALUES $values\n;";
    

    $res = sql_query($insert_query);
    if ($res)
      {
        echo "Votre offre a bien t enregistre<br><br>";
      }
    if ($confirm == 0)
      {
        echo "Vous allez bientt recevoir un mail de confirmation  l'adresse <strong>".$_POST['mailSignataire']."</strong><br/><br/>";
      }
    echo "Nous vous remercions pour votre intrt pour cette consultation<br><br>";
    echo "<a href=\"javascript:ActivateMenu('get_main_page')\">Retour  la page d'accueil</a>";

    @unlink ($xmlFileName);
    @unlink ($xmlFileName.".tsr");
} // END function submit_prop()



/** Chiffre le fichier $data_file avec la cl publique du certificat $cert_file_name ???? XXX TODO
 * @ingroup offer_fct
 * retourne une chane crypte ou une chane vide
 * @param $cert_file_name chemin du certificat de chiffrement
 * @param $data_file chemin du fichier  crypter
 * @param $password le mot de passe
 * @return une chane crypte ou une chane vide
 */
function crypt_offer_file($cert_file_name, $data_file, $password)
{
  return  sym_cipher_data($data_file, $des3, $password);
}



/** Chiffre le fichier $data_file avec la cl publique du certificat $cert_file_name
 * @ingroup offer_fct
 * retourne une chane crypte ou une chane vide
 * @param $cert_file_name chemin du certificat de chiffrement
 * @param $data_file chemin du fichier  crypter
 * @return une chane crypte ou une chane vide
 */
function crypt_data($cert_file_name, $data_file)
{
  $sess_id = session_id();
  $encrypted_file = TMP_DIR.$sess_id."_encrypted_data";
  $crypt = OPENSSL ." smime -encrypt -in  $data_file -out $encrypted_file $cert_file_name"; //-des3
  system($crypt . "&> ".TMP_DIR."encrypt_error", $crypt_result);

  if ($crypt_result == 0)
    {
//       $fp = fopen($encrypted_file, 'r');
//       $result = fread($fp, filesize($encrypted_file));
//       fclose($fp);
      $pkcs7_file = $encrypted_file."pkcs7";
      $pkcs7 = OPENSSL ." smime -pk7out -in  $encrypted_file -out $pkcs7_file "; //-des3
      system($pkcs7 . "&> ".TMP_DIR."convert_encrypt_error", $convert_result);
      $result = '';
      if ($convert_result == 0)
	{
	  $fp = fopen($pkcs7_file, 'r');
	  $result = fread($fp, filesize($pkcs7_file));
	  fclose($fp);
	}
      unlink($pkcs7_file);
      unlink($encrypted_file);
      return $result;
    }
  else
    {
      PrintError("Erreur lors du chiffrement");
    }
  return '';
} // END function crypt_data($cert_file_name, $data_file)



/** Chiffre le fichier $data_file avec l'algorithme symtrique $algo
 * en utilisant le mot de passe $pwd
 * @ingroup offer_fct
 * retourne une chane crypte ou une chane vide
 * @param $data_file chemin du fichier  crypter
 * @param $algo algorithme de chiffrement symtrique
 * @param $pwd password de gnration de cl
 * @return une chane crypte ou une chane vide
 */
function sym_cipher_file($data_file, $algo, $pwd)
{
  $sess_id = session_id();
  $encrypted_file = TMP_DIR.$sess_id."_sym_cipher_file";
  $crypt = OPENSSL ." des -e -in $data_file -out $encrypted_file -k $pwd"; //des3
  system($crypt . "&> ".TMP_DIR."sym_cipher_error", $crypt_result);

  if ($crypt_result == 0)
    {
      $fp = fopen($encrypted_file, 'r');
      $result = fread($fp, filesize($encrypted_file));
      fclose($fp);
      @unlink($encrypted_file);
      return $result;
    }
  return "";
}


/** Chiffre la chane $instring avec le certificat 
 * @ingroup offer_fct
 * @param $instring
 * @param $cert
 * @return STRING chane crypte ou vide
 */
function asym_cipher_data($instring, $cert)
{
  $sess_id = session_id();
  $tmp_file_name = TMP_DIR.$sess_id."_tmp_clear_file";
  $fp = fopen($tmp_file_name, 'w');
  if (!fwrite($fp, $tmp_file_name))
    {
      PrintError ("Erreur lors de l'criture du mot de passe de chiffrement");
      return;
    }
  fclose($fp);
  $result = crypt_data ($cert, $tmp_file_name);
  @unlink ($tmp_file_name);
  return $result;
}


/** calcule une chane pseudo-alatoire de taille $len octets
 * @ingroup offer_fct
 * retourne une chane de taille $len octets si l'opration a russi, une chane vide sinon
 * @param $len longueur de la chane de retour (en octets)
 * @return une chane de taille $len octets si l'opration a russi, une chane vide sinon
 */
function generate_random_password($len)
{
  $sess_id = session_id();
  $random_output = TMP_DIR."random_gen_output";
  $random_error = TMP_DIR."random_gen_error";
  $rand = OPENSSL ." rand -base64 -out $random_output $len";
  system($rand . "&> ".$random_error, $rand_result);

  if ($rand_result == 0)
    {
      $fp = fopen($random_output, 'r');
      $result = fread($fp, filesize($random_output));
      fclose($fp);
      //@unlink($random_output);
      return $result;
    }
  return "";
  
}              



/** calcule le jeton d'horodatage de $infile et le cre dans $outfile (= $infile.tsr par dfaut)
 * @ingroup offer_fct
 * retourne un tableau contenant le status de l'horodatage (0 si OK) et ventuellement la date de l'horodatage
 * @param $infile chemin du fichier  timestamper
 * @return un tableau contenant le status de l'horodatage (0 si OK) et ventuellement la date de l'horodatage
 */
function timeStamp($infile)
{
  $sess_id = session_id();

  $ts_verify = -1;
  $query = OPENSSL . " ts -query -data $infile -cert -out $infile.tsq";
  system($query . " &> /tmp/tsq_error", $ts_query);

  if ($ts_query != 0)
    {
      PrintError("Erreur lors de la cration de la requte d'horodatage");
      return array($ts_query, NULL);
    }

  //  $reply = OPENSSL . " ts -reply -queryfile $infile.tsq -config " . OPENSSL_CONFIG . " -passin file:" . TS_PRIV_KEY_PASS . " -out $infile.tsr -section " . TSA_SECTION;
  $reply = OPENSSL . " ts -reply -queryfile $infile.tsq -config " . OPENSSL_CONFIG . " -out $infile.tsr -section " . TSA_SECTION;
  system($reply . " &> /tmp/tsr_error", $ts_reply);

  if ($ts_reply != 0)
    {
      PrintError("Erreur lors de la cration du jeton d'horodatage");
      return array($ts_reply, NULL);
    }

  $verify = OPENSSL . " ts -verify -data $infile -in $infile.tsr -CAfile " . TS_CAFILE;

  system($verify . " &> /tmp/".$sess_id."_tsv_error", $ts_verify);
  if ($ts_verify != 0)
    {
     
      PrintError("Erreur lors de la vrification du jeton d'horodatage");
      return array($ts_verify, NULL);
    }
  
  // rcupration de la date
  $text = OPENSSL . " ts -reply -data $infile -in $infile.tsr -text";
  system($text . " &> ".$infile.".tst", $ts_text);
  if ($ts_text != 0)
    {
      PrintError("Echec lors de la rcupration de la date d'horodatage");
      return array ($ts_text, NULL);
    }
  
  $fp = fopen($infile.'.tst', 'r');
  $res = fread($fp, filesize($infile.'.tst'));
  fclose($fp);
  
  $time_stamp = "";
  $msgs = explode("\n", $res);
  foreach ($msgs As $msg)
    {
      $msgTitle = explode("Time stamp:", $msg);
      if ($msgTitle[1])
	{
	  $time_stamp = $msgTitle[1];
	}
  
    }
  unlink($infile.".tst");
  unlink($infile.".tsq");
  return array($ts_verify, $time_stamp);
}
?>
