/*
Copyright (C) 2004 ATEXO Local Trust MPE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For more information on our product, please contact MPE@atexo.com
*/
/**
 * @name EstSirenValide
 * 
 * @param   Le code SIREN dont on veut vrifier la validit.
 * 
 * @return   Un boolen qui vaut 'true' si le code SIREN pass en 
 *                           paramtre est valide, false sinon.
 */
function EstSirenValide() {
  var estValide;
  var siren;
  if(document.all)
	siren = document.all.main_form.siren.value;
  else
	siren = document.main_form.cmd.value;

    if ( (siren.length != 9) || (isNaN(siren)) )	
	ActivateMenu('show_subs_insc_form2');
    else {
      // Donc le SIREN est un numrique  9 chiffres
      var somme = 0;
      var tmp;
      for (var cpt = 0; cpt<siren.length; cpt++) {
        if ((cpt % 2) == 1) { // Les positions paires : 2me, 4me, 6me et 8me chiffre
          tmp = siren.charAt(cpt) * 2; // On le multiplie par 2
          if (tmp > 9) 
            tmp -= 9;  // Si le rsultat est suprieur  9, on lui soustrait 9
        }
        else
          tmp = siren.charAt(cpt);
        somme += parseInt(tmp);
      }
      if ((somme % 10) == 0)
//        estValide = true;  // Si la somme est un multiple de 10 alors le SIREN est valide 
	ActivateMenu('show_subs_insc_form2');
      else
{
//        estValide = false;
	alert("SIREN Invalide");

}
    }
  }
	

/** active le formulaire
 * @ingroup form_js
 * @param MenuName nom de la commande d'activation
 * @return void
 */
function ActivateMenu(MenuName) {
  if(document.all) { //IE
    document.all.main_form.cmd.value = MenuName;
    document.all.main_form.submit();
  } else {
    document.main_form.cmd.value = MenuName;
    document.main_form.submit();
  }
} // end function ActivateMenu(MenuName)



/** active le formulaire
 * @ingroup form_js
 * @param MenuName nom de la commande d'activation
 * @return void
 */
function ActivateMenu2(MenuName) {
  if(document.all) { //IE
    document.all.main_form.cmd.value = MenuName;
  } else {
    document.main_form.cmd.value = MenuName;
  }
} // end function ActivateMenu(MenuName)


/** active le formulaire de recherche
 * @ingroup form_js
 * @param MenuName nom de la commande d'activation
 * @return void
 */
function ActivateSearch(MenuName) {
  if(document.all) { //IE
  	document.all.main_form.recherche.value = "1";
	} else {
  	document.main_form.recherche.value = "1";
	}
	ActivateMenu(MenuName);
}

/** Affiche les resultats a partir de nb sur la page Page
 * @ingroup form_js
 * @param Page page ds laquelle on doit afficher les resultats
 * @param Nb
 * @param Displayed numero de la page courante affichee
 * @return void
 */
function ShowPageResult(Page, Displayed) {
if(document.all) { //IE
if(Page=='search_cons' || Page=='search_managed_valid_cons')
  	document.all.main_form.recherche.value = "1";
    document.all.main_form.cmd.value = Page;
    document.all.main_form.displayed.value = Displayed;
    document.all.main_form.submit();
  } else {
if(Page=='search_cons')
  	document.main_form.recherche.value = "1";
    document.main_form.cmd.value = Page;
    document.main_form.displayed.value = Displayed;
    document.main_form.submit();
  }
}

/** Affiche les resultats precedents sur la page Page
 * @ingroup form_js
 * @param Page page ds laquelle on doit afficher les resultats
 * @return void
 */
function ShowPrev(Page) {
  if(document.all) { //IE
    document.all.main_form.cmd.value = Page;
    document.all.main_form.display.value = 'previous';
    document.all.main_form.submit();
  } else {
    document.main_form.cmd.value = Page;
    document.main_form.display.value = 'previous';
    document.main_form.submit();
  }
} // end function ShowPrev(Page)

/** Affiche les resultats suivants sur la page Page
 * @ingroup form_js
 * @param Page page ds laquelle on doit afficher les resultats
 * @return void
 */
function ShowNext(Page) {
  if(document.all) { //IE
    document.all.main_form.cmd.value = Page;
    document.all.main_form.display.value = 'next';
    document.all.main_form.submit();
  } else {
    document.main_form.cmd.value = Page;
    document.main_form.display.value = 'next';
    document.main_form.submit();
  }
} // end function ShowNext(Page)

/** active le menu pour faire une offre à une consultation
 * @ingroup offer_fct
 * @ingroup form_js
 * @param Reference STRING la référence de la consultation
 * @return XXX
 * @see do_search_cons.php
 */
function ValidateRef (Reference)
{
	if (document.all)
	{
		document.all.main_form.prop_form.value = "1"
		document.all.main_form.refMarche.value = Reference
	}
	else
	{
		document.main_form.prop_form.value = "1"
		document.main_form.refMarche.value = Reference
	}
	ActivateMenu ('validate_ref')
} // end function ValidateRef(Reference)



/** efface certains champs du formulaire
 * <br>efface les champs :
 * <ul>
 *   <li>INPUT type=text</li>
 *   <li>SELECT</li>
 *   <li></li>
 * </ul>
 * @ingroup form_js
 * @param nameForm nom du formulaire
 * @return VOID
 * @see tous les formulaires
 */
function wipeForm(nameForm) {
	var formSize = nameForm.length;
	for (var i=0 ; i<formSize ; i++) {
		var elem = nameForm.elements[i];
		var type = elem.type;
		if (type=='text' || type=='select-one') {
			elem.value='';
		} else {
			if (type != 'hidden') {
//				alert('NAME:'+elem.name+'| TYPE:'+type+'| VALUE:'+elem.value+'|');
			} // end if
		}
	} //end for i<formSize
	return;
} // end function (_nameForm)


/**
 * Cette fonction permet d'afficher un message de confirmation 
 * d'une action donnee en redirigeant vers confirm_action.php
 * @param msg : type de l'action
 * @ingroup form_js
 */
function confirmAction(msg)
{
	if (document.all) //IE
	   {
		document.all.main_form.cmd.value = "confirm_action";
		document.all.main_form.cfm_msg.value=msg;
		document.all.main_form.submit();
	   }	
	else
	   {
		document.main_form.cmd.value = "confirm_action";
   		document.main_form.cfm_msg.value=msg;
		document.main_form.submit();
	   }	
}

/**
 * Cette fonction permet d'afficher une dialogbox de confirmation 
 * d'une action donnee en redirigeant (si confirm==true) vers la page redirectPage
 * @param msg : type de l'action
 * @ingroup form_js
 */
function confirmChoice(msg, redirectPage)
{
	var choice;
	choice = confirm(msg+" ?");
	if (document.all) //IE
	   {	
		if(choice)
		{
			document.all.main_form.cmd.value = redirectPage;
			document.all.main_form.submit();
		}
		else
			return;
	   }	
	else
	   {
		if(choice)
		{
			document.main_form.cmd.value = redirectPage;
			document.main_form.submit();
		}
		else
			return;
	   }	
}

/** sert pour l'affichage des annexes dans le prop_form.phpp
 * @ingroup javascript
 *
 */
var annexeId=2;

/** ajoute une ligne de input dans la partie "ajout d'annexes".
 * @ingroup javascript
 * @param itemId id de l'élément HTML
 * @return VOID
 */
function addAppendix(itemId) {
  if (!document.getElementById) {
    return;
  }
	
	var curr =  "annexe"+annexeId;
  if (document.getElementById(curr).style.display=="none") {
    document.getElementById(curr).style.display = "";
	}

	if (annexeId==5) {
		document.getElementById('ajoutAnnexe').style.display='none';
	}
	
  annexeId++;
	return;
}

/**
 * Sert au téléchargement di fichier FileName
 * @ingroup form_js
 */
function DownloadFile (FileName, OfferId, DocType)
{
	var oldAction;
	if(document.all) 
	    { //IE
		oldAction = document.all.main_form.action;
		document.all.main_form.action = "stream_file.php";
		document.all.main_form.fileName.value = FileName;
		document.all.main_form.offerId.value = OfferId;
		document.all.main_form.docType.value = DocType;
		document.all.main_form.submit();
		document.all.main_form.action = oldAction;
	
      	   } 
	else 
	   {
		oldAction = document.main_form.action;
		document.main_form.action = "stream_file.php";
		document.main_form.fileName.value = FileName;
		document.main_form.offerId.value = OfferId;
		document.main_form.docType.value = DocType;
		document.main_form.submit();
		document.main_form.action = oldAction;
      	  }
 }

function DownloadConsFile(Ref)
{
	var oldAction;
	if(document.all) 
	    { //IE
		oldAction = document.all.main_form.action;
		document.all.main_form.action = "download_cons.php";
		document.all.main_form.cons_ref.value = Ref;
		document.all.main_form.submit();
		document.all.main_form.action = oldAction;
   	   } 
	else 
	   {	
		oldAction = document.main_form.action;
		document.main_form.action = "download_cons.php";
		document.main_form.cons_ref.value = Ref;
		document.main_form.submit();
		document.main_form.action = oldAction;
      	  }
}


/**
 * Sert au sert au decryptage de l'enveloppe EnveloppeNb pour l'offre OffreId
 * @ingroup form_js
 */
function SetDecrypt (EnveloppeNb, OfferId, NbrEnv) 
{
	if(document.all) 
	    { //IE
		document.all.main_form.cmd.value = 'decrypt_offer_file';
	
		document.all.main_form.enveloppeId.value = EnveloppeNb;
		document.all.main_form.offerId.value = OfferId;
		document.all.main_form.nbrElmt.value = NbrEnv;
		document.all.main_form.submit();
	
      	   } 
	else 
	   {
		document.main_form.cmd.value = 'decrypt_offer_file';
	
		document.main_form.enveloppeId.value = EnveloppeNb;
		document.main_form.offerId.value = OfferId;
		document.main_form.nbrElmt.value = NbrEnv;
		document.main_form.submit();
      	  }
}

/**
 * Sert au sert au decryptage de l'enveloppe EnveloppeNb pour l'offre OffreId
 * @ingroup form_js
 */
function SetVerify (EnveloppeNb, OfferId) 
{
	if(document.all) 
	    { //IE
		document.all.main_form.cmd.value = 'verify_signature';
	
		document.all.main_form.enveloppeId.value = EnveloppeNb;
		document.all.main_form.offerId.value = OfferId;
		document.all.main_form.submit();
	
      	   } 
	else 
	   {
		document.main_form.cmd.value = 'verify_signature';
	
		document.main_form.enveloppeId.value = EnveloppeNb;
		document.main_form.offerId.value = OfferId;
		document.main_form.submit();
      	  }
}

/**
 * Sert au sert a la suppression de l'enveloppe 2 pour l'offre OfferId
 * @ingroup form_js
 */
function SetDelete (OfferId) 
{
	if(document.all) 
	    { //IE
		document.all.main_form.cmd.value = 'delete_offer';
	
		document.all.main_form.offerId.value = OfferId;
		document.all.main_form.submit();
	
      	   } 
	else 
	   {
		document.main_form.cmd.value = 'delete_offer';

		document.main_form.offerId.value = OfferId;
		document.main_form.submit();
      	  }
}

/**
 * Sert a la suppression de l'enveloppe 2
 * @ingroup form_js
 */
function DeleteEnv (OfferId) 
{	
	var mssg;
	mssg = "Etes-vous certain de vouloir supprimer la seconde enveloppe de l'offre "+OfferId;

	if(document.all) 
	    { //IE
		//document.all.main_form.cmd.value = 'delete_enveloppe';
	
		document.all.main_form.id_offre.value = OfferId;
		confirmChoice(mssg, "do_delete_enveloppe");
		//document.all.main_form.submit();
      	   } 
	else 
	   {
		//document.main_form.cmd.value = 'do_delete_enveloppe';

		document.main_form.id_offre.value = OfferId;
		confirmChoice(mssg, "do_delete_enveloppe");
		//document.main_form.submit();
      	  }
}

/**
 * Sert a la restauration de l'enveloppe 2
 * @ingroup form_js
 */
function RestoreEnv (OfferId) 
{
	if(document.all) 
	    { //IE
		document.all.main_form.cmd.value = 'restore_enveloppe';
	
		document.all.main_form.id_offre.value = OfferId;
		document.all.main_form.submit();
	
      	   } 
	else 
	   {
		document.main_form.cmd.value = 'restore_enveloppe';

		document.main_form.id_offre.value = OfferId;
		document.main_form.submit();
      	  }
}

/**
 * Sert a la suppression d'un utilisateur interne
 * @ingroup form_js
 */
function DeleteInterne (InterneId) 
{
	confirmSupp = confirm("Etes-vous certain de vouloir supprimer cet utilisateur interne ?");
	if (! confirmSupp)
	{
		return;
	}	
	if(document.all) 
	    { //IE
		document.all.main_form.cmd.value = 'delete_interne';
	
		document.all.main_form.interneId.value = InterneId;
		document.all.main_form.submit();
	
      	   } 
	else 
	   {
		document.main_form.cmd.value = 'delete_interne';

		document.main_form.interneId.value = InterneId;
		document.main_form.submit();
      	  }
}

/**
 * Sert a l'activation d'un compte interne
 * @ingroup form_js
 */
function ActivateInterne (InterneId) 
{
	if(document.all) 
	    { //IE
		document.all.main_form.cmd.value = 'activer_interne';
	
		document.all.main_form.interneId.value = InterneId;
		document.all.main_form.submit();
	
      	   } 
	else 
	   {
		document.main_form.cmd.value = 'activer_interne';

		document.main_form.interneId.value = InterneId;
		document.main_form.submit();
      	  }
}

/**
 * Sert a la suppression d'un utilisateur externe
 * @ingroup form_js
 */
function DeleteExterne (ExterneId) 
{
	confirmSupp = confirm("Etes-vous certain de vouloir supprimer cet utilisateur externe ?");
	if (! confirmSupp)
	{
		return;
	}	
	if(document.all) 
	    { //IE
		document.all.main_form.cmd.value = 'delete_externe';
	
		document.all.main_form.externeId.value = ExterneId;
		document.all.main_form.submit();
	
      	   } 
	else 
	   {
		document.main_form.cmd.value = 'delete_externe';

		document.main_form.externeId.value = ExterneId;
		document.main_form.submit();
      	  }
}

/**
 * Sert au sert a la suppression d'un consultation en attente de validation
 * @ingroup form_js
 */
function DeleteCons (ConsId) 
{
	if(document.all) 
	    { //IE
		document.all.main_form.cmd.value = 'delete_waiting_cons';
	
		document.all.main_form.cons_ref.value = ConsId;
		document.all.main_form.submit();
	
      	   } 
	else 
	   {
		document.main_form.cmd.value = 'delete_waiting_cons';

		document.main_form.cons_ref.value = ConsId;
		document.main_form.submit();
      	  }
}


/**
 * Sert au téléchargement di fichier FileName
 * @ingroup form_js
 */
function DownloadFile2 (FileName, OfferId, DocType)
{
	var oldAction;
	if(document.all) 
	    { //IE
		oldAction = document.all.main_form.action;
		document.all.main_form.action = "stream_file2.php";
		document.all.main_form.fileName.value = FileName;
		document.all.main_form.offerId.value = OfferId;
		document.all.main_form.docType.value = DocType;
		document.all.main_form.submit();
		document.all.main_form.action = oldAction;
	
      	   } 
	else 
	   {
		oldAction = document.main_form.action;
		document.main_form.action = "stream_file2.php";
		document.main_form.fileName.value = FileName;
		document.main_form.offerId.value = OfferId;
		document.main_form.docType.value = DocType;
		document.main_form.submit();
		document.main_form.action = oldAction;
      	  }
 }

/** retourne à la page précédente
 * @ingroup form_js
 * @return void
 */
function BackPage() {
  if(document.all) { //IE
    document.all.main_form.cmd.value = 'back_page';
    document.all.main_form.back.value = '1';
    document.all.main_form.submit();
  } else {
    document.main_form.cmd.value = 'back_page';
    document.main_form.back.value = '1';
    document.main_form.submit();
  }
} // end function BackPage

/** Réexecute la fonction fct en ordonnant par field 
 * @ingroup form_js
 * @param fct fonction à executer
 * @param field nom du champ par lequel on ordonne la table
 * @return void
 */
function ReplayWithOrder(fct, field) {
  if(document.all) { //IE
    document.all.main_form.cmd.value = fct;
    document.all.main_form.order_by_field.value = field;
    document.all.main_form.submit();
  } else {
    document.main_form.cmd.value = fct;
    document.main_form.order_by_field.value = field;
    document.main_form.submit();
  }
} // end function ReplayWithOrder


function ValidateCons(ref)
{
  if(document.all) { //IE
    document.all.main_form.cmd.value = 'validate_cons';
    document.all.main_form.cons_ref.value = ref;
    document.all.main_form.submit();
  } else {
    document.main_form.cmd.value = 'validate_cons';
    document.main_form.cons_ref.value = ref;
    document.main_form.submit();
  }
}

function ValidateCons2(env, ref )
{
  if(document.all) { //IE
    document.all.main_form.cons_ref_env.value = env;

  } else {

    document.main_form.cons_ref_env.value = env;

  }
  ValidateCons(ref);
}

function FollowOffers(ref)
{
  if(document.all) { //IE
    document.all.main_form.cmd.value = 'show_synthese_cons';
    document.all.main_form.cons_ref.value = ref;
    document.all.main_form.submit();
  } else {
    document.main_form.cmd.value = 'show_synthese_cons';
    document.main_form.cons_ref.value = ref;
    document.main_form.submit();
  }
}

function OpenCons(ref)
{
  if(document.all) { //IE
    document.all.main_form.cmd.value = 'download_decrypt_cons';
    document.all.main_form.cons_ref.value = ref;
    document.all.main_form.submit();
  } else {
    document.main_form.cmd.value = 'download_decrypt_cons';
    document.main_form.cons_ref.value = ref;
    document.main_form.submit();
  }
}


function ShowOfferFiles(ref)
{
  if(document.all) { //IE
    document.all.main_form.cmd.value = 'show_offer_files';
    document.all.main_form.offer_ref.value = ref;
    document.all.main_form.submit();
  } else {
    document.main_form.cmd.value = 'show_offer_files';
    document.main_form.offer_ref.value = ref;
    document.main_form.submit();

  }
}

/** renvoie dans des INPUT hidden du FORM principal les champs cochés
 * @ingroup admin_fct
 * @param satelliteForm nom du petitFORM
 * @param mainForm nom du FORM mère
 * @return VOID
 */
function validateInternes(satelliteForm, divName, publisherId)
{
	var form = document.forms.namedItem(satelliteForm) ;
	var formLength = form.length;
	var isAtLeastOneInterneSelected = 0;
	for (var i=0; i<formLength; i++) {
		var elem = form.elements[i];
		var interneId = elem.name;
		if (elem.type=='checkbox') {
                   if (elem.checked) {
			// On supprime tout les internes du parentdoc
			teleRemoveInterne (interneId);
			var interneDroit;
                        isAtLeastOneInterneSelected += 1;
			
			var tdsInterne = elem.parentNode.parentNode.cells;
			var interneName = tdsInterne.item(1).childNodes.item(0).data;
			var interneMail = tdsInterne.item(2).childNodes.item(0).href;
			var interneDroit1 = tdsInterne.item(3).childNodes.item(0);
			var interneDroit2 = tdsInterne.item(4).childNodes.item(0);
			
			if (interneDroit1.checked)
			   interneDroit = interneDroit1.value;
			else if(interneDroit2.checked)
			   interneDroit = interneDroit2.value;
			if(interneId==publisherId)
		  	   interneDroit = 3;

			interneMail = interneMail.replace(/^mailto:/,'');
			interneMail = interneMail.replace(/\?.*$/,'');
			
			// on a recupéré les INPUT checkbox du FORM "internes" qui ont été cochés
			var parentDocument = window.opener.document;
			var div = parentDocument.getElementById(divName);
			var testTable = parentDocument.getElementById(interneId);
			if (testTable!= null && testTable.tagName=='TABLE') {
				continue;
			}
			var table = parentDocument.createElement('TABLE');
			table.setAttribute('id',interneId);
			table.setAttribute('class','gestionnaires');
			var tr = table.insertRow(-1); // TR iunique du tableau
			var td2 = tr.insertCell(-1);
			var tdA1 = parentDocument.createElement('A');
			tdA1.setAttribute('href','mailto:'+interneMail+'?subject=consultation');
			tdA1.setAttribute('style','float: left;');

			var IndicationDroit; // (interneDroit1.checked ? "Suivi seul" : "Suivi / Modification")
			if(interneDroit1.checked)
				IndicationDroit = "Suivi seul";	
			if(interneDroit2.checked)
				IndicationDroit = "Suivi / Modification";
			if(interneDroit==3)
				IndicationDroit = "Administrateur";	
	
			var tdA1Text = parentDocument.createTextNode(interneName + " ("+IndicationDroit+")");
			tdA1.appendChild(tdA1Text);
			td2.appendChild(tdA1);

			var td1 = tr.insertCell(-1); // TD 1 de la ligne
                       	var tdDiv = parentDocument.createElement('SPAN');
               	        tdDiv.setAttribute('class','droite');

			if(interneDroit!=3)
			{
				var tdA2 = parentDocument.createElement('A');
    				tdA2.setAttribute('href','javascript:retirer(\''+interneId+'\');');
	    			var tdA2Text = parentDocument.createTextNode('Retirer');
		    		tdA2.appendChild(tdA2Text);
				tdDiv.appendChild(tdA2);
			}

			var tdHiddenId = parentDocument.createElement('INPUT');
			tdHiddenId.setAttribute('type','hidden');
			tdHiddenId.setAttribute('name',interneId);
			tdDiv.appendChild(tdHiddenId);
			var tdHiddenDroit = parentDocument.createElement('INPUT');
			tdHiddenDroit.setAttribute('type','hidden');
			tdHiddenDroit.setAttribute('name','droit_'+interneId);
			tdHiddenDroit.setAttribute('id','droit_'+interneId);
                        var thisDocDroit = document.getElementById
			tdHiddenDroit.setAttribute('value',interneDroit);				
			tdDiv.appendChild(tdHiddenDroit);
			td1.appendChild(tdDiv)

			div.appendChild(table);
		} else { // l'interne n'est pas coché, on le supprime de la liste
			teleRemoveInterne(interneId);
		} // END if then else
             } // END if checkbox
	} // END for
    
window.close();
//	if (isAtLeastOneInterneSelected > 0) {
//		window.close();
//	} else {
//		alert("Vous devez sélectionner au moins un gestionnaire.");
//	} // END if then else
   
} // END function validateInternes()




/** recupere la liste des internes qui gèrent actuellement la consultation, et
 * les coche dans la fenêtre du popup
 * @ingroup admin_fct
 * @param divName nom du DIV dans le grand FORM
 * @param hiddenInterne identifiant de l'interne qui cree la consultation, et qui n'apparait pas dans la liste
 *
 */
function check_Internes(divName, hiddenInterne) {
	// recuperer les internes
	var childNodes = window.opener.document.getElementById(divName).childNodes;
	var childNum = childNodes.length;
	for (var i=0 ; i<childNum ; i++) {
		var elem = childNodes.item(i);
		if (elem.tagName=='TABLE')
		{
			document.getElementById(elem.id).checked=true;
			// On coche les radio button droit_interneX
			var droit_id = "droit_"+elem.id;
			// recuperation du droit attribue dans opene
			var elemDroit = window.opener.document.getElementById(droit_id);

			if (elemDroit.value=="1")
                            document.getElementById("droit_1_"+elem.id).checked=true;
			if (elemDroit.value=="2")
                            document.getElementById("droit_2_"+elem.id).checked=true;
			if (elemDroit.value=="3")
                            document.getElementById("droit_3_"+elem.id).checked=true;

		} // END if
	} // END for
} // END function check_Internes(divName)



/** retire la ligne correspondant à un interne dans la liste des gestionnaires
 * @param interneId l'ID de l'interne (= de la TABLE)
 * @return VOID
 */
function teleRemoveInterne(interneId)
{

	var table = window.opener.document.getElementById(interneId);

	if (table) {
		table.parentNode.removeChild(table);
	} // END if
} // END function teleRemoveInterne(interneId)




/** retire la ligne correspondant à un interne dans la liste des gestionnaires
 * @param interneId l'ID de l'interne (= de la TABLE)
 * @return VOID
 */
function retirer(interneId)
{
	var table = document.getElementById(interneId);
	table.parentNode.removeChild(table);
} // END function retirer(interneId)



/** verifie qu'au moins un gestionnaire est sélectionné
 *
 */
function verify_atLeastOneInterneIsSelected(divName) {
	var res_=false;
	var div=parentDocument.getElementById(divName);
	alert(div);
	return res_;
}
