<SCRIPT type="text/vbscript">
' Copyright (C) 2004 ATEXO Local Trust MPE
' 
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
' 
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
' 
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
' 
' For more information on our product, please contact MPE@atexo.com


Option Explicit

Function MakeKeyFlags(keysize)
  Dim flags
  Const CRYPT_EXPORTABLE = 1
  Const CRYPT_USER_PROTECTED = 2

' On met par dfaut ces flags-l 
  flags = CRYPT_EXPORTABLE Or CRYPT_USER_PROTECTED

  MakeKeyFlags = flags Or ( keysize * 65536)
End Function

Function CreatePKCS10Request(keysize)
  On Error Resume Next
  Dim DNName
  Const AT_KEYEXCHANGE = 1
  Const AT_SIGNATURE = 2

  DNName = "CN=<? echo $_POST['cons_ref']." ".$_POST['cons_ref_env'];?>"

'On met par dfaut local-machine
 XEnroll.RequestStoreFlags = &H10000

  XEnroll.GenKeyFlags = MakeKeyFlags(keysize)
  XEnroll.KeySpec = AT_KEYEXCHANGE

  CreatePKCS10Request = XEnroll.createPKCS10(DNName, "")
  If Err.Number <> 0 Then
    MsgBox ("Impossible de gnrer la cl: " & Err.Description & _
            " (" & CStr(Err.Number) & ")")
    CreatePKCS10Request = "error"
  End If
End Function


Sub CertRequestSub
  Dim keysize, req
  keysize = document.main_form.keysize.value
  req = CreatePKCS10Request(keysize)
  If req = "error" Then
    Exit Sub
  End If
  document.main_form.pkcs10_req.value = req
  document.main_form.cmd.value="generate_cert"
  document.main_form.submit()
End Sub

Sub CertRequestEdit
  Dim keysize, req
  keysize = document.main_form.keysize.value
  req = CreatePKCS10Request(keysize)
  If req = "error" Then
    Exit Sub
  End If
End Sub


'-----------------------------------------------------------------
' IE SPECIFIC:
' Get the list of CSPs from Enroll
' returns error number
' assumes Enroll is named 'Enroll' and the list box is 'document.main_form.lbCSP'
Function GetCSPList()
  On Error Resume Next
  Dim nProvType, nOrigProvType, nTotCSPs, nDefaultCSP, bNoDssBase, bNoDssDh, sUserAgent
  ' should be >= the number of providers defined in wincrypt.h (~line 431)
  Const nMaxProvType=25 
  nTotCSPs=0
  nDefaultCSP=-1

  sUserAgent=navigator.userAgent
  If CInt(Mid(sUserAgent, InStr(sUserAgent, "MSIE")+5, 1))<=4 Then
    bNoDssDh=True
    bNoDssBase=True
  Else
    bNoDssDh=False
    If 0<>InStr(sUserAgent, "95") Then
      bNoDssBase=True
    ' NT 4 does not include version num in string.
    ElseIf 0<>InStr(sUserAgent, "NT)") Then 
      bNoDssBase=True
    Else
      bNoDssBase=False
    End If
  End If

  ' save the original provider type
  nOrigProvType=XEnroll.ProviderType
  If 0 <> Err.Number Then
    ' something wrong with XEnroll
    GetCSPList=Err.Number 
    MsgBox "ProviderType error: " + hex(err.number), 64, "Error"
    ' Exit Function
  End If

  ' enumerate through each of the provider types
  For nProvType=0 To nMaxProvType 
    Dim nCSPIndex
    nCSPIndex=0
    XEnroll.ProviderType=nProvType
			
    ' enumerate through each of the providers for this type
    Do 
      Dim sProviderName
      'get the name
      sProviderName=XEnroll.enumProviders(nCSPIndex, 0)
				
      If &H80070103=Err.Number Then 
        ' no more providers
        Err.Clear
        Exit Do
      ElseIf 0<>Err.Number Then
        ' something wrong with XEnroll
        '  - ex, Win16 IE4 XEnroll doesn't support this call.
        GetCSPList=Err.Number 
        Exit Function
      End If
    
      If ("Microsoft Base DSS Cryptographic Provider"=sProviderName And True=bNoDssBase) _
        Or ("Microsoft Base DSS and Diffie-Hellman Cryptographic Provider"=sProviderName And True=bNoDssDh) Then
        ' skip this provider
      Else 
        ' For each provider, add an element to the list box.
        Dim oOption
        Set oOption=document.createElement("Option")
        oOption.text=sProviderName
        oOption.Value=nProvType
        document.main_form.lbCSP.add(oOption)
        If InStr(sProviderName, "Microsoft Enhanced Cryptographic Provider") <> 0 Then
    	  oOption.selected=True
	  nDefaultCSP=nTotCSPs
        End If
	nTotCSPs=nTotCSPs+1
      End If
				
      ' get the next provider
      nCSPIndex=nCSPIndex+1
    Loop
  Next
		
  ' if there are no CSPs, we're kinda stuck
  If 0=nTotCSPs Then
    Set oElement=document.createElement("Option")
    oElement.text="-- No CSP's found --"
    document.main_form.lbCSP.Options.Add(oElement)
  End If

  ' remove the 'loading' text
  document.main_form.lbCSP.remove(0)

  ' select the default provider
  If -1 <> nDefaultCSP Then
    document.main_form.lbCSP.selectedIndex=nDefaultCSP
  End If

  ' restore the original provider type
  XEnroll.ProviderType=nOrigProvType

  ' set the return value and exit
  If 0 <> Err.Number Then
    GetCSPList=Err.Number
    ElseIf 0 = nTotCSPs Then
    ' signal no elements with -1
    GetCSPList=-1
  Else
    GetCSPList=0
  End If
End Function

Function postLoad()
  On Error Resume Next   
  VerifyXEnroll("postLoad2")
End Function

Function postLoad2(status)
  On Error Resume Next   
  Dim nResult  

  If status = 0 Then 
    MsgBox "XEnroll version mismatch", 64, "Error"
    Exit Function
  End If

  nResult = 0
  ' get the CSP list
  nResult = GetCSPList()
  If 0 <> nResult Then
    Exit Function
  End If
  handleCSPChange()
End Function

Function handleCSPChange()
    Dim g_bOkToSubmit, nCSPIndex, nProvType, nSupportedKeyUsages
    Dim keymax, keymin

    ' IE is not ready until XEnroll has been loaded
    g_bOkToSubmit = false

    ' some constants defined in wincrypt.h:
    Const CRYPT_EXPORTABLE = 1
    Const CRYPT_USER_PROTECTED = 2
    Const CRYPT_MACHINE_KEYSET = &H20
    Const AT_KEYEXCHANGE = 1
    Const AT_SIGNATURE = 2
    Const CERT_SYSTEM_STORE_LOCAL_MACHINE = &H20000
    Const ALG_CLASS_ANY = 0
    Const ALG_CLASS_SIGNATURE = &H2000
    Const ALG_CLASS_HASH = &H4000
    Const PROV_DSS=3
    Const PROV_DSS_DH=13

    ' convenience constants, for readability
    Const KEY_LEN_MIN=true
    Const KEY_LEN_MAX=false
    Const KEY_USAGE_EXCH=0
    Const KEY_USAGE_SIG=1
    Const KEY_USAGE_BOTH=2

    ' defaults
    Const KEY_LEN_MIN_DEFAULT=384
    Const KEY_LEN_MAX_DEFAULT=16384

    nCSPIndex = document.main_form.lbCSP.selectedIndex
    XEnroll.ProviderName = document.main_form.lbCSP.options(nCSPIndex).text
    nProvType = document.main_form.lbCSP.options(nCSPIndex).value
    XEnroll.ProviderType = nProvType
    


    nSupportedKeyUsages = AT_KEYEXCHANGE



    if (PROV_DSS = nProvType OR PROV_DSS_DH = nProvType) then
     nSupportedKeyUsages = AT_SIGNATURE
    End If

    document.main_form.keyusage.value="both"

End Function

</SCRIPT>
