/*
Copyright (C) 2004 ATEXO Local Trust MPE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For more information on our product, please contact MPE@atexo.com
*/
<?php

session_start();
header('Cache-control: private, no-cache'); // HTTP 1.1
header('Expires: Mon, 25 Feb 2002 01:00:00 GMT'); // HTTP 1.0
header('Pragma: no-cache'); // HTTP 1.0

define ('DEFAULT_CMD', 'get_main_page');
include('config.inc.php');

require_once 'format.inc.php';
require_once 'files.inc.php';

require_once 'add_co_desc.php';
require_once 'add_co_insc.php';
require_once 'add_subs_insc2.php';
require_once 'add_subs_pref.php';
require_once 'update_subs_insc2.php';
require_once 'update_co_insc.php';
require_once 'delete_subs_profile.php';
require_once 'change_auth_method.php';
require_once 'eparapheur.inc.php';

	
/** affiche la page d'accueil
 * affiche pour l'instant les trois dernires consultations
 * @return void
 */
function get_main_page() {
 ?>
<h1>Gestion des marchs publics</h1>
	<p>Bienvenue sur la plate-forme de gestion des marchs publics d'<?echo OWNER_NAME?>.</p>
	<p>Voici les trois dernires consultations publies :</p>
<?php
	$_POST['recherche']=1; // simule l'envoi du FORM show_search_cons
	show_cons();
	$_POST['recherche']=0;
?>

<?php
} // end function get_main_page() 

function back_page()
{
  if ($_POST['thisForm'] == "DC5")
    include 'dc4.php';
  else if ($_POST['thisForm'] == "PROP_FORM")
    include 'dc5-1.php';
}

/** affichage de la page d'accueil, en mode authentifi
 * @return VOID
 */
function get_authenticated_main_page()
{
if (!$_SESSION['sess_subs_profile'])
{
  PrintError ("Vous n'tes pas authentifi");
  return;
}
 echo "Bonjour ".stripslashes($_SESSION['sess_subs_profile']['prenom'])." ".stripslashes($_SESSION['sess_subs_profile']['nom']);
 get_main_page ();
 
}



/** affiche un titre + les liens d'AuthN
 * appel par le lien "Me connecter"
 * @return void
 */
function authenticate_from_menu() {
	echo "<h1>Mon Compte</h1>\n";
	authenticate();
} // end authenticate_from_menu()



/** affiche les liens d'AuthN
 * <ul>
 * <li>0 : aucune authN</li>
 * <li>1 : authN par login seulement</li>
 * <li>2 : authN par certif uniquement</li>
 * <li>3 : authN par certif et login</li>
 * </ul>
 * @param $_authType type d'authentification requise
 * @return void
 */
function authenticate($_authType=3)
{
  $_SESSION = array();

  // Pour la rcupration de la rfrence de l'offre lorsqu'on 
  //    * est pas authentifi
  //    * clique sur rpondre  une offre
  if ($_POST['refMarche'])
    {
      $_SESSION['sess_ref_market'] = $_POST['refMarche'];
    }
  // PrintError($_POST['prop_form']);
  if ($_POST['prop_form'])
    {
      $_SESSION['sess_prop_form'] = $_POST['prop_form'];
    }

  // Il y a vraiment plus simple !!!!
  ?>
	<h2>Authentification</h2>
	<?php
		if ($_authType==2 || $_authType==3) {
	?>
	<a href="secure/auth_by_cert.php">Authentification par certificat</a>
	<br /><br />
	<?php
		}
		if ($_authType==1 || $_authType==3) {
	?>
	<a href="javascript:ActivateMenu('show_auth_by_pass_form')">Authentification par login / mot de passe</a>
	<?php
		}
		if ($_authType<0 || $_authType>3) {
			PrintError("Mode d'authentification inconnu");
			return;
		}
	?>
<?php

}

/** fermeture de la session php authentifie
 * @return void
 */
function disconnect() {
  //  $_SESSION['sess_logged'] = 0;
  $_SESSION = array();
?>
	<script Language="JavaScript">
	if (document.all) { // IE
		document.all.main_form.cmd.value='';   
		document.all.main_form.submit();
	} else { // non-IE
		document.main_form.cmd.value='';   
		document.main_form.submit();
	}
	</script>
<?php
} // end function disconnect()



/** affiche bouton d'authN d'un inscrit par login/passwd
 * @return HTM INPUT
 */
function show_auth_by_pass_form()
{
  require('subs_auth_pass.php');
?>
<input type="submit" name="valider" value="Valider" onClick="javascript:ActivateMenu2('do_auth_pass')" />
<?
}


/** TODO XXX
 * @return void
 */
function do_auth_pass()
{
  $_SESSION['sess_logged'] = 0;
  $_SESSION['sess_auth_method'] = 0;

  if (!$_POST["login"] || !$_POST["mdp"])
    {
      PrintError("Formulaire incomplet (login / mdp)");
      show_auth_by_pass_form();
      return;
    }
  
  if (!field_exists('Inscrit', 'login', $_POST["login"]))
    {
      PrintError("Login ou mot de passe erron");
      show_auth_by_pass_form();
      return;
    }
  if (!($subscriber_db = passwd_match('Inscrit', $_POST["login"], $_POST["mdp"])))
    {
      PrintError("Login ou mot de passe ronn");
      show_auth_by_pass_form();
      return;
    }
  $company_id = get_subscriber_company($_POST["login"]);
  if (!$company_id)
    {
      PrintError("Impossible de trouver l'identifiant de votre entreprise");
      return;
    }
  $company_db = get_row_by_field('Entreprise', 'id', $company_id);
  
  if (!$company_db)
    {
      PrintError("Votre entreprise n'est plus enregistre");
      return;
    }
  $_SESSION["sess_subs_profile"] = $subscriber_db;
  $_SESSION["sess_subs_company"] = $company_db;     
  $_SESSION['sess_logged'] = 1;
  $_SESSION['sess_auth_method'] = LOGIN_AUTH;
    ?>
  <script Language="JavaScript">
     if (document.all)
       {
	 document.all.main_form.cmd.value='confirm_pass_auth';   
	 document.all.main_form.submit();
       }
     else
       {
	 document.main_form.cmd.value='confirm_pass_auth';   
	 document.main_form.submit();
       }
</script>
<?
} // end function do_auth_pass()


/** XXX
 * <ol>
 * <li>XXX</li>
 * <li>Affiche message de bienvenue</li>
 * <li>affiche les trois dernires consultations</li>
 * </ol>
 * @return 
 */
function confirm_pass_auth()
{
  if (!$_SESSION['sess_subs_profile'] || !$_SESSION['sess_subs_company'] || !$_SESSION['sess_logged'])
    {
      PrintError("Vous n'tes pas authentifi");
      return;
    }
  //show_cons();
  do_next_cmd ('get_authenticated_main_page');
}



/** affiche les 3 dernieres consultations
 * est utilise pour la page d'accueil
 * @return void
 */
function show_cons()
{
	$_POST['limit']=3;
    require('do_search_cons.php');
    show_found_cons(create_searchQuery(), false);
	$_POST['recherche']=0; // XXX est-ce ncessaire ?
	?>
	<br />
	<div class="droite">
		<a href="javascript:ActivateMenu('show_search_cons_form')">Nouvelle recherche</a>
	</div>
	<?php
} // END function show_cons()



/** affiche la page de recherche de consultation
 * l'affichage des rsultats est condiionn par l'argument
 * @return VOID
 */
function search_cons()
{
	?>
	<h1>Consultations</h1>
	<h2>Rsultats de la recherche</h2>
	<div class="droite">
		<a href="#recherche">Nouvelle recherche</a>
	</div>
    <?php
    require_once('do_search_cons.php');

    if ($_POST['recherche']==1) {
      //echo 'ca vient la';
       
        show_found_cons(create_searchQuery(), true, 'search_cons');
    } // END if
	echo '<br />';
	require('search_cons_form.php');
} // END function search_cons($_showResults)



/** affiche le formulaire de recherche
 * @return VOID
 */
function show_search_cons_form() {
	?>
	<h1>Consultations</h1>
	<?php
  require('search_cons_form.php');
}



function show_co_desc_form()
{
  require('co_desc_form.php');
}

/** affichage du formulaire de cration du compte entreprise
 * @return VOID
 */
function show_co_insc_form() {
	?>
	<h1>Compte d'entreprise</h1>
	<h2>Cration</h2>
	<?php
  require('co_insc_form.php');
} // end function show_co_insc_form()


function mod_subs_insc()
{
  require('subs_auth.php');
  subs_auth();
}

function show_subs_insc_form2()
{
  //Erreur si candidat non tabli en France et pays='FR'
  if ($_POST['enFrance'] == '2' && strtolower($_POST['paysEnregistrement1']) == 'fr')
    {
      PrintError('Pays incorrect pour candidat non tabli en France');
      require('get_subs_company.php');
      return;
    }
  $company_id = get_co_by_siren($_POST);
  if ($company_id == -1) // format invalide du rcs
    { 
      PrintError("Format invalide du RCS; saisir: Ville + A ou B + numro de SIREN  9 chiffres<br />Exemple : Paris B 440909562");
      identify_subs_company();
      //      require("get_subs_company.php");
    }
  else if (!$company_id) // Entreprise n'existe pas
    {
      $_SESSION['sess_co_exists'] = 0;
      if($_POST['enFrance'] == 1)
	{
	  $_SESSION['paysEnregistrement'] = "FR";
	  // parse_rcs
	  $_SESSION['villeEnregistrement'] = addslashes($_POST['villeEnregistrement1']);
	  $_SESSION['repMetiers'] = addslashes($_POST['repMetiers']);
	  $_SESSION['siren'] = addslashes($_POST['siren']);
	}
      else
	{
	  $_SESSION["villeEnregistrement"] = addslashes($_POST["villeEnregistrement2"]);
	  $_SESSION["paysEnregistrement"] = addslashes($_POST["paysEnregistrement1"]);
	  $_SESSION["sirenEtranger"] = addslashes($_POST["sirenEtranger"]);
	}
      echo "<h2>Cette entreprise n'est pas enregistre</h2>";
      echo "<p>L'inscription  la plate-forme de gestion des marchs publics requiert la cration pralable du compte de cette entreprise.</p>";
	?>
	<input type="hidden" name="access_one_co_insc_form" value="1">
       <a href="javascript:ActivateMenu('show_co_insc_form')">Crer le compte de l'entreprise</a><br /><br />
       <a href="javascript:ActivateMenu('identify_subs_company')">Retour</a>
<?php
    }
  else //Entreprise existe
    {
  $_SESSION['sess_co_profile_array'] = get_row_by_field('Entreprise', 'id', $_SESSION['sess_company_id']);
  $_SESSION['sess_co_exists'] = 1;
  echo "<h2>Votre entreprise est enregistre</h2>";
  echo "<strong>Entreprise</strong>";
  print_company_summary($_SESSION['sess_co_profile_array'], true, true);
    }
} // end function show_subs_insc_form2()

function print_admin_insc_form()
{
	?>
	<h1>Cration de compte</h1>
	<p>
		En crant ce compte, vous deviendrez administrateur du compte de votre
		entreprise dans la plate-forme des marchs publics. Votre nom et votre
		adresse e-mail seront accessibles  toute personne appartenant  votre
		socit.
	</p>
	<?php
	choose_auth_method();
}



function print_user_insc_form()
{
?>
 <h1>Cration de compte personnel</h1>
 <?php
 print_subs_insc_form2(NULL, false);
 
} // end function print_user_insc_form()



function print_user_insc_form_by_cert()
{
  
?>
 <h1>Cration de compte personnel</h1>
<?if(!$_SESSION['sess_co_profile_array'])
    {
      PrintError("Impossible de charger le profile entreprise");
      return;
    }
 ?>
En crant ce compte personnel, vous affirmez faire partie de l'entreprise <b><? echo stripslashes($_SESSION['sess_co_profile_array']['nom']);?></b>.<br><br>
 <?
 if (!$_POST['client_cert'] || !$_POST['client_cert_serial'])
   {
     PrintError("Erreur lors de la rcupration du certificat.");
     return;
   }
 $_SESSION['sess_subs_cert'] = addslashes($_POST['client_cert']);
 $_SESSION['sess_subs_cert_serial'] = addslashes($_POST['client_cert_serial']);
 print_subs_insc_form2(NULL, false, false); //(subscriber, with_preferences, display_login_pass)
}

/** affiche le choix de tyle d'authN  l'inscription : certificat ou
 * login/passwd
 * @return HTML TABLE
 */
function choose_auth_method()
{
require_once('ac.inc.php');
  ?>
  <strong>Veuillez choisir le type d'authentification dsir</strong>.
	<br><br>
  <table summary="deux-authN">
	  <tr>
			<td><a href="javascript:ActivateMenu('print_user_insc_form')">Authentification par mot de passe</a></td>
			<td>Vous pourrez vous abonner au site des marchs publics et avoir accs  toutes les consultations</td>
		</tr>
		<tr>
			<td><a href="secure/get_cert.php">Authentification par certificat</a></td>
			<td>Vous pourrez vous abonner au site des marchs publics et avoir accs  toutes les consultations avec la possiblit d'y rpondre en ligne</td>
		</tr>
	</table>
 <?php
} // end function choose_auth_method()
     
// Pour l'authentification des clients inscrits
     /* function tell_auth_method()
 {
   echo "Quel est votre type d'authentification ?" ;
   ?>
   <table>
   <tr>
   <td><a href="secure/get_cert.php">Authentification par certificat</a></td>
   </tr><tr>
   <td><a href="javascript:ActivateMenu('print_user_insc_form')">Authentification par mot de passe</a></td>
 </tr>
 </table>
 <?
 }
     */



/** affiche le formulaire demandant l'entreprise, dans le cas o l'utilisateur
 * veut crer son compte personnel.
 * @return VOID
 */
function identify_subs_company() {
	?>
	<h1>Cration d'un compte personnel</h1>
	<h2>Entreprise de l'utilisateur</h2>
	<?php
  require('get_subs_company.php');
} // end function identify_subs_company()

function do_mod_subs_insc()
{
  require('do_mod_subs_insc.php');
}

function show_subs_pref_form()
{
    require('subs_pref_form.php');
?>
<input type="submit" name="valider" value="Valider" onClick="javascript:ActivateMenu2('add_subs_pref')">
<?
}



/** verifie si l'utilisateur est logged par certificat
 * @return HTML msg d'erreur / HTML formulaire de proposition d'offre (1 enveloppe)
 * @see ValidateRef(...)
 */
function validate_ref()
{
  if (!$_SESSION['sess_logged'])
    {
      //      PrintError ("Vous n'tes pas authentifi");
      echo MSG_USER_NON_AUTHENTICATED_SUBMIT_OFFER;
      authenticate(2);
      $_SESSION['sess_next_cmd'] = 'validate_ref';
      return;
    }

  if ($_SESSION['sess_auth_method']!=CERT_AUTH)
    {
      $_SESSION['sess_ref_market'] = addslashes($_POST['refMarche']);
      echo MSG_USER_AUTH_PASS_SUBMIT_OFFER;
      $_SESSION['sess_next_cmd'] = 'validate_ref';
      return;
    }
if ($_POST['error_msg'])
  {
    PrintError (stripslashes($_POST['error_msg']));
    return;
  }
 
// La consultation est charge en session
 $_SESSION['sess_cons'] = get_row_by_field (CONSULTATION, REFERENCE, $_POST['refMarche']);
 if (!$_SESSION['sess_cons'])
   {
     PrintError("Une erreur inconnue est survenue lors du chargement de la consultation");
     return;
   }
 include "dc4.php"; 
}

/** verifie si l'utilisateur est logged par certificat
 * @return HTML msg d'erreur / HTML formulaire de proposition d'offre (2 enveloppes)
 * @see ValidateRef(...)
 */
function validate_ref2()
{
  if (!$_SESSION['sess_logged'])
    {
      //      PrintError ("Vous n'tes pas authentifi");
      echo MSG_USER_NON_AUTHENTICATED_SUBMIT_OFFER;
      authenticate(2);
      $_SESSION['sess_next_cmd'] = 'validate_ref';
      return;
    }

  if ($_SESSION['sess_auth_method']!=CERT_AUTH)
    {
      $_SESSION['sess_ref_market'] = addslashes($_POST['refMarche']);
      echo MSG_USER_AUTH_PASS_SUBMIT_OFFER;
      $_SESSION['sess_next_cmd'] = 'validate_ref';
      return;
    }
if ($_POST['error_msg'])
  {
    PrintError ($_POST['error_msg']);
    return;
  }
 
// La consultation est charge en session 
 $_SESSION['sess_cons'] = get_row_by_field (CONSULTATION, REFERENCE, $_POST['refMarche']);
 if (!$_SESSION['sess_cons'])
   {
     
     PrintError("Une erreur inconnue est survenue lors du chargement de la consultation");
     return;
   }


 include "prop_form2.php";
}

/** 
 *
 *
 */
function submit_offer()
{
  /* if (!$_SESSION['sess_logged'])
    {
			echo MSG_USER_NON_AUTHENTICATED_SUBMIT_OFFER;
      authenticate (2);
      $_SESSION['sess_next_cmd'] = 'submit_offer';
      return;
    }
  else if ($_SESSION['sess_logged'] && $_SESSION['sess_auth_method']!=CERT_AUTH)
    {
      echo MSG_USER_AUTH_PASS_SUBMIT_OFFER;
      $_SESSION['sess_next_cmd'] = 'submit_offer';
      return;
    }*/
  include "prop_ref.php";
} // end submit_offer()

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<title><?echo OWNER_NAME;?> - Marchs publics lectroniques</title>
	<link rel="stylesheet" type="text/css" href="./include/joli.css">
	<script type="text/javascript" src="./include/form.inc.js"><!-- //--></script>
	<script type="text/javascript" src="./include/popup.inc.js"><!-- //--></script>
<?
	if ($_POST['cmd'] == "validate_ref" || $_POST['prop_form'] == "1")
{

  $php_self = $_SERVER['PHP_SELF'];
  // preg_match prend un chaine entoure de '/'
  preg_match("/(.*)\//", $php_self, $activex_path);

?>
<object classid="CLSID:A996E48C-D3DC-4244-89F7-AFA33EC60679" id="capicom"
  codebase="https://<?php echo $_SERVER['SERVER_NAME'].$activex_path[1].'/activex/capicom.cab' ;?>">
</object>
<object classid="CLSID:4E4B65ED-A6C6-4C7B-9634-490881779B9D" id="mpe" width="24" height="24"
  codebase="https://<?php echo $_SERVER['SERVER_NAME'].$activex_path[1].'/activex/MarchesPublics.CAB' ;?>">
</OBJECT>
<?php }?>
</head>
<body>
<?
if ($_POST['cmd'] == "validate_ref" || $_POST['prop_form'] == "1")
{

  $php_self = $_SERVER['PHP_SELF'];
  // preg_match prend un chaine entoure de '/'
  preg_match("/(.*)\//", $php_self, $activex_path);

?>
<script type="text/vbscript">
<!-- Instruct non-IE browsers to skip over VBScript modules.
Sub SignAndSubmit_OnClick()
    
     document.all.main_form.cmd.value = "submit_prop"
  
     

     document.all.main_form.xmlFile.value = mpe.SignForm(document.all.main_form.refMarche.value,_
							     document.all.main_form.fichierPrin1.value,_
							     document.all.main_form.fichierPrin2.value,_
							     document.all.main_form.complement_1.value,_
							     document.all.main_form.complement_2.value,_
							     document.all.main_form.complement_3.value,_
							     document.all.main_form.complement_4.value,_
							     document.all.main_form.complement_5.value)

     document.all.main_form.signEnvXml.value = mpe.SignFile(document.all.main_form.fichierPrin1.value,_
							     document.all.main_form.fichierPrin2.value,_
							     document.all.main_form.xmlFile.value)

     document.all.main_form.encryptFile1.value = mpe.EncryptFile(document.all.main_form.fichierPrin1.value,_
							     document.all.main_form.certifPrin1.value)

     document.all.main_form.xmlFile.value = mpe.EncryptXML(document.all.main_form.xmlFile.value,_
							     document.all.main_form.certifXML.value)

       document.all.main_form.encryptFile2.value = mpe.EncryptFile(document.all.main_form.fichierPrin2.value,_
							     document.all.main_form.certifPrin2.value)
  If document.all.main_form.signEnvXml.value <> vbnullstring Then
     'freeFiles()
     document.all.main_form.submit()
end If
End Sub

'Sub validerMarche_OnClick()
'     document.all.main_form.cmd.value = "reload_with_summary"
'End Sub
 -->
</script>
<script type="text/javascript">
function freeFiles()
{
var env1 = document.getElementById("enveloppe1");
if (env1)
{
  env1.parentNode.removeChild (env1);
}

var env2 = document.getElementById("enveloppe2");
if (env2)
{
  env2.parentNode.removeChild (env2);
}
}
</script>

<?php }?>

<div id="tout">

	<form name="main_form" action="<?php echo $_SERVER['PHP_SELF']; ?>"
id="main_form" method="POST" enctype="multipart/form-data">

<?php //if ($_POST['cmd'] == "submit_offer" || $_POST['prop_form'] == "1") echo "enctype=\"multipart/form-data\"" ;
?>
	<?php require('template.bandeau-h.inc.php'); ?>
	
	<div id="contenu">
	<table id="ttt" summary="les trois colonnes">

        <tr>
	<?php

		require('template.menu-g.inc.php');

	?>
	<td id="centre">
<input type="hidden" name="cmd" id="cmd" value="">
<input type="hidden" name="msg" id="msg" value="">
<input type="hidden" name="displayed" id="displayed" value="">

<?php

//Affichage de messages
if($_POST['msg'])
{
  PrintMessage(stripslashes($_POST['msg']));
}


$cmd = $_POST['cmd'];
if (!$cmd)
{
  $cmd = DEFAULT_CMD;
}

switch ($cmd)
{
 case 'get_main_page': // affiche page d'accueil
   get_main_page();
   break;
 case 'get_authenticated_main_page': // affiche page d'accueil authentifie
   get_authenticated_main_page();
   break;
 case 'show_co_desc_form':
   show_co_desc_form();
   break;
 case 'add_co_desc':
   add_co_desc();
   break;
 case 'show_co_insc_form': // affiche le form de creation de compte entreprise
   show_co_insc_form();
   break;
 case 'add_co_insc':
   add_co_insc();
   break;
 case 'mod_co_insc':
   require_once 'mod_co_insc.php';
   mod_co_insc();
   break;
 case 'do_mod_co_insc':
   do_mod_co_insc();
   break;
 case 'do_mod_subs_insc':
   do_mod_subs_insc();
   break;
 case 'update_co_insc':
   update_co_insc();
   break;
 case 'update_subs_insc2':
   update_subs_insc2();
   break;
 case 'show_subs_insc_form2':
   show_subs_insc_form2();
   break;
 case 'add_subs_insc2':
   add_subs_insc2();
   break;
 case 'show_subs_pref_form':
   show_subs_pref_form();
   break;
 case 'add_subs_pref':
   add_subs_pref();
   break;
 case 'mod_subs_insc':
   mod_subs_insc();
   break;
 case 'delete_subs':
   delete_subs();
   break;
 case 'delete_subs_account':
   delete_subs_account();
   break;
 case 'identify_subs_company':
   identify_subs_company();
   break;
 case 'show_search_cons_form':
   show_search_cons_form();
   break;
 case 'search_cons': // affiche la page de recherche de consultation
   search_cons(); // n'affiche pas de rsultats de recherche
   break;
 case 'authenticate_from_menu':
   authenticate_from_menu();
   break;
 case 'authenticate':
   authenticate();
   break;
  case 'show_auth_by_pass_form':
   show_auth_by_pass_form();
    break;
  case 'do_auth_pass':
    do_auth_pass();
    break;
  case 'confirm_pass_auth':
    confirm_pass_auth();
    break;
  case 'change_auth_method':
    change_auth_method();
    break;
 case 'get_user_cert':
   get_user_cert();
   break;
 case 'print_admin_insc_form':
  print_admin_insc_form();
   break;
 case 'print_user_insc_form':
  print_user_insc_form();
   break;
 case 'print_user_insc_form_by_cert':
  print_user_insc_form_by_cert();
   break;
 case 'choose_auth_method': // affiche la page de choix d'authentification
   choose_auth_method();
   break;
 case 'submit_offer': // soumettre une offre en rponse  une consultation
   submit_offer();
   break;
 case 'validate_ref':
   //validate_ref();// Cette fonction sert dans le cas d'une reponse d'offre avec dc4 dc5 (1 enveloppe)
   validate_ref2();// Cette fonction sert dans le cas d'une reponse d'offre avec 2  enveloppes
   break;
 // ACTIONS DU BANDEAU /////////////////////////////////////////////////////////
 case 'profile':
   require_once 'banner_fct.inc.php';
   profile();
   break;
 case 'show_my_offers': // affiche mes offres
   require_once 'banner_fct.inc.php';
   show_my_offers();
   break;
 case 'show_my_cons': // affiche mes consultations
   require_once 'banner_fct.inc.php';
   show_my_cons();
   break;
 // FIN ACTIONS DU BANDEAU /////////////////////////////////////////////////////
 case 'disconnect': // deconnexion
   disconnect();
   break;
 case 'add_dc5_1': // affiche le DC5
   require_once 'add_dc5_1.php';
   add_dc5_1();
   break;
 case 'add_dc4': // affiche le D4
   require_once 'add_dc4.php';
   add_dc4();
   break;
 case 'confirm_action':
   require_once 'confirm_action.inc.php';
   confirm_action();
   break;
 case 'back_page':
   back_page();
   break;

 // ACTIONS E-PARAPHEUR ////////////////////////////////////////////////////////
 case 'show_prop_form':
   //show_prop_form();// pour afficher l'etape de reponse apres dc4 et dc5
   show_prop_form2();// pour afficher l'etape de reponse d'offre sans dc4, dc5 (2 enveloppes)
   break;
 case 'reload_with_summary':
   reload_with_summary();
   break;
 case 'reload_from_code_with_summary':
   reload_from_code_with_summary();
   break;
 case 'submit_prop':
   //submit_prop();
   submit_prop2();
   break;
 case 'verif_dir':
   verif_dir();
   break;
 case 'show_menu':
   show_menu();
   break;
 case 'show_dirs':
   show_dirs();
   break;
 case 'get_capicom':
   require_once 'capicom.php';
   get_capicom();
   break;
   // FIN ACTIONS E-PARAPHEUR ////////////////////////////////////////////////////
   // ACTIONS ENCHERES ///////////////////////////////////////////////////////////
 case 'auctions': // participer  une enchre
   require_once 'auction.inc.php';
   auctions();
   break;
   // FIN ACTIONS UTILISATEUR INTERNE ////////////////////////////////////////////
 default:
   echo "Commande inconnue: '$cmd'";
   break;
} // END switch ($cmd)
//print_request_vars($_SESSION);

?>

</td>
<?php

require 'template.menu-d.inc.php';
?>
</tr>
</table>
<?php
	if (isset($_SESSION['dc']) && $_SESSION['dc']) { // seulement si c'est un DC
	$_SESSION['dc']=false;
	?>
		<script type="text/javascript" src="./include/dc.inc.js"><!-- //--></script>
		<script type="text/javascript"><!--
			mask_menu('menu-gauche');
			mask_menu('menu-droite');
		//--></script>
<?php
	}

	require_once 'template.footer.inc.php'; // footer
?>
</div><!-- FIN DIV CONTENU //-->
</form>
</div><!-- FIN DIV TOUT //-->
</body>



</html>
