/*
Copyright (C) 2004 ATEXO Local Trust MPE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For more information on our product, please contact MPE@atexo.com
*/
<?php
//error_reporting(E_ALL);
require_once 'config.inc.php';
require_once  'mysql.inc.php';
require_once 'crypto.inc.php';
require_once  'files.inc.php';
require_once 'format.inc.php';
require_once   'mail.inc.php';
require_once   'misc.inc.php';


session_name('interne');
session_start(); // creation de la session
header("Cache-control: private, no-cache"); // HTTP 1.1
header("Expires: Mon, 25 Feb 2002 01:00:00 GMT"); // HTTP 1.0
header("Pragma: no-cache"); // HTTP 1.0

/** affiche le formulaire d'ajout de fichier au dossier de consultation
* @ingroup interne_fct
 */
function affiche_addfile_form() {
?>$_SESSION['sess_interne_profile']['id']
		<input type="hidden" name="sendfile" value="1" />
		<input type="hidden" name="reference" value="<?php $strip_reference;?>" />
		   <br />
		<label>Fichier à ajouter au dossier</label>
		<input type="file" size="40" name="fichier" />
<?php
		   } //END function affiche_addfile_form()



/** recupere la liste des fichiers dans l'archive zip
 * @ingroup interne_fct
 * @param $_zipname nom du fichier zip
 * @return liste des noms
 */
function getZipFileList($_zipname) {
	$res_=array();
	$sys_answer=shell_exec("zip -Tv $_zipname");
	$sysArray=explode("\n",$sys_answer);
	foreach($sysArray as $line) {
		if( preg_match('/^ *testing: ([^ ]*) *OK$/',$line, $match)) {
			array_push($res_,$match[1]);
		}
	}
	return $res_;
} // END function getZipFileList($_zipname)


/** renvoie le nom+numéro de la version du fichier à insérer dans le zip
 * @ingroup interne_fct
 * @param $_nom nom du fichier, avec extension éventuelle
 * @param $_array liste des noms des fichiers dans le zip
 * @return STRING
 */
function getNewName_fileInArray($_nom,$_array) {
  //	list($prepoint,$postpoint)=explode('.',$_nom);
	preg_match('/^(.*)\.(.*)$/',$_nom,$m);
	list(,$prepoint,$postpoint)=$m;
	$extension = strlen($postpoint)==0 ? '' : ".$postpoint";
	$num=-1;
	foreach($_array as $fname) {
		if(preg_match("/\/".preg_quote($_nom)."$/",$fname))
            { $num=0; }
		if(preg_match("/\/".preg_quote($prepoint)."--mpe([0-9]{1,2})$extension$/",$fname,$match)) {
			$num=max($num,$match[1]);
		}
	} // END foreach
	$prepoint= $num==-1 ? $prepoint : "$prepoint--mpe".($num+1) ;
	$res_="$prepoint$extension";
	return $res_;
}  // END function getNewName_fileInArray($_nom,$_array)



// les différents tests 
if (!isInterneAuthenticated()) {
  PrintMessage("Vous devez vous authentifier pour modifier une consultation.");
  return;
     }
     if (!isset($_REQUEST['reference']))
{
       PrintError("Vous devez sélectionner une consultation à modifier");
	return;
}
$reference=addslashes($_REQUEST['reference']);
$strip_reference = stripslashes ($_REQUEST['reference']);

// on recupere les infos de la consultation

$query="SELECT titre, dateDebut, dateFin \nFROM Consultation, Interne_Consultation\nWHERE `reference`='$reference'\n AND Interne_Consultation.interne_id = ".$_SESSION['sess_interne_profile']['id']."\n;";

$response=sql_query($query);
$consultation=mysql_fetch_array($response,MYSQL_ASSOC);
mysql_free_result($response);
	if (is_bool($consultation)) {
		// pas de consultation trouvée
		PrintError("Il n'y a pas de consultation r&eacute;f&eacute;renc&eacute;e '$strip_reference'.");
		return;
	} // END if

    // vérifie la date de clôture
    $dayDate = date('Y-m-d H:i:s');
    $is_timeUp = strcmp($consultation['dateFin'], $dayDate)<=0;

?>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>

<head>
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
	<title>consultation <?php echo $strip_reference;?> : ajout de fichier au dossier</title>
	<link rel="stylesheet" type="text/css" href="../include/joli.css">
	<script type="text/javascript" src="../include/popup.inc.js"><!-- //--></script>
	<script type="text/javascript" src="../include/form.inc.js"><!-- //--></script>

</head>

<body id="telecharger">
<h2>Gestion d'une consultation</h2>
<?
 if ($is_timeUp&&!is_interne_publisher($_SESSION['sess_interne_profile']['id'], $_REQUEST['reference'])) {
        echo "Cette consultation est cl&ocirc;tur&eacute;e, il est impossible de
        la modifier.<br />";
        ?>
        <br /><a href="javascript:window.close();">Fermer la fen&ecirc;tre</a>
        <?php
        return;
    } // END if
?>
<form method="POST" enctype="multipart/form-data" action="<?php
	echo preg_replace('/.*\//','',$_SERVER['SCRIPT_FILENAME']);?>">

<?php
/*Script a rajouter dans head au cas ou --  	<script type="text/javascript" src="./include/form.inc.js"><!-- //--></script>  --*/



//Verification des droits de l'interne
if(!has_interne_right_to(INTERNE_DROIT_ECRITURE, $_SESSION['sess_interne_profile']['id'], $_REQUEST['reference']))
{
  echo "Vous n'avez pas les droits n&eacutecessaires pour modifier cette consultation.<br />Vous pouvez consulter votre administrateur afin de r&eacute;gler ce probl&egrave;me.<br />"; 

  return;
}


/*--------------PREPARATION DE LA GESTION DES DROITS DES INTERNES-------------------*/

$internes_query = "SELECT interne_id, droit  FROM ".INTERNE_CONSULTATION." WHERE consultation_ref='".$reference."'";
//echo $internes_query;
$internes_resp = sql_query($internes_query);

/*--------------FIN PREPARATION DE LA GESTION DES DROITS DES INTERNES-------------------*/


$modification_date = false;
$modification_zip = false;

/*------------CAS OU LA DATE DE CLOTURE A ETE MODIFIEE---------------*/
if(isset($_POST['sendfile']) && $_POST['sendfile']==1)
{

  // Etape 1 : mise a jour de la date de cloture
  $dateFin = frnDateTime2iso($_POST['dateFin']);
  if ($dateFin != $consultation['dateFin'])
    {
      $update_dateFin = "UPDATE Consultation SET dateFin='".$dateFin."' WHERE reference='$reference'";
      
      if(!checkDateTime($dateFin))
	{
	  PrintMessage("La date que vous avez saisi est invalide");
	  return;
	}
      
      if (!sql_query($update_dateFin))
	{
	  PrintMessage("Une erreur s'est produite lors de la mise a jour de la date de cloture");
	  return;
	}
      else      // On met a jour la date dans le tableau
	{
	  $consultation['dateFin'] = $dateFin;
	  $modification_date=true;
	}
    }
  // Fin mise a jour de la date de cloture
  
  // Etape 2 : mise a jour du fichier ZIP
  $sess_id=session_id();
  $zip_filename=TMP_DIR."zip-$sess_id.zip";
  
  // recupérer le fichier à ajouter 
  // 	if(count($_FILES)==0 || strlen($_FILES['fichier']['tmp_name'])==0) {
  // 		PrintError("Le fichier à ajouter au dossier de consultation est manquant.");
  // 		affiche_addfile_form();
  // 		return;
  // 	} // END if
  
  
  
  // recupérer, écrire et vérifier  le zip /////////////////////////////////////
  if (count($_FILES) > 0 && strlen($_FILES['fichier']['tmp_name']) > 0)
  {
    $query="SELECT `fichierDossier`\nFROM `Consultation`\nWHERE `reference`='$reference'\n;";
    $response=sql_query($query);
    $zip=mysql_fetch_array($response,MYSQL_NUM);
    mysql_free_result($response);
    $zip=$zip[0];
    // écrire le fichier zip
    if(!write_file($zip_filename,$zip))
      {
	PrintError("Une erreur s'est produite lors de la récupération du dossier de consultation.");
	return;
      }
    // tester l'intégrité du fichier zip
    // -T revient au zip precedent en cas d'echec
    // -D ne considere pas 
    $sys_answer=shell_exec("zip -T $zip_filename");
    if(strlen($sys_answer)==0)
      {
	PrintError("Le dossier de consultation ".$zip_filename." est corrompu.");
	return;
      } // END if
    
	// renomme le fichier et l'ajouter au fichier zip 
    $newfile_filename=TMP_DIR.getNewName_fileInArray($_FILES['fichier']['name'],getZipFileList($zip_filename));
    $exe = "mv -f ".$_FILES['fichier']['tmp_name']." ".escapeshellarg($newfile_filename)." ;";
    $sys_answer=shell_exec($exe);
    if(strlen($sys_answer)!=0)
      {
	PrintError("Erreur lors de l'ajout du fichier dans le dossier de consultation (sans doute une partition pleine).");
	return;
      }
    // ajout du fichier dans le zip
    // -D n'ajoute pas les chemins du fichier ajoute
    $cmd= "zip -m -j ".escapeshellarg($zip_filename)." ".escapeshellarg($newfile_filename)." 2>".TMP_DIR."zip.log";
    system("$cmd &> ".TMP_DIR."zip.log", $sys_answer);

    if($sys_answer != 0)
       {
 	PrintError("Erreur lors de l'ajout du fichier dans le dossier de consultation.");
 	return;
       }
    
    // écriture en base de données du fichier zip ////////////////////////////////
    $fp=fopen($zip_filename,'r');
    $zip=fread($fp, filesize($zip_filename));
    fclose($fp);
    $zip = addslashes($zip);
    $query="UPDATE LOW_PRIORITY `Consultation`\nSET `fichierDossier`='$zip'\nWHERE `reference`='$reference'\n;";
    if (!sql_query($query))
      {
	PrintError("Une erreur s'est produite lors de la modification du dossier de consultation");
	return;
      }
    $modification_zip = true;
    @unlink($zip_filename);
  }    
  
  // mail automatique de notification //////////////////////////////////////////
  if ($modification_zip || $modification_date )
    {
      $from=$_SESSION['sess_interne_profile']['email'];
      
      $subject=MAIL_SUBJECT_PREFIX." Modification de la consultation $strip_reference";
      $body="Madame, Monsieur,\n\n";
      if ($modification_zip)
	{

	  $body="Le dossier de la consultation $strip_reference a t modifi.\n\nNous vous invitons a venir tlcharger le dossier  l'adresse suivante: ".URL_SITE_EXTERNE;
	}
      if ($modification_date)
	{
	  if ($modification_zip)
	    $body .= "\n\n";
	  $body .= "La date de clture de la consultation $strip_reference est modifie au ".iso2frnDateTime($dateFin);
	}
      $body .= "\n\nVeuillez vous rendre sur le site de la plate-forme ".URL_SITE_EXTERNE." pour plus de dtails concernant cette consultation.".MAIL_SIG;
      // les gens qui ont DL
      $gensQuery="SELECT DISTINCT email FROM Telechargement WHERE reference='$reference'\n;";
      $bcc='';
      $gensResponse=sql_query($gensQuery);
      while($Gens=mysql_fetch_array($gensResponse,MYSQL_NUM))
	{
	  $bcc.=', '.$Gens[0];
	} // END while
      mysql_free_result($gensResponse);
      $bcc=substr($bcc,1);
      /*   $headers = "FROM: ".MAIL_FROM_ADDR."\n";
      $headers .= "SUBJECT: ".stripslashes($subject)."\n";
      $headers .= "BCC: ".$bcc;*/
$header = "Return-Path: ".MAIL_FROM_ADDR."\r\nFrom: ".MAIL_FROM_ADDR."\r\nTo: ".MAIL_FROM_ADDR."\r\nBcc: $bcc\r\nSubject: $subject\r\n";      
$send_mail = send_signed_mail_with_headers($from,stripslashes($subject),stripslashes($body), $header);//,'',"",$bcc);
      if($send_mail!=0)
	{
	  PrintError("Erreur lors de l'envoi du mail");
	  return;
	} // END if
	  ?>
	  <p>Un mail de notification a &eacute;t&eacute; envoy&eacute; (en copie cach&eacute;e) aux personnes ayant 
	     t&eacute;l&eacute;charg&eacute; le dossier de consultation.</p><br/>
	     <?php
		
      unset($_POST['sendfile']);
      if(!$_POST['modif_rights'])
	{
	  echo "<a href=\"javascript:window.close();\">Fermer la fen&ecirc;tre</a>";
	  exit();
	}

    }
}
/*------------FIN CAS OU LA DATE DE CLOTURE A ETE MODIFIEE---------------*/

/*------------CAS OU LES DROITS DES UTILISATEURS ONT ETE MODIFIES---------------*/
if(isset($_POST['modif_rights'])&&$_POST['modif_rights']==1)
{
  $main_interne = "interne".$_SESSION['sess_interne_profile']['id'];  
// Transaction ajout de Consultation et Interne_Consultation
  // Recuperation des internes et leurs habilitations
  $insert_cons = "DELETE FROM ".INTERNE_CONSULTATION." WHERE Consultation_ref='".$reference."'";

  $insert_cons_internes = array();
  $insert_cons_internes[0] = $insert_cons;

  $xkeys=array_keys($_POST);
  $indexInternes = 1;
  foreach($xkeys as $xkey)
    {
      if(preg_match('/droit_interne/',$xkey))
        {
           $insert_interne_cons = "INSERT INTO ".INTERNE_CONSULTATION." (interne_id,consultation_ref,droit) VALUES(";
	   $interneId=preg_replace('/droit_interne/','',$xkey);
           $insert_interne_cons .= "'$interneId' , '".addslashes($_REQUEST['reference'])."', '".$_POST[$xkey]."')";
           $insert_cons_internes[$indexInternes] = $insert_interne_cons;
           $indexInternes ++;
        }
     } // END foreach
  //print_request_vars ($insert_cons_internes);
  $res = sql_transaction_query($insert_cons_internes);
  if(!$res)
    {
      PrintMessage("Erreur lors de la modification des droits utilisateurs: Aucune modification effectuee");
      for($p=0; $p<5; $p++)
	{
	  echo $insert_cons_internes[$p];
	}
      return;
    }
  unset($_POST['modif_rights']);
      ?>Les modifications ont &eacute;t&eacute; &eacute;xecut&eacute;es avec succ&egrave;s<br /><br /><a href="javascript:window.close();">Fermer la fen&ecirc;tre</a><?
      exit();
}
/*------------FIN CAS OU LES DROITS DES UTILISATEURS ONT ETE MODIFIES---------------*/

if(!$is_timeUp)
{
?>
Si vous modifiez les dates ou le dossier de cette consultation, les personnes ayant t&eacute;l&eacute;charg&eacute; le dossier de 
cette consultation seront avertis par email (en copie cach&eacute;e)<br/><br />

<fieldset><legend><b>Modification d'une consultation</b></legend>
	<table>
	<tr><td>Titre :</td><td><?php echo stripslashes($consultation['titre']);?></td>
	<tr><td>R&eacute;f. :</td><td><?php echo $strip_reference;?></td>
	<tr><td>Date d'envoi au J.O. :</td><td><?php echo iso2frnDate($consultation['dateDebut']);?></td>
	<tr><td>Date et heure de cl&ocirc;ture :<br><small><em>(JJ/MM/AAAA hh:mm)</em></small></td><td><input type="text" name="dateFin" value="<?php echo iso2frnDateTime($consultation['dateFin']);?>"></td>
	</table>
	<input type="hidden" name="sendfile" value="1" />

	   <br />
	<label>Fichier &agrave; ajouter au dossier</label>
	<input type="file" size="40" name="fichier" />
</fieldset>
<?
}
?>
<br />

<?
if(is_interne_publisher($_SESSION['sess_interne_profile']['id'], $_REQUEST['reference']))
{
?>
   Vous pouvez modifier les droits des utilisateurs internes ayant acc&egrave;s &agrave; cette consultation en cliquant sur le lien "Ajouter un gestionnaire"<br /><br />
<br />
	<?show_interne_rights ($reference)/*show_interne_rights()*/;?>
	<input type="hidden" name="modif_rights" value="1" />
<br />
<?
}
?>
<input type="submit" value="Valider" name="Valider" />
<input type="hidden" name="reference" value="<?php echo $strip_reference;?>" />
</form>
<br /><a href="javascript:window.close();">Fermer la fen&ecirc;tre</a>
</body>
</html>
