# Copyright (C) 2004 ATEXO Local Trust MPE
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# 
# For more information on our product, please contact MPE@atexo.com
# phpMyAdmin SQL Dump
# version 2.5.3
# http://www.phpmyadmin.net
#
# Version du serveur: 4.0.15
# Version de PHP: 4.3.3
# 
# Base de donnes: `MarchesPublics`
# 

# --------------------------------------------------------

#
# Structure de la table `Administrateur`
#

CREATE TABLE Administrateur (
  id tinyint(2) NOT NULL auto_increment,
  login varchar(20) NOT NULL default '',
  mdp varchar(16) NOT NULL default '',
  nom varchar(30) NOT NULL default '',
  prenom varchar(30) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  tentatives_mdp int(1) NOT NULL default '0',
  KEY id (id)
) TYPE=InnoDB COMMENT='contient le(s) administrateur(s) (qui valident les consultations)';

# --------------------------------------------------------

#
# Structure de la table `CategorieConsultation`
#

CREATE TABLE CategorieConsultation (
  categorie varchar(60) NOT NULL default ''
) TYPE=InnoDB;

# --------------------------------------------------------

#
# Structure de la table `Consultation`
#

CREATE TABLE Consultation (
  nbr_enveloppes int(1) NOT NULL default '0',
  nomMinistere varchar(100) default NULL,
  reference varchar(20) NOT NULL default '',
  categorie varchar(60) NOT NULL default '',
  titre varchar(160) NOT NULL default '',
  resume varchar(255) NOT NULL default '',
  dateDebut date NOT NULL default '0000-00-00',
  dateFin datetime NOT NULL default '0000-00-00 00:00:00',
  dateValidation datetime default NULL,
  nomFichierDossier varchar(100) NOT NULL default '',
  fichierDossier longblob NOT NULL,
  etat int(1) NOT NULL default '0',
  certificat_env_1 mediumtext,
  certificat_env_2 mediumtext,
  nom_complement_1 varchar(100) default NULL,
  nom_complement_2 varchar(100) default NULL,
  nom_complement_3 varchar(100) default NULL,
  nom_complement_4 varchar(100) default NULL,
  nom_complement_5 varchar(100) default NULL,
  type_procedure enum('1','2') NOT NULL default '1',
  code_procedure varchar(8) default NULL,
  PRIMARY KEY  (reference)
) TYPE=InnoDB;

# --------------------------------------------------------

#
# Structure de la table `Entreprise`
#

CREATE TABLE Entreprise (
  id int(11) NOT NULL auto_increment,
  admin_id int(11) NOT NULL default '0',
  siren varchar(9) NOT NULL default '',
  repMetiers char(1) NOT NULL default '',
  nom varchar(30) NOT NULL default '',
  adresse varchar(80) NOT NULL default '',
  codePostal varchar(5) NOT NULL default '',
  villeAdresse varchar(50) NOT NULL default '',
  paysAdresse varchar(50) NOT NULL default '',
  email varchar(20) default NULL,
  formeJuridique varchar(6) NOT NULL default '',
  villeEnregistrement varchar(50) default NULL,
  motifNonIndNum int(11) default NULL,
  ordreProfOuAgrement varchar(30) default NULL,
  dateConstSociete date default NULL,
  nomOrgInscription varchar(30) default NULL,
  adrOrgInscription varchar(80) default NULL,
  dateConstAssoc date default NULL,
  dateConstAssocEtrangere date default NULL,
  nomPersonnePublique varchar(30) default NULL,
  nationalite char(2) default NULL,
  redressement int(11) default NULL,
  paysEnregistrement varchar(50) default NULL,
  sirenEtranger varchar(20) default NULL,
  numAssoEtrangere varchar(20) default NULL,
  debutExerciceGlob1 varchar(15) default NULL,
  finExerciceGlob1 varchar(15) default NULL,
  debutExerciceGlob2 varchar(15) default NULL,
  finExerciceGlob2 varchar(15) default NULL,
  debutExerciceGlob3 varchar(15) default NULL,
  finExerciceGlob3 varchar(15) default NULL,
  ventesGlob1 varchar(10) default NULL,
  ventesGlob2 varchar(10) default NULL,
  ventesGlob3 varchar(10) default NULL,
  biensGlob1 varchar(10) default NULL,
  biensGlob2 varchar(10) default NULL,
  biensGlob3 varchar(10) default NULL,
  servicesGlob1 varchar(10) default NULL,
  servicesGlob2 varchar(10) default NULL,
  servicesGlob3 varchar(10) default NULL,
  totalGlob1 varchar(10) default NULL,
  totalGlob2 varchar(10) default NULL,
  totalGlob3 varchar(10) default NULL,
  PRIMARY KEY  (id)
) TYPE=InnoDB;

# --------------------------------------------------------

#
# Structure de la table `FormeJuridique`
#

CREATE TABLE FormeJuridique (
  formeJuridique varchar(8) NOT NULL default ''
) TYPE=InnoDB;

# --------------------------------------------------------

#
# Structure de la table `Inscrit`
#

CREATE TABLE Inscrit (
  id int(11) NOT NULL auto_increment,
  entreprise_id int(11) NOT NULL default '0',
  login varchar(20) default NULL,
  mdp varchar(16) default NULL,
  num_cert varchar(64) default NULL,
  cert mediumtext,
  civilite tinyint(1) NOT NULL default '0',
  nom varchar(30) NOT NULL default '',
  prenom varchar(30) NOT NULL default '',
  adresse varchar(80) NOT NULL default '',
  codePostal varchar(5) NOT NULL default '',
  ville varchar(50) NOT NULL default '',
  pays varchar(50) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  telephone varchar(20) NOT NULL default '',
  categorie varchar(100) default NULL,
  motsTitre mediumtext,
  motsResume mediumtext,
  periode tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id,entreprise_id),
  KEY entreprise_id (entreprise_id),
  CONSTRAINT `0_146` FOREIGN KEY (`entreprise_id`) REFERENCES `Entreprise` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) TYPE=InnoDB;

# --------------------------------------------------------

#
# Structure de la table `Interne`
#

CREATE TABLE Interne (
  id int(11) NOT NULL auto_increment,
  login varchar(20) NOT NULL default '',
  mdp varchar(16) NOT NULL default '',
  nom varchar(30) NOT NULL default '',
  prenom varchar(30) NOT NULL default '',
  email varchar(50) NOT NULL default '',
  tentatives_mdp int(11) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY id (id)
) TYPE=InnoDB COMMENT='contient les utilisateurs internes (qui crent les consultat';

# --------------------------------------------------------

#
# Structure de la table `Interne_Consultation`
#

CREATE TABLE Interne_Consultation (
  id int(11) NOT NULL auto_increment,
  interne_id int(11) NOT NULL default '0',
  consultation_ref varchar(20) NOT NULL default '0',
  droit enum('1','2','3') NOT NULL default '1',
  PRIMARY KEY  (id),
  KEY interne_id (interne_id),
  KEY consultation_ref (consultation_ref),
  CONSTRAINT `0_149` FOREIGN KEY (`interne_id`) REFERENCES `Interne` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `0_150` FOREIGN KEY (`consultation_ref`) REFERENCES `Consultation` (`reference`) ON DELETE CASCADE ON UPDATE CASCADE
) TYPE=InnoDB COMMENT='Table des habilitations d''un interne par consultation';

# --------------------------------------------------------

#
# Structure de la table `Offre`
#

CREATE TABLE Offre (
  id int(11) NOT NULL auto_increment,
  consultation_id varchar(20) NOT NULL default '',
  entreprise_id int(11) NOT NULL default '0',
  inscrit_id int(11) NOT NULL default '0',
  commentaire mediumtext,
  cryptage_xml enum('0','1') NOT NULL default '1',
  signatureXML mediumtext,
  signatureEnvXML mediumtext,
  cryptage_env_1 enum('0','1') NOT NULL default '1',
  enveloppe_1 longblob NOT NULL,
  nom_fichier_1 text,
  cryptage_env_2 enum('0','1') NOT NULL default '1',
  enveloppe_2 longblob,
  nom_fichier_2 text,
  horodatage mediumblob,
  mailSignataire varchar(50) NOT NULL default '',
  untrustedDate varchar(20) default NULL,
  untrustedSerial varchar(20) default NULL,
  supprime enum('0','1','2') NOT NULL default '0',
  PRIMARY KEY  (id,consultation_id,entreprise_id),
  KEY entreprise_id (entreprise_id),
  KEY consultation_id (consultation_id),
  KEY inscrit_id (inscrit_id),
  CONSTRAINT `0_152` FOREIGN KEY (`entreprise_id`) REFERENCES `Entreprise` (`id`) ON DELETE NO ACTION ON UPDATE CASCADE,
  CONSTRAINT `0_153` FOREIGN KEY (`consultation_id`) REFERENCES `Consultation` (`reference`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `0_154` FOREIGN KEY (`inscrit_id`) REFERENCES `Inscrit` (`id`) ON DELETE NO ACTION ON UPDATE CASCADE
) TYPE=InnoDB;

# --------------------------------------------------------

#
# Structure de la table `ResponsableEngagement`
#

CREATE TABLE ResponsableEngagement (
  id int(11) NOT NULL auto_increment,
  entreprise_id int(11) NOT NULL default '0',
  nom varchar(30) default NULL,
  prenom varchar(30) default NULL,
  qualite varchar(32) default NULL,
  PRIMARY KEY  (id,entreprise_id),
  KEY entreprise_id (entreprise_id),
  CONSTRAINT `0_156` FOREIGN KEY (`entreprise_id`) REFERENCES `Entreprise` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) TYPE=InnoDB;

# --------------------------------------------------------

#
# Structure de la table `Telechargement`
#

CREATE TABLE Telechargement (
  id int(11) NOT NULL auto_increment,
  reference varchar(20) NOT NULL default '',
  nom varchar(30) NOT NULL default '',
  adresse varchar(80) NOT NULL default '',
  email varchar(64) NOT NULL default '',
  PRIMARY KEY  (id,reference),
  KEY reference (reference),
  CONSTRAINT `0_158` FOREIGN KEY (`reference`) REFERENCES `Consultation` (`reference`) ON DELETE CASCADE ON UPDATE CASCADE
) TYPE=InnoDB;
