/*
Copyright (C) 2004 ATEXO Local Trust MPE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

For more information on our product, please contact MPE@atexo.com
*/
<?
require_once('format.inc.php');
require_once('mysql.inc.php');
require_once('misc.inc.php');

function update_co_insc()
{
  require('sqlRights.inc.php');
  //  print_request_vars($_POST);
  $update_form_vars = array();
  
  // Pour la rcupration en cas POST
  $co_profile = $_SESSION["sess_subs_company"];
  $co_managers = $_SESSION["sess_company_managers"];
  
  
  if (!$_POST["nom"] || !$_POST["adresse"] || !$_POST["codePostal"] || !$_POST["villeAdresse"] || !$_POST["paysAdresse"]
      || !$_POST["enFrance"] || !$_POST["formeJuridique"])
    {
      PrintError("Formulaire incomplet (nom, adresse, email, ayantDroit, pays d'implantation, formeJuridique)");
      print_co_update_form($co_profile, $co_managers);
      return;
    }
  $update_form_vars["nom"] = $_POST["nom"];
  $update_form_vars["adresse"] = $_POST["adresse"];
  $update_form_vars["codePostal"] = $_POST["codePostal"];
  $update_form_vars["villeAdresse"] = $_POST["villeAdresse"];
  $update_form_vars["paysAdresse"] = $_POST["paysAdresse"];
  $update_form_vars["formeJuridique"] = $_POST["formeJuridique"];
  
  if ($_POST["enFrance"] == "1")
    {
      if (!$_POST["rcs"])
	{
	  PrintError("Formulaire incomplet; RCS pour candidat tabli en France");
	  print_co_update_form($co_profile, $co_managers);
	  return;
	}
      //      ereg("([a-zA-Z -]+) *([A|B]) *([0-9]{9})", $_POST["rcs"], $regs);
      $regs = parse_rcs ($_POST['rcs']);
      
      $update_form_vars["paysEnregistrement"] = "FR";
      
      if (!$regs[1] || !$regs[2] || !$regs[3])
	{
	  PrintError("Format invalide du RCS; saisir: Ville + A ou B + numro de SIREN  9 chiffres ");
	  print_co_update_form($co_profile, $co_managers);
	  return; 
	}
      $update_form_vars["villeEnregistrement"] = $regs[1];
      $update_form_vars["repMetiers"] = $regs[2];
      $update_form_vars["siren"] = $regs[3];
      
    }
  
  else if ($_POST["enFrance"] == "2")
    {
      if(!$_POST["villeEnregistrement2"] || !$_POST["paysEnregistrement1"])
	{
	  PrintError("Formulaire incomplet; elements manquants pour candidat non établi en France");
	  print_co_update_form($co_profile, $co_managers);
	  return;
	}
      $update_form_vars["paysEnregistrement"] = $_POST["paysEnregistrement1"];
      $update_form_vars["villeEnregistrement"] = $_POST["villeEnregistrement2"];
      
      if ($_POST["sirenEtranger"])
	$update_form_vars["sirenEtranger"] = $_POST["sirenEtranger"];
    }
  
  $update_form_vars["debutExerciceGlob1"] = $_POST["debutExerciceGlob1"];
  $update_form_vars["finExerciceGlob1"] = $_POST["finExerciceGlob1"];
  $update_form_vars["debutExerciceGlob2"] = $_POST["debutExerciceGlob2"];
  $update_form_vars["finExerciceGlob2"] = $_POST["finExerciceGlob2"];
  $update_form_vars["debutExerciceGlob3"] = $_POST["debutExerciceGlob3"];
  $update_form_vars["finExerciceGlob3"] = $_POST["finExerciceGlob3"];
  $update_form_vars["ventesGlob1"] = $_POST["ventesGlob1"];
  $update_form_vars["ventesGlob2"] = $_POST["ventesGlob2"];
  $update_form_vars["ventesGlob3"] = $_POST["ventesGlob3"];
  $update_form_vars["biensGlob1"] = $_POST["biensGlob1"];
  $update_form_vars["biensGlob2"] = $_POST["biensGlob2"];
  $update_form_vars["biensGlob3"] = $_POST["biensGlob3"];
  $update_form_vars["servicesGlob1"] = $_POST["servicesGlob1"];
  $update_form_vars["servicesGlob2"] = $_POST["servicesGlob2"];
  $update_form_vars["servicesGlob3"] = $_POST["servicesGlob3"];
  $update_form_vars["totalGlob1"] = $_POST["totalGlob1"];
  $update_form_vars["totalGlob2"] = $_POST["totalGlob2"];
  $update_form_vars["totalGlob3"] = $_POST["totalGlob3"];

  if (!$_POST["nomManager1"] || !$_POST["prenomManager1"] || !$_POST["qualiteManager1"])
    {
      PrintError("Formulaire incomplet; Personne ayant le droit d'engager la société");
      print_co_update_form($co_profile, $co_managers);
      return;
    }
  
  for ($i = 1;
       ($_POST["nomManager".$i] != "") && ($_POST["prenomManager".$i] != "") && ($_POST["qualiteManager".$i] != "");
       $i++)
    {
      $managers[$i]["nomManager".$i] = $_POST["nomManager".$i];
      $managers[$i]["prenomManager".$i] = $_POST["prenomManager".$i];
      $managers[$i]["qualiteManager".$i] = $_POST["qualiteManager".$i];
    }
  
  $columns = "";
  $values = "";
  $update_company = "UPDATE Entreprise SET ";
  $len = count($update_form_vars);
  $i = 1;
  foreach ($update_form_vars as $key => $value)
    {
      $update_company .= $key . "=";
      if (strcmp($key, "mdp") == 0)
	$update_company .= " PASSWORD('" . $value . "') ";
      else
	$update_company .= "'" . $value . "' ";
      if ($i < $len)
	{
	  $update_company .= ", ";
	}
      $i ++;
    }
  
  $update_company .= " WHERE id = " . $co_profile["id"];
  //echo $update_company . "<br>";
  $result = sql_query($update_company);
  
  $delete_managers = "DELETE FROM ResponsableEngagement WHERE entreprise_id = " . $co_profile["id"];
  //echo $delete_managers . "<br>";
  $result = sql_query($delete_managers);
  for($i = 1; $i <= count($managers); $i++)
    {
      $insert_new_managers = "INSERT INTO ResponsableEngagement(entreprise_id, nom, prenom, qualite) VALUES('" . $co_profile["id"] . "'";
      foreach ($managers[$i] as $key => $value)
	{
	  $insert_new_managers .=  ", '" . $value . "'";
	}
      $insert_new_managers .= ")";
      //echo $insert_new_managers . "<br>";
      $result= sql_query($insert_new_managers);
    }
  if ($result)
    {
      $_SESSION['sess_subs_company'] = get_row_by_field('Entreprise', 'id', $co_profile['id']);
      $_SESSION['sess_company_managers'] = company_managers($_SESSION['sess_subs_company']);
      
	?>
	<input type="hidden" name="cfm_msg" value="">
	   <script Language="JavaScript">
	   confirmAction ('update_co_insc');
      </script>

	  <?
	  }
  else
    {
      PrintError ("Une erreur s'est produite lors de cette opration");
    }
}
